SystemOrganization addCategory: #'ShoreComponents-Kernel'!
SystemOrganization addCategory: #'ShoreComponents-Support'!
SystemOrganization addCategory: #'ShoreComponents-Dialogs'!
SystemOrganization addCategory: #'ShoreComponents-Hierarchy'!
SystemOrganization addCategory: #'ShoreComponents-Lists'!
SystemOrganization addCategory: #'ShoreComponents-Panels'!
SystemOrganization addCategory: #'ShoreComponents-Useful'!
SystemOrganization addCategory: #'ShoreComponents-Editors'!
SystemOrganization addCategory: #'ShoreComponents-Webtree'!
SystemOrganization addCategory: #'ShoreComponents-Widgets'!
SystemOrganization addCategory: #'ShoreComponents-Tables'!
SystemOrganization addCategory: #'ShoreComponents-Libraries'!
SystemOrganization addCategory: #'ShoreComponents-Demo1'!
SystemOrganization addCategory: #'ShoreComponents-Demo2'!
SystemOrganization addCategory: #'ShoreComponents-Demo3'!
SystemOrganization addCategory: #'ShoreComponents-Demo4'!

Form subclass: #ShoreForm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Support'!

!ShoreForm class methodsFor: 'instance creation' stamp: 'tbn 7/11/2005 21:36'!
from: aForm
	"Creates and answers a new form with the given form as a template"

	| new |
	new := self extent: aForm extent depth: aForm depth bits: aForm bits.
	^ new! !

!ShoreForm methodsFor: 'conversion' stamp: 'pk 12/14/2005 14:13'!
asMIMEDocument 
	"Returns the receiver converted to a MIME document"

	| aStream |
	aStream := RWBinaryOrTextStream on: ''.
	PNGReadWriter putForm: self onStream: aStream.
	^MIMEDocument contentType: self mimeType content: aStream contents! !

!ShoreForm methodsFor: 'conversion' stamp: 'pk 12/14/2005 14:12'!
mimeType

	^ 'image/png' ! !

Form subclass: #ShoreJpegForm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Support'!

!ShoreJpegForm class methodsFor: 'instance creation' stamp: 'tbn 7/11/2005 21:36'!
from: aForm
	"Creates and answers a new form with the given form as a template"

	| new |
	new := self extent: aForm extent depth: aForm depth bits: aForm bits.
	^ new
	! !

!ShoreJpegForm methodsFor: 'conversion' stamp: 'pk 12/14/2005 14:13'!
asMIMEDocument 
	| aStream writer |
	aStream := RWBinaryOrTextStream on: ''.
	writer := JPEGReadWriter2 on: aStream.
	writer nextPutImage: self quality: 100 progressiveJPEG: false.
	^MIMEDocument contentType: self mimeType content: aStream contents! !

!ShoreJpegForm methodsFor: 'conversion' stamp: 'pk 12/14/2005 14:13'!
mimeType

	^ 'image/jpg' ! !

WADivTag subclass: #ShoreNestedFormTag
	instanceVariableNames: 'parentForm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Kernel'!

!ShoreNestedFormTag methodsFor: 'as yet unclassified' stamp: 'pk 1/3/2006 19:33'!
after
"	canvas context actionUrl parameters keysAndValuesDo:
		[:k :v |
		canvas hiddenInput name: k; value: v.
		canvas text: ' ']"! !

!ShoreNestedFormTag methodsFor: 'accessing' stamp: 'pk 12/11/2005 16:49'!
attributes

	^ self parentForm attributes! !

!ShoreNestedFormTag methodsFor: 'accessing' stamp: 'pk 1/3/2006 19:21'!
name: aString
	self parentForm attributeAt: 'name' put: aString! !

!ShoreNestedFormTag methodsFor: 'accessing' stamp: 'pk 12/11/2005 15:40'!
parentForm
	"Answer the value of parentForm"

	^ parentForm! !

!ShoreNestedFormTag methodsFor: 'accessing' stamp: 'pk 12/11/2005 15:40'!
parentForm: anObject
	"Set the value of parentForm"

	parentForm := anObject! !

!ShoreNestedFormTag methodsFor: 'as yet unclassified' stamp: 'pk 12/11/2005 15:46'!
tag
	^ 'div'! !

WAComponent subclass: #ShoreComponent
	instanceVariableNames: 'parent attributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Kernel'!

ShoreComponent class
	instanceVariableNames: 'id'!

!ShoreComponent commentStamp: 'tbn 7/11/2005 21:10' prior: 0!
This is a common superclass for Shore components. A shore component may refer
to it's parent and can contain attributes. !

ShoreComponent subclass: #ShoreBatchedList
	instanceVariableNames: 'title page pageSize data itemBlock noteBlock sorters activeSorter filterText showItemBlock id idLeft1 idLeft2 idRight1 idRight2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Lists'!

!ShoreBatchedList methodsFor: 'accessing' stamp: 'pk 7/1/2005 19:12'!
activeSorter
	^activeSorter! !

!ShoreBatchedList methodsFor: 'accessing' stamp: 'pk 7/1/2005 19:33'!
activeSorter: sorterName

	activeSorter := sorterName.
	self data: self data.! !

!ShoreBatchedList methodsFor: 'sorting' stamp: 'pk 7/2/2005 19:44'!
addSorter: name block: sortBlock

	sorters add: (name -> sortBlock).
! !

!ShoreBatchedList methodsFor: 'accessing' stamp: 'pk 6/29/2005 22:57'!
data
	^data! !

!ShoreBatchedList methodsFor: 'accessing' stamp: 'pk 5/17/2006 20:40'!
data: anObject

	activeSorter ifNil: [ 
		data := anObject.
		^ self ].

	data := (anObject asSortedCollection: activeSorter value) asOrderedCollection

	! !

!ShoreBatchedList methodsFor: 'accessing' stamp: 'jlr 7/7/2005 20:15'!
filteredData
	"This needs to be more generic, since we do not always batch on classes"

	(filterText isEmptyOrNil or: [self showItemBlock isNil]) 
		ifTrue: [^data]
		ifFalse: [^data select: [:e | self showItemBlock value: e value: filterText]]! !

!ShoreBatchedList methodsFor: 'initialization' stamp: 'pk 5/17/2006 14:44'!
initialize 

	super initialize. 

	self registerForBackgracking.

	page := 1.
	pageSize := 15.
	title := 'List' translated.
	sorters := OrderedCollection  new.
	activeSorter := nil.

	id := ShoreComponent newId.
	idLeft1 := ShoreComponent newId.
	idRight1 := ShoreComponent newId.
	idLeft2 := ShoreComponent newId.
	idRight2 := ShoreComponent newId.
! !

!ShoreBatchedList methodsFor: 'accessing' stamp: 'pk 6/29/2005 22:58'!
itemBlock
	^itemBlock! !

!ShoreBatchedList methodsFor: 'accessing' stamp: 'pk 6/29/2005 22:58'!
itemBlock: anObject
	itemBlock := anObject! !

!ShoreBatchedList methodsFor: 'accessing' stamp: 'pk 7/2/2005 19:34'!
noteBlock
	^noteBlock! !

!ShoreBatchedList methodsFor: 'accessing' stamp: 'pk 7/2/2005 19:34'!
noteBlock: anObject
	noteBlock := anObject! !

!ShoreBatchedList methodsFor: 'accessing' stamp: 'pk 6/29/2005 22:57'!
page
	^page! !

!ShoreBatchedList methodsFor: 'accessing' stamp: 'pk 6/29/2005 22:57'!
pageSize
	^pageSize! !

!ShoreBatchedList methodsFor: 'accessing' stamp: 'pk 6/29/2005 22:57'!
pageSize: anObject
	pageSize := anObject! !

!ShoreBatchedList methodsFor: 'accessing' stamp: 'pk 6/29/2005 22:57'!
page: anObject
	page := anObject! !

!ShoreBatchedList methodsFor: 'initialization' stamp: 'pk 5/16/2006 16:32'!
registerForBackgracking

	self session registerObjectForBacktracking: self. ! !

!ShoreBatchedList methodsFor: 'rendering' stamp: 'pk 6/29/2006 11:20'!
renderComponentOn: html 

	| pageData pagesCount |	

	pageData := self filteredData.
	pagesCount := (pageData size - 1) // pageSize + 1.
	pageData := pageData copyFrom: ((page - 1) * pageSize + 1 max: 1)
				to: (page * pageSize min: pageData size).
	self renderHeaderOn: html.
	self renderPageData: pageData on: html.

	self renderScriptsOn: html page: page pagesCount: pagesCount.

	html div class: #shoreComponentList; class: #shoreBatchedListPages; with: [
		self renderPagesOn: html pagesCount: pagesCount.].

	
! !

!ShoreBatchedList methodsFor: 'rendering' stamp: 'pk 6/29/2006 11:54'!
renderContentOn: html 

	html div class: #shoreComponent; class: #shoreBatchedList; with: [
		 html div id: id; with: [
			self renderComponentOn: html ]. 
			html form class: #shoreComponentImportantPart; class: #shoreBatchedListNavigation; with: [
				self renderFiltersOn: html. 
				self renderNavigationOn: html.].
		
	].
! !

!ShoreBatchedList methodsFor: 'rendering' stamp: 'pk 5/16/2006 14:17'!
renderFiltersOn: html 

	showItemBlock ifNotNil: 
		[ 
			html textInput callback: [:v |
				page := 1. 
				filterText := v.
					(filterText beginsWith: '*') 
						ifFalse: [filterText size > 1 ifTrue: [filterText := '*' , filterText]].
					(filterText endsWith: '*') 
						ifFalse: [filterText size > 1 ifTrue: [filterText := filterText , '*']]].
			html space.
			html submitButton text: 'Filter On']! !

!ShoreBatchedList methodsFor: 'rendering' stamp: 'pk 6/29/2006 11:17'!
renderHeaderOn: html 

	html div  class: #shoreComponentImportantPart; class: #shoreBatchedListNavigation; with: [
		self renderSortersOn: html.
		html text: title].
	! !

!ShoreBatchedList methodsFor: 'rendering' stamp: 'pk 6/29/2006 11:29'!
renderNavigationOn: html 

	| pagesCount |

	pagesCount := (self filteredData size - 1) // pageSize + 1.

	html space.
	page <= 1 
		ifFalse: 	[
			html span class: #shoreComponentButton; class: #shoreLiveBatchdeListButton;
				onClickAction: [page := page - 1];
				with: '<']
		ifTrue: 	[
			html span class: #shoreComponentButtonDisabled; class: #shoreLiveBatchdeListButtonDisabled;
				with: '<'].
	page >= pagesCount 
		ifFalse: 	[
			html span class: #shoreComponentButton; class: #shoreLiveBatchdeListButton;
				onClickAction: [page := page + 1];
				with: '>']
		ifTrue: 	[
			html span  class: #shoreComponentButtonDisabled; class: #shoreLiveBatchdeListButtonDisabled;
				with: '>'].

! !

!ShoreBatchedList methodsFor: 'rendering' stamp: 'pk 6/29/2006 11:42'!
renderPageData: pageData on: html 

	noteBlock ifNil: [
		pageData do: [:item | 
			html div: [
				html div class: #shoreBatchedListItem; with: [
					itemBlock 
						ifNil: [html text: item displayString]
						ifNotNil: [itemBlock value: item value: html]]]]]
	ifNotNil: [
		html table layout; class: #shoreBatchedListTable; with: [
			pageData do: [:item | 
				html tableRow with: [
					html tableData class: #shoreBatchedListItem; with: [
						itemBlock 
							ifNil: [html text: item displayString]
							ifNotNil: [itemBlock value: item value: html]].
					html tableData class: #shoreComponenNote; class: #shoreBatchedListItemNote; with: [
						noteBlock value: item value: html]]


]]]

! !

!ShoreBatchedList methodsFor: 'rendering' stamp: 'pk 4/29/2006 17:13'!
renderPagesOn: html pagesCount: pagesCount

	html text: ('[Page {1} of {2}]' format: (Array with: page with: pagesCount )).! !

!ShoreBatchedList methodsFor: 'rendering' stamp: 'pk 5/16/2006 11:43'!
renderScriptsOn: html page: pageIndex pagesCount: pagesCount


	
! !

!ShoreBatchedList methodsFor: 'rendering' stamp: 'pk 6/14/2006 10:31'!
renderSorterLink: sorter on: html

	html anchor callback: [ self activeSorter: sorter];
		text: sorter key displayString.! !

!ShoreBatchedList methodsFor: 'rendering' stamp: 'pk 5/6/2006 14:06'!
renderSortersOn: html

	| names |

	names := sorters asOrderedCollection.

	names isEmpty ifFalse: [
		html div class: #shoreBatchedListSorters; with: [
			html  text: '(sort by '.
			names allButLast do: [:sorter |
				self renderSorterLink: sorter on: html.
				html text: ', '].
			self renderSorterLink: names last on: html.
			html text: ')'. ] ]! !

!ShoreBatchedList methodsFor: 'accessing' stamp: 'pk 7/1/2005 19:11'!
setSorter: sorterName

	activeSorter := sorterName
! !

!ShoreBatchedList methodsFor: 'accessing' stamp: 'jlr 7/7/2005 20:13'!
showItemBlock
	^ showItemBlock! !

!ShoreBatchedList methodsFor: 'accessing' stamp: 'jlr 7/7/2005 20:13'!
showItemBlock: aBlock
	showItemBlock := aBlock! !

!ShoreBatchedList methodsFor: 'accessing' stamp: 'pk 7/1/2005 19:02'!
sorters
	^sorters! !

!ShoreBatchedList methodsFor: 'accessing' stamp: 'pk 7/1/2005 19:02'!
sorters: anObject
	sorters := anObject! !

!ShoreBatchedList methodsFor: 'accessing' stamp: 'pk 6/29/2005 22:58'!
title
	^title! !

!ShoreBatchedList methodsFor: 'accessing' stamp: 'pk 6/29/2005 22:58'!
title: anObject
	title := anObject! !

ShoreBatchedList subclass: #ShoreLiveBatchedList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Lists'!

!ShoreLiveBatchedList methodsFor: 'as yet unclassified' stamp: 'pk 5/16/2006 16:32'!
registerForBackgracking
! !

!ShoreLiveBatchedList methodsFor: 'as yet unclassified' stamp: 'pk 6/29/2006 11:24'!
renderDecreaseLinkOn: html pagesCount: pagesCount

	| style1 style2 |
	page <= 1 
		ifTrue: 	[
			style1 := #hidden.
			style2 := 'shoreComponentButtonDisabled shoreLiveBatchdeListButtonDisabled' ]
		ifFalse: [ 
			style1 := 'shoreComponentButton shoreLiveBatchdeListButton'.
			style2 := #hidden. ].

	html span id: idLeft1; class: style1;
		onClick: (html updater id: id; 
			evalScripts: true;
			callback: [:h | 
				page := page - 1.
				self renderComponentOn: h]);
			 with: '<'.

	html span id: idLeft2; class: style2; with: '<'! !

!ShoreLiveBatchedList methodsFor: 'as yet unclassified' stamp: 'pk 6/14/2006 09:30'!
renderFiltersOn: html 

	showItemBlock ifNotNil: 
		[ 
			html textInput callback: [:v | 
				page := 1.
				filterText := v.
					(filterText beginsWith: '*') 
						ifFalse: [filterText size > 1 ifTrue: [filterText := '*' , filterText]].
					(filterText endsWith: '*') 
						ifFalse: [filterText size > 1 ifTrue: [filterText := filterText , '*']]].
			html space.
			html submitButton 
				onClick: (html updater
					id: id;
					triggerForm: html formId;
					callback: [ :h | self renderComponentOn: h ]);
				text: 'Filter On']! !

!ShoreLiveBatchedList methodsFor: 'as yet unclassified' stamp: 'pk 6/29/2006 11:24'!
renderIncreaseLinkOn: html pagesCount: pagesCount

	| style1 style2 |
	page >= pagesCount
		ifTrue: 	[
			style1 := #hidden.
			style2 := 'shoreComponentButtonDisabled shoreLiveBatchdeListButtonDisabled'.]
		ifFalse: [ 
			style1 := 'shoreComponentButton shoreLiveBatchdeListButton'.
			style2 := #hidden. ].

	html span id: idRight1;class: style1;
		onClick: (html updater id: id; 
			evalScripts: true;
			callback: [:h | 
				page := page + 1.
				self renderComponentOn: h]);
			 with: '>'.

	html span id: idRight2; class: style2; with: '>'! !

!ShoreLiveBatchedList methodsFor: 'as yet unclassified' stamp: 'pk 5/16/2006 13:48'!
renderNavigationOn: html 

	| pagesCount |

	pagesCount := (self filteredData size - 1) // pageSize + 1.

	html space.
	self renderDecreaseLinkOn: html pagesCount: pagesCount.
	self renderIncreaseLinkOn: html pagesCount: pagesCount.
! !

!ShoreLiveBatchedList methodsFor: 'as yet unclassified' stamp: 'pk 5/16/2006 13:23'!
renderScriptsOn: html page: pageIndex pagesCount: pagesCount

	| script |
	
	script := '
		var button = document.getElementById("{1}");
		if (button) \{ button.className="{2}" \};
		button = document.getElementById("{3}");
		if (button) \{ button.className="{4}" \}; '.

	pageIndex <= 1
		ifTrue: 	[
				html script: (script format: (Array 
					with: idLeft1 with: #hidden 
					with: idLeft2 with: #shoreLiveBatchdeListButtonDisabled )) ]
		ifFalse: 	[
				html script: (script format: (Array 
					with: idLeft2 with: #hidden 
					with: idLeft1 with: #shoreLiveBatchdeListButton )) ].
	
	pageIndex >= pagesCount 
		ifTrue: 	[
				html script: (script format: (Array 
					with: idRight1 with: #hidden 
					with: idRight2 with: #shoreLiveBatchdeListButtonDisabled )) ]
		ifFalse: 	[
				html script: (script format: (Array 
					with: idRight2 with: #hidden 
					with: idRight1 with: #shoreLiveBatchdeListButton )) ].


	
! !

!ShoreLiveBatchedList methodsFor: 'as yet unclassified' stamp: 'pk 6/14/2006 10:35'!
renderSorterLink: sorter on: html

	html anchor onClick: (html updater id: id; 
		callback: [:h | 
			self activeSorter: sorter.
			self renderComponentOn: h]);
		text: sorter key displayString.! !

!ShoreComponent class methodsFor: 'application' stamp: 'pk 12/14/2005 10:28'!
applicationClass

	^ ShoreApplication! !

!ShoreComponent class methodsFor: 'application' stamp: 'pk 12/14/2005 10:28'!
applicationWithPath: aString

	| app |
	
	app := self applicationClass path: aString.
	app configuration addAncestor: WARenderLoopConfiguration new.
	app preferenceAt: #rootComponent put: self.
	^ app! !

!ShoreComponent class methodsFor: 'documentation' stamp: 'pk 7/14/2005 21:33'!
CSSValid

	^ false! !

!ShoreComponent class methodsFor: 'documentation-support' stamp: 'pk 6/14/2006 10:35'!
comment

	^ 'Component name: {1}

Short description: {2}

Maintainer: {3}

State: {4}

XHTML valid: {5}

CSS valid: {6}

- - - - - - - - - - - - - - - - - - - - 
Description: 
{7}

- - - - - - - - - - - - - - - - - - - - 
Development documentation: 
{8}

- - - - - - - - - - - - - - - - - - - - 
Examples:
{9}

- - - - - - - - - - - - - - - - - - - - 
TODO: 
{10}

!!!!!! Please, help us finish or improve this component !!!!!!
' translated format: (OrderedCollection new
	add: self name;
	add: self shortDescription translated;
	add: self maintainer;
	add: self state translated;
	add: self XHTMLValid displayString translated;
	add: self CSSValid asString translated;
	add: self description translated;
	add: self devDocumentation translated;
	add: self examples translated;
	add: self todo translated;
	yourself)
! !

!ShoreComponent class methodsFor: 'documentation' stamp: 'pk 7/14/2005 21:53'!
description

	^ self notEntered! !

!ShoreComponent class methodsFor: 'documentation' stamp: 'pk 7/14/2005 21:53'!
devDocumentation

	^ self notEntered! !

!ShoreComponent class methodsFor: 'documentation' stamp: 'pk 7/14/2005 21:53'!
examples

	^ self notEntered! !

!ShoreComponent class methodsFor: 'documentation' stamp: 'pk 7/14/2005 21:53'!
maintainer

	^ self notEntered
! !

!ShoreComponent class methodsFor: 'instance creation' stamp: 'pk 7/19/2005 17:15'!
new
	"Returns a new instance of the receiver"

	"WARNING: 
		Use this method only for root component of application.
		In any other cases use constructor #parent:"

	^ super new 
	! !

!ShoreComponent class methodsFor: 'identifiers' stamp: 'pk 6/14/2006 10:33'!
newId
	"Generates new unique identifier for html element etc "

	id ifNil: [ id := 0 ].
	id > 1048576 ifTrue: [ id := 0 ].
	id := id + 1.
	^ 'eid', id displayString.
		! !

!ShoreComponent class methodsFor: 'documentation-support' stamp: 'pk 7/14/2005 21:55'!
notEntered

	^ #'not entered'.! !

!ShoreComponent class methodsFor: 'instance creation' stamp: 'tbn 7/11/2005 21:30'!
parent: aComponent
	"Returns a new instance of the receiver initialized with the given parent component"

	^ (super basicNew parent: aComponent) initialize.! !

!ShoreComponent class methodsFor: 'documentation-support' stamp: 'pk 12/11/2005 18:02'!
renderAdditionalDescriptionOn: html

	html table class: #shoreDocumentationTable; with: [
		html documentationRow: self description
			label: 'Description:'.
		html documentationRow: self devDocumentation
			label: 'Development documentation:'.
		html documentationRow: self examples
			label: 'Examples:'.
		html documentationRow: self todo
			label: 'TODO:'.
		].
! !

!ShoreComponent class methodsFor: 'documentation-support' stamp: 'pk 7/14/2005 22:53'!
renderDescriptionOn: html

	self renderShortDescriptionOn: html.
	html break.
	self renderAdditionalDescriptionOn: html.
	html paragraph: 'Please, help us finish or improve this component '

! !

!ShoreComponent class methodsFor: 'documentation-support' stamp: 'pk 12/11/2005 18:02'!
renderShortDescriptionOn: html

	html table class: #shoreDocumentationTable; with: [
		html documentationRow: self name
			label: 'Component name:'.
		html documentationRow: self shortDescription
			label: 'Short description:'.
		html documentationRow: self maintainer
			label: 'Maintainer:'.
		html documentationRow: self state
			label: 'State:'.
		html documentationRow: self XHTMLValid
			label: 'XHTML valid:'.
		html documentationRow: self CSSValid 
			label: 'CSS valid:'.
	].
! !

!ShoreComponent class methodsFor: 'documentation' stamp: 'pk 7/14/2005 21:52'!
shortDescription

	^ self notEntered! !

!ShoreComponent class methodsFor: 'documentation' stamp: 'pk 7/14/2005 21:52'!
state

	^ self notEntered! !

!ShoreComponent class methodsFor: 'documentation' stamp: 'pk 7/14/2005 21:52'!
todo

	^ self notEntered! !

!ShoreComponent class methodsFor: 'documentation' stamp: 'pk 7/14/2005 21:33'!
XHTMLValid

	^ false! !

!ShoreComponent methodsFor: 'attributes' stamp: 'tbn 7/11/2005 21:10'!
addAttribute: attributeAssociation category: aCategoryName
	"Adds a new attribute in the given category"	

	(self ensureCategory: aCategoryName) 
		add: attributeAssociation.! !

!ShoreComponent methodsFor: 'attributes' stamp: 'tbn 7/11/2005 21:10'!
addFormAttribute: attributeAssociation
	"Add a new form attribute"

	self addAttribute: attributeAssociation category: #formAttributes
	! !

!ShoreComponent methodsFor: 'attributes' stamp: 'pk 10/3/2005 15:52'!
attributes
	"Returns the receivers attribute mapping"

	^attributes ifNil: [ attributes := Dictionary new ].! !

!ShoreComponent methodsFor: 'attributes' stamp: 'tbn 7/11/2005 21:11'!
attributes: aDictionary
	"Sets the receivers attribute mapping"

	attributes := aDictionary! !

!ShoreComponent methodsFor: 'hierarchy' stamp: 'tbn 7/11/2005 21:14'!
call: aComponent
	"Calls and returns the given component"

	| result |
	result := super call: aComponent.
	self pageTitle ifNotNil: [self pageTitle: self pageTitle].
	^ result! !

!ShoreComponent methodsFor: 'convenience' stamp: 'tbn 7/11/2005 21:23'!
confirm: aString
	"Let the user confirm the contents of the given string"

	^ self defaultTarget call: ((ShoreConfirmDialog parent: self defaultTarget) message: aString)! !

!ShoreComponent methodsFor: 'hierarchy' stamp: 'tbn 7/11/2005 21:14'!
defaultTarget
	"Returns the receivers default target"

	^ self root! !

!ShoreComponent methodsFor: 'attributes' stamp: 'tbn 7/11/2005 21:12'!
ensureAttributes
	"Ensures that the receiver has an attribute mapping and return it"

	attributes ifNil: [ attributes := Dictionary new ].
	^ self attributes.
	! !

!ShoreComponent methodsFor: 'attributes' stamp: 'tbn 7/11/2005 21:13'!
ensureCategory: aCategoryName
	"Ensures that the receiver has an attribute mapping for the given category"

	^ self ensureAttributes at: aCategoryName ifAbsentPut: [Dictionary new].
! !

!ShoreComponent methodsFor: 'convenience' stamp: 'tbn 7/11/2005 21:22'!
error: aString
	"Displays the given string as an error"

	self defaultTarget call: ((ShoreErrorDialog parent: self defaultTarget) message: aString)
! !

!ShoreComponent methodsFor: 'files' stamp: 'pk 12/14/2005 16:01'!
fileProvider

	^ self session application fileProvider! !

!ShoreComponent methodsFor: 'hierarchy' stamp: 'pk 7/19/2005 17:07'!
footer
	"Returns the receivers footer"

	^ (self parent respondsTo: #footer)
			ifTrue: [ self parent footer ]
			ifFalse: [ self ]! !

!ShoreComponent methodsFor: 'forms' stamp: 'pk 12/11/2005 16:05'!
form

	^ self attributes at: #form ifAbsent: [ nil ].! !

!ShoreComponent methodsFor: 'forms' stamp: 'pk 12/11/2005 22:24'!
formId
	"Sets the receivers form id"

	^ (self parent respondsTo: #nestedInForm) 
		ifTrue: [ 
			self form 
				ifNotNil: [ (self form attributes at: #id) value  ]
				ifNil: [ self parent formId ] ] 
		ifFalse: [ nil ].

	! !

!ShoreComponent methodsFor: 'forms' stamp: 'pk 12/20/2005 17:44'!
form: aFormTag

	self ensureAttributes at: #form put: aFormTag

! !

!ShoreComponent methodsFor: 'convenience' stamp: 'pk 11/1/2005 10:22'!
getString

	^ self getString: '' message: 'Please, input a string' translated.! !

!ShoreComponent methodsFor: 'convenience' stamp: 'pk 11/1/2005 10:22'!
getString: initialValue message: aMessageString
	"gets simple string from user"

	^ self defaultTarget call: ((ShoreGetStringDialog parent: self defaultTarget) 
		message: aMessageString;
		string: initialValue)! !

!ShoreComponent methodsFor: 'hierarchy' stamp: 'pk 7/19/2005 17:07'!
header
	"Returns the receivers header"

	^ (self parent respondsTo: #header)
			ifTrue: [ self parent header ]
			ifFalse: [ self ]! !

!ShoreComponent methodsFor: 'convenience' stamp: 'tbn 7/11/2005 21:23'!
inform: aString
	"Inform the user about the contents of the given string"

	self defaultTarget call: ((ShoreInformDialog parent: self defaultTarget) message: aString)! !

!ShoreComponent methodsFor: 'initialization' stamp: 'pk 12/11/2005 17:23'!
initialize
	"Initializes the receiver"

	super initialize.
	self pageTitle ifNotNil: [self pageTitle: self pageTitle].
	! !

!ShoreComponent methodsFor: 'hierarchy' stamp: 'pk 7/19/2005 17:08'!
leftPanel
	"Returns the left panel"

	^ (self parent respondsTo: #leftPanel)
			ifTrue: [ self parent leftPanel ]
			ifFalse: [ self ]! !

!ShoreComponent methodsFor: 'hierarchy' stamp: 'pk 7/19/2005 17:07'!
mainPanel
	"Return the main panel"

	^ (self parent respondsTo: #mainPanel)
			ifTrue: [ self parent mainPanel ]
			ifFalse: [ self ]! !

!ShoreComponent methodsFor: 'forms' stamp: 'pk 12/20/2005 18:30'!
nestedInForm

	^ self form 
		ifNotNil: [ true ]
		ifNil: [ 
			(self parent respondsTo: #nestedInForm)
				ifTrue: [ self parent nestedInForm ] 
				ifFalse: [ false ] ].! !

!ShoreComponent methodsFor: 'hierarchy' stamp: 'tbn 7/11/2005 21:18'!
pageTitle
	"Returns the receivers page title"

	^nil! !

!ShoreComponent methodsFor: 'convenience' stamp: 'pk 11/1/2005 10:52'!
pageTitle: title
	"Set the receivers page title"

	self header ifNotNilDo: [:header | 
		(header respondsTo: #subtitle) ifTrue: [ header subtitle: title] ].

	! !

!ShoreComponent methodsFor: 'accessing' stamp: 'pk 7/19/2005 17:12'!
parent
	"Returns the receivers parent component"

	^parent 
		ifNil: [self class canBeRoot 
			ifFalse: [self error: 'Component has no parent.  Consider creating the instance with parent:
instead of new.' translated] 
			ifTrue: [nil]]! !

!ShoreComponent methodsFor: 'accessing' stamp: 'tbn 7/11/2005 21:26'!
parent: anObject
	"Sets the receivers parent (component) to the given object"

	parent := anObject! !

!ShoreComponent methodsFor: 'hierarchy' stamp: 'pk 7/19/2005 17:07'!
realRoot
	"Returns the receivers real root component"

	^(self parent respondsTo: #realRoot)
			ifTrue: [ self parent realRoot ]
			ifFalse: [ self ].! !

!ShoreComponent methodsFor: 'renderer' stamp: 'pk 12/11/2005 11:36'!
rendererClass 
	"Returns the receivers default renderer class"

	^ ShoreCanvas! !

!ShoreComponent methodsFor: 'private' stamp: 'pk 12/11/2005 17:33'!
renderWithContext: aRenderingContext

	self attributes ifNotNilDo: [:attribs |
		(attribs includesKey: #form) ifTrue: [
			attributes at: #form put: nil ] ].
		
	^ super renderWithContext: aRenderingContext! !

!ShoreComponent methodsFor: 'hierarchy' stamp: 'pk 7/19/2005 17:07'!
rightPanel
	"Returns the receivers right panel"
	
	^(self parent respondsTo: #rightPanel)
			ifTrue: [ self parent rightPanel ]
			ifFalse: [ self ]! !

!ShoreComponent methodsFor: 'hierarchy' stamp: 'pk 7/19/2005 17:07'!
root
	"Returns the receivers root"

	^(self parent respondsTo: #root)
			ifTrue: [ self parent root ]
			ifFalse: [ self ].! !

!ShoreComponent methodsFor: 'caching' stamp: 'tbn 7/11/2005 21:28'!
sessionCache
	"Returns the receivers session cache which is a special attribute called session cache.
	The session cache is a dictionary of URLs and documents. When a component generates a picture it remembers 
 	the URL generated by Seaside and saves it with this picture into the session cache under unique name. When 
	the component wants to generate the picture again it takes only the URL from cache."

	^ self realRoot ensureCategory: #sessionCache.
! !

!ShoreComponent methodsFor: 'caching' stamp: 'tbn 7/11/2005 21:29'!
sessionCacheAt: aSymbol ifAbsentPut: aBlock
	"Returns a cache item at the given symbol - if there is none evaluate the block to return a new cache item and register
      it into the session cache"

	^ (self sessionCache at: aSymbol ifAbsentPut: [aBlock value]) url
			
	! !

!ShoreComponent methodsFor: 'hierarchy' stamp: 'pk 7/19/2005 17:08'!
target
	"Returns the receivers target"

	^ (self parent respondsTo: #target)
			ifTrue: [ self parent target ]
			ifFalse: [ self ]! !

!ShoreComponent methodsFor: 'forms' stamp: 'pk 12/20/2005 18:46'!
wrappingForm

	"returns parent form of the component"

	^ self form 
		ifNil: [ 
			(self parent respondsTo: #nestedInForm)
				ifTrue: [ self parent wrappingForm ] 
				ifFalse: [ nil ] ].

	! !

ShoreComponent subclass: #ShoreDemo1ComponentWithForm
	instanceVariableNames: 'name surname'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo1'!

!ShoreDemo1ComponentWithForm methodsFor: 'initialization' stamp: 'pk 7/3/2005 21:42'!
initialize

	super initialize.

	name := 'name' translated.
	surname := 'surname' translated.! !

!ShoreDemo1ComponentWithForm methodsFor: 'accessing' stamp: 'pk 7/3/2005 21:41'!
name
	^name! !

!ShoreDemo1ComponentWithForm methodsFor: 'accessing' stamp: 'pk 7/3/2005 21:08'!
name: anObject
	name := anObject! !

!ShoreDemo1ComponentWithForm methodsFor: 'rendering' stamp: 'pk 1/3/2006 20:48'!
renderContentOn: html

	html div class: #shoreDemo1ComponentWithFrom2; with: [
		html form 
			attributeAt: #onSubmit put: 'alert("onSubmit")';
			with: [
			html table: [
				html tableRowWithLabel: 'Name:' translated 
					column:  [html textInput on: #name of: self].
				html tableRowWithLabel: 'Surname:' translated 
					column:  [html textInput on: #surname of: self] ].
			html buttons: [ html submitButton callback: [self inform: 'Submit button callback one' translated] ] ].
	].

! !

!ShoreDemo1ComponentWithForm methodsFor: 'style informations' stamp: 'pk 7/3/2005 21:41'!
style

	^ '
.shoreDemo1ComponentWithFrom2 { background: #c6d3f7 }
'! !

!ShoreDemo1ComponentWithForm methodsFor: 'accessing' stamp: 'pk 7/3/2005 21:08'!
surname
	^surname! !

!ShoreDemo1ComponentWithForm methodsFor: 'accessing' stamp: 'pk 7/3/2005 21:08'!
surname: anObject
	surname := anObject! !

ShoreComponent subclass: #ShoreDemo1ComponentWithForm2
	instanceVariableNames: 'person description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo1'!

!ShoreDemo1ComponentWithForm2 methodsFor: 'accessing' stamp: 'pk 4/11/2006 11:19'!
children

	^ Array with: person ! !

!ShoreDemo1ComponentWithForm2 methodsFor: 'accessing' stamp: 'pk 7/3/2005 21:23'!
description
	^description! !

!ShoreDemo1ComponentWithForm2 methodsFor: 'accessing' stamp: 'pk 7/3/2005 21:23'!
description: anObject
	description := anObject! !

!ShoreDemo1ComponentWithForm2 methodsFor: 'initialization' stamp: 'tbn 7/11/2005 21:56'!
initialize

	super initialize.

	person := ShoreDemo1ComponentWithForm parent: self.
	description := 'description' translated.! !

!ShoreDemo1ComponentWithForm2 methodsFor: 'rendering' stamp: 'pk 1/3/2006 20:48'!
renderContentOn: html

	html div class: #shoreDemo1ComponentWithFrom; with: [
		html form with: [
			html table: [
				html tableRowWithLabel: 'Person:' translated 
					column:  [html render: person.].
				html tableRowWithLabel: 'Description:' translated 
					column:  [html textInput on: #description of: self] ].
			html buttons: [ html submitButton callback: [ self inform: 'Submit button callback two' translated ] ] ].
	].! !

!ShoreDemo1ComponentWithForm2 methodsFor: 'style informations' stamp: 'pk 7/3/2005 21:40'!
style

	^ '
.shoreDemo1ComponentWithFrom { background: #ecf1fd }
'! !

ShoreComponent subclass: #ShoreDemo1DemosMenu
	instanceVariableNames: ''
	classVariableNames: 'DemoMapping'
	poolDictionaries: ''
	category: 'ShoreComponents-Demo1'!

!ShoreDemo1DemosMenu class methodsFor: 'accessing' stamp: 'pk 5/17/2006 16:28'!
demoMapping
	"Returns the receivers demo mapping"

	DemoMapping isNil ifTrue: [ self resetMapping].

	^ DemoMapping! !

!ShoreDemo1DemosMenu class methodsFor: 'demo registration' stamp: 'pk 6/18/2006 20:31'!
register: aDemoPage

	"Registers the given demo in the demo mapping"

	(self demoMapping includes: aDemoPage) 
		ifTrue: [ ^ aDemoPage ].

	^self demoMapping add: aDemoPage.! !

!ShoreDemo1DemosMenu class methodsFor: 'accessing' stamp: 'pk 5/17/2006 16:27'!
resetMapping

	DemoMapping := OrderedCollection new! !

!ShoreDemo1DemosMenu methodsFor: 'accessing' stamp: 'tbn 7/11/2005 20:47'!
name
	"Returns the receivers name"
	
	^'Demos menu'.! !

!ShoreDemo1DemosMenu methodsFor: 'rendering' stamp: 'pk 5/17/2006 19:45'!
renderContentOn: html
	"Renders the receivers content on the given html object"

	html unorderedList: [
		"add all demos"	
		(self class demoMapping asSortedCollection: [:a :b | a menuPriority <= b menuPriority ]) 
			do: [:demoClass | 
				self renderLinkTo: demoClass on: html ]]

! !

!ShoreDemo1DemosMenu methodsFor: 'rendering' stamp: 'pk 5/17/2006 16:23'!
renderLinkTo: demoClass on: html
	"Renders a link to a demo component on the given html object"

	html listItem with: [
		html anchor 
			callback: [ self target show: (demoClass parent: self target)];
			with:  demoClass menuName. ].
	! !

ShoreComponent subclass: #ShoreDemo1Page
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo1'!

ShoreDemo1Page subclass: #ShoreDemo1ContextMenu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo1'!

!ShoreDemo1ContextMenu class methodsFor: 'as yet unclassified' stamp: 'pk 5/17/2006 16:25'!
initialize

	self registerToMenu
! !

!ShoreDemo1ContextMenu class methodsFor: 'as yet unclassified' stamp: 'pk 5/17/2006 16:12'!
menuName

	^ 'Context menu' translated! !

!ShoreDemo1ContextMenu methodsFor: 'accessing' stamp: 'pk 4/23/2006 09:58'!
pageTitle

	^ 'Context menu demo' translated! !

!ShoreDemo1ContextMenu methodsFor: 'rendering' stamp: 'pk 4/23/2006 14:21'!
renderContentOn: html

	| id1 id2 |

	html heading: self pageTitle.

	id1 := ShoreComponent newId.
	id2 := ShoreComponent newId.

	html div
		class: #bordered;
		id: id1;
		contextMenu: (Array 
			with: ('Item 1' translated -> [ self inform: 'Item 1' translated])
			with: ('Item 2' translated -> [ self inform: 'Item 2' translated])
			with: ('Item 3' translated -> [ self inform: 'Item 3' translated]));			
		with: 'click here with right mouse button...' translated.
	html assignContextMenuTo: id1.

	html paragraph
		id: id2;
		contextMenu: (Array 
			with: ('Item 4' translated -> [ self inform: 'Item 4' translated])
			with: ('Item 5' translated -> [ self inform: 'Item 5' translated])
			with: ('Item 6' translated -> [ self inform: 'Item 6' translated]));			
		with: 'another menu...' translated.
	html assignContextMenuTo: id2.
	! !

ShoreDemo1Page subclass: #ShoreDemo1DynamicFileDownload
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo1'!

!ShoreDemo1DynamicFileDownload class methodsFor: 'as yet unclassified' stamp: 'pk 5/17/2006 16:25'!
initialize

	self registerToMenu
! !

!ShoreDemo1DynamicFileDownload class methodsFor: 'as yet unclassified' stamp: 'pk 5/17/2006 16:13'!
menuName

	^ 'Dynamic files' translated! !

!ShoreDemo1DynamicFileDownload methodsFor: 'file contents' stamp: 'tbn 7/8/2005 16:56'!
csvContents
	"Note that we return the field seperated by , instead of ; since this makes it correctly visible in Excel "

	^'"Hello","World"'! !

!ShoreDemo1DynamicFileDownload methodsFor: 'rendering' stamp: 'pk 12/14/2005 16:13'!
displayLogo

	| response |

	response := WAResponse new contentType: 'image/svg+xml'.
	response stream nextPutAll: self logo.
	self session returnResponse: response! !

!ShoreDemo1DynamicFileDownload methodsFor: 'rendering' stamp: 'pk 12/14/2005 16:13'!
displaySVG

	| response |

	response := WAResponse new contentType: 'image/svg+xml'.
	response stream nextPutAll: self svg.
	self session returnResponse: response! !

!ShoreDemo1DynamicFileDownload methodsFor: 'file contents' stamp: 'pk 12/14/2005 16:17'!
logo

	^'<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<!!-- Created with Inkscape (http://www.inkscape.org/) -->
<svg
   xmlns:dc="http://purl.org/dc/elements/1.1/"
   xmlns:cc="http://web.resource.org/cc/"
   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
   xmlns:svg="http://www.w3.org/2000/svg"
   xmlns="http://www.w3.org/2000/svg"
   xmlns:sodipodi="http://inkscape.sourceforge.net/DTD/sodipodi-0.dtd"
   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
   id="svg2"
   sodipodi:version="0.32"
   inkscape:version="0.43"
   width="100"
   height="100"
   sodipodi:docbase="C:\temp\66"
   sodipodi:docname="shore.svg"
   version="1.0">

  <defs
     id="defs5" />

  <path
     style="opacity:1;fill:#307ae6;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.99999952;stroke-miterlimit:4.30000019;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
     d="M 90.68,2.0000008 L 2.0,2.0 L 2.0,98.0 L 2.6899998,97.999972 C 3.4731582,97.653796 3.3387582,97.689412 4.1899998,97.309924 C 7.6852063,95.752036 11.73007,93.90298 16.04,91.849924 C 20.349929,89.796964 24.921152,87.542212 29.51,85.099972 C 34.098848,82.657684 38.708067,80.025652 43.04,77.30002 C 45.205971,75.937108 47.308726,74.54386 49.31,73.129972 C 51.311273,71.71618 53.210393,70.291636 54.98,68.84002 C 56.749606,67.388404 58.36904,65.936116 59.84,64.46002 C 61.31096,62.983828 62.634665,61.477492 63.74,59.989972 C 64.845334,58.502548 65.737261,57.005524 66.41,55.52002 C 67.082739,54.03442 67.526845,52.580404 67.7,51.109972 C 67.808077,50.192308 67.805168,49.300679 67.73,48.470001 C 67.654832,47.639322 67.514029,46.855002 67.28,46.100001 C 66.811952,44.589998 66.047168,43.235313 65.09,41.960001 C 64.132832,40.684689 62.981216,39.491342 61.73,38.360001 C 60.478784,37.22866 59.120192,36.13809 57.77,35.060001 C 56.419808,33.981911 55.064096,32.90555 53.81,31.790001 C 52.555904,30.674452 51.412928,29.523729 50.45,28.280001 C 49.487072,27.036273 48.706678,25.722628 48.23,24.260001 C 47.991661,23.528692 47.830208,22.75305 47.75,21.950001 C 47.669792,21.146951 47.677683,20.316119 47.78,19.430001 C 47.90935,18.309777 48.215033,17.258452 48.68,16.280001 C 49.144966,15.30155 49.779344,14.397383 50.54,13.550001 C 51.300656,12.702618 52.1936,11.907018 53.21,11.180001 C 54.2264,10.452983 55.367801,9.7873672 56.6,9.1700008 C 59.064397,7.9352776 61.912025,6.9103432 65,6.0500008 C 68.087974,5.1896584 71.417955,4.491604 74.81,3.9200008 C 78.202045,3.3483976 81.663411,2.908516 85.04,2.5400008 C 87.005273,2.3255176 88.805571,2.168644 90.68,2.0000008 z "
     id="path2196" />
  <path
     style="opacity:1;fill:#ffff00;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.99999952;stroke-miterlimit:4.30000019;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
     d="M 90.68,2.0000008 C 88.805571,2.168644 87.005273,2.3255176 85.04,2.5400008 C 81.663411,2.908516 78.202045,3.3483976 74.81,3.9200008 C 71.417955,4.491604 68.087974,5.1896584 65,6.0500008 C 61.912025,6.9103432 59.064397,7.9352776 56.6,9.1700008 C 55.367801,9.7873672 54.2264,10.452983 53.21,11.180001 C 52.1936,11.907018 51.300656,12.702618 50.54,13.550001 C 49.779344,14.397383 49.144966,15.30155 48.68,16.280001 C 48.215033,17.258452 47.90935,18.309777 47.78,19.430001 C 47.677683,20.316119 47.669792,21.146951 47.75,21.950001 C 47.830208,22.75305 47.991661,23.528692 48.23,24.260001 C 48.706678,25.722628 49.487072,27.036273 50.45,28.280001 C 51.412928,29.523729 52.555904,30.674452 53.81,31.790001 C 55.064096,32.90555 56.419808,33.981911 57.77,35.060001 C 59.120192,36.13809 60.478784,37.22866 61.73,38.360001 C 62.981216,39.491342 64.132832,40.684689 65.09,41.960001 C 66.047168,43.235313 66.811952,44.589998 67.28,46.100001 C 67.514029,46.855002 67.654832,47.639322 67.73,48.470001 C 67.805168,49.300679 67.808077,50.192308 67.7,51.109972 C 67.526845,52.580404 67.082739,54.03442 66.41,55.52002 C 65.737261,57.005524 64.845334,58.502548 63.74,59.989972 C 62.634665,61.477492 61.31096,62.983828 59.84,64.46002 C 58.36904,65.936116 56.749606,67.388404 54.98,68.84002 C 53.210393,70.291636 51.311273,71.71618 49.31,73.129972 C 47.308726,74.54386 45.205971,75.937108 43.04,77.30002 C 38.708067,80.025652 34.098848,82.657684 29.51,85.099972 C 24.921152,87.542212 20.349929,89.796964 16.04,91.849924 C 11.73007,93.90298 7.6852063,95.752036 4.1899998,97.309924 C 3.3387582,97.689412 3.4731582,97.653796 2.6899998,97.999972 L 97.99999,97.999972 L 97.99999,2.0000008 L 90.68,2.0000008 z "
     id="rect1318" />
</svg>
'! !

!ShoreDemo1DynamicFileDownload methodsFor: 'accessing' stamp: 'tbn 7/8/2005 16:55'!
pageTitle
	"Returns the receivers page title"

	^'Dynamic Download Demo'! !

!ShoreDemo1DynamicFileDownload methodsFor: 'rendering' stamp: 'pk 12/14/2005 16:16'!
renderContentOn: html
	"Renders the receivers content on the given html object"

	html heading: self pageTitle.


	html unorderedList list: 
		(Array 
			with: [ html anchor 
				callback: [self session download: self csvContents mimeType: 'application/csv' filename: 'file.csv']; 
				text: 'CVS'.]
			with: [ html anchor 
				callback: [
					self session download: self rtfContents mimeType: 'application/rtf' filename: 'file.rtf'	]; 
				text: 'RTF'.]
			with: [ html anchor callback: [ self displaySVG]; text: 'SVG demo'.]
			with: [ html anchor callback: [ self displayLogo]; text: 'ShoreComponents logo' ])

 ! !

!ShoreDemo1DynamicFileDownload methodsFor: 'file contents' stamp: 'tbn 7/8/2005 16:56'!
rtfContents

	^'{\rtf1\ansi\ansicpg1252\deff0\deflang1031{\fonttbl{\f0\fswiss\fcharset0 Arial;}}
\viewkind4\uc1\pard\f0\fs20 Hello World\par
}'! !

!ShoreDemo1DynamicFileDownload methodsFor: 'file contents' stamp: 'pk 12/14/2005 16:17'!
svg
	^'<?xml version="1.0" standalone="no"?>
<!!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.0//EN"
  "http://www.w3.org/TR/2001/REC-SVG-20010904/DTD/svg10.dtd">
<!!-- ===================================================================== -->
<!!--

  SVG Color Identifiers

  author: Stephane Hillion - 2000/04/16

-->
<!!-- ===================================================================== -->
<svg width="800" height="600" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns="http://www.w3.org/2000/svg" preserveAspectRatio="xMidYMid meet" zoomAndPan="magnify">
<title>SVG Color Identifiers</title>
  <style type="text/css"><!![CDATA[
    text {
      font-size:   16;
      font-weight: bold
    }
  ]]>
  </style>
  <rect width="100%" height="100%" style="fill: black"/>
  <text x="200" y="30" style="font-size: 32; fill:white" startOffset="0">SVG Color Identifiers</text>
  <line x1="10" y1="35" x2="790" y2="35" style="stroke: white"/>
  <text x="10" y="50" style="fill: AliceBlue" startOffset="0">AliceBlue</text>
  <text x="10" y="65" style="fill: AntiqueWhite" startOffset="0">AntiqueWhite</text>
  <text x="10" y="80" style="fill: Aqua" startOffset="0">Aqua</text>
  <text x="10" y="95" style="fill: Aquamarine" startOffset="0">Aquamarine</text>
  <text x="10" y="110" style="fill: Azure" startOffset="0">Azure</text>
  <text x="10" y="125" style="fill: Beige" startOffset="0">Beige</text>
  <text x="10" y="140" style="fill: Azure" startOffset="0">Bisque</text>
  <text x="10" y="155" style="fill: Black; stroke:White" startOffset="0">Black</text>
  <text x="10" y="170" style="fill: BlancheDalmond" startOffset="0">BlancheDalmond</text>
  <text x="10" y="185" style="fill: Blue" startOffset="0">Blue</text>
  <text x="10" y="200" style="fill: BlueViolet" startOffset="0">BlueViolet</text>
  <text x="10" y="215" style="fill: Brown" startOffset="0">Brown</text>
  <text x="10" y="230" style="fill: BurlyWood" startOffset="0">BurlyWood</text>
  <text x="10" y="245" style="fill: CadetBlue" startOffset="0">CadetBlue</text>
  <text x="10" y="260" style="fill: Chartreuse" startOffset="0">Chartreuse</text>
  <text x="10" y="275" style="fill: Chocolate" startOffset="0">Chocolate</text>
  <text x="10" y="290" style="fill: Coral" startOffset="0">Coral</text>
  <text x="10" y="305" style="fill: CornFlowerBlue" startOffset="0">CornFlowerBlue</text>
  <text x="10" y="320" style="fill: CornSilk" startOffset="0">CornSilk</text>
  <text x="10" y="335" style="fill: Crimson" startOffset="0">Crimson</text>
  <text x="10" y="350" style="fill: Cyan" startOffset="0">Cyan</text>
  <text x="10" y="365" style="fill: DarkBlue" startOffset="0">DarkBlue</text>
  <text x="10" y="380" style="fill: DarkCyan" startOffset="0">DarkCyan</text>
  <text x="10" y="395" style="fill: DarkGoldenRod" startOffset="0">DarkGoldenRod</text>
  <text x="10" y="410" style="fill: DarkGray" startOffset="0">DarkGray</text>
  <text x="10" y="425" style="fill: DarkGreen" startOffset="0">DarkGreen</text>
  <text x="10" y="440" style="fill: DarkGrey" startOffset="0">DarkGrey</text>
  <text x="10" y="455" style="fill: DarkKhaki" startOffset="0">DarkKhaki</text>
  <text x="10" y="470" style="fill: DarkMagenta" startOffset="0">DarkMagenta</text>
  <text x="10" y="485" style="fill: DarkOliveGreen" startOffset="0">DarkOliveGreen</text>
  <text x="10" y="500" style="fill: DarkOrange" startOffset="0">DarkOrange</text>
  <text x="10" y="515" style="fill: DarkOrchid" startOffset="0">DarkOrchid</text>
  <text x="10" y="530" style="fill: DarkRed" startOffset="0">DarkRed</text>
  <text x="10" y="545" style="fill: DarkSalmon" startOffset="0">DarkSalmon</text>
  <text x="10" y="560" style="fill: DarkSeaGreen" startOffset="0">DarkSeaGreen</text>
  <text x="10" y="575" style="fill: DarkSlateBlue" startOffset="0">DarkSlateBlue</text>
  <text x="10" y="590" style="fill: DarkSlateGray" startOffset="0">DarkSlateGray</text>
  <text x="190" y="50" style="fill: DarkSlateGrey" startOffset="0">DarkSlateGrey</text>
  <text x="190" y="65" style="fill: DarkTurquoise" startOffset="0">DarkTurquoise</text>
  <text x="190" y="80" style="fill: DarkViolet" startOffset="0">DarkViolet</text>
  <text x="190" y="95" style="fill: DeepPink" startOffset="0">DeepPink</text>
  <text x="190" y="110" style="fill: DeepSkyBlue" startOffset="0">DeepSkyBlue</text>
  <text x="190" y="125" style="fill: DimGray" startOffset="0">DimGray</text>
  <text x="190" y="140" style="fill: DimGrey" startOffset="0">DimGrey</text>
  <text x="190" y="155" style="fill: DodgerBlue" startOffset="0">DodgerBlue</text>
  <text x="190" y="170" style="fill: FireBrick" startOffset="0">FireBrick</text>
  <text x="190" y="185" style="fill: FloralWhite" startOffset="0">FloralWhite</text>
  <text x="190" y="200" style="fill: ForestGreen" startOffset="0">ForestGreen</text>
  <text x="190" y="215" style="fill: Fuchsia" startOffset="0">Fuchsia</text>
  <text x="190" y="230" style="fill: Gainsboro" startOffset="0">Gainsboro</text>
  <text x="190" y="245" style="fill: GhostWhite" startOffset="0">GhostWhite</text>
  <text x="190" y="260" style="fill: Gold" startOffset="0">Gold</text>
  <text x="190" y="275" style="fill: GoldenRod" startOffset="0">GoldenRod</text>
  <text x="190" y="290" style="fill: Gray" startOffset="0">Gray</text>
  <text x="190" y="305" style="fill: Green" startOffset="0">Green</text>
  <text x="190" y="320" style="fill: Grey" startOffset="0">Grey</text>
  <text x="190" y="335" style="fill: GreenYellow" startOffset="0">GreenYellow</text>
  <text x="190" y="350" style="fill: HoneyDew" startOffset="0">HoneyDew</text>
  <text x="190" y="365" style="fill: HotPink" startOffset="0">HotPink</text>
  <text x="190" y="380" style="fill: IndianRed" startOffset="0">IndianRed</text>
  <text x="190" y="395" style="fill: Indigo" startOffset="0">Indigo</text>
  <text x="190" y="410" style="fill: Ivory" startOffset="0">Ivory</text>
  <text x="190" y="425" style="fill: Khaki" startOffset="0">Khaki</text>
  <text x="190" y="440" style="fill: Lavender" startOffset="0">Lavender</text>
  <text x="190" y="455" style="fill: LavenderBlush" startOffset="0">LavenderBlush</text>
  <text x="190" y="470" style="fill: LawnGreen" startOffset="0">LawnGreen</text>
  <text x="190" y="485" style="fill: LemonChiffon" startOffset="0">LemonChiffon</text>
  <text x="190" y="500" style="fill: LightBlue" startOffset="0">LightBlue</text>
  <text x="190" y="515" style="fill: LightCoral" startOffset="0">LightCoral</text>
  <text x="190" y="530" style="fill: LightCyan" startOffset="0">LightCyan</text>
  <text x="190" y="545" style="fill: LightGoldenRodYellow" startOffset="0">LightGoldenRodYellow</text>
  <text x="190" y="560" style="fill: LightGray" startOffset="0">LightGray</text>
  <text x="190" y="575" style="fill: LightGreen" startOffset="0">LightGreen</text>
  <text x="190" y="590" style="fill: LightGrey" startOffset="0">LightGrey</text>
  <text x="410" y="50" style="fill: LightPink" startOffset="0">LightPink</text>
  <text x="410" y="65" style="fill: LightSalmon" startOffset="0">LightSalmon</text>
  <text x="410" y="80" style="fill: LightSeaGreen" startOffset="0">LightSeaGreen</text>
  <text x="410" y="95" style="fill: LightSkyBlue" startOffset="0">LightSkyBlue</text>
  <text x="410" y="110" style="fill: LightSlateGray" startOffset="0">LightSlateGray</text>
  <text x="410" y="125" style="fill: LightSlateGrey" startOffset="0">LightSlateGrey</text>
  <text x="410" y="140" style="fill: LightSteelBlue" startOffset="0">LightSteelBlue</text>
  <text x="410" y="155" style="fill: LightYellow" startOffset="0">LightYellow</text>
  <text x="410" y="170" style="fill: Lime" startOffset="0">Lime</text>
  <text x="410" y="185" style="fill: LimeGreen" startOffset="0">LimeGreen</text>
  <text x="410" y="200" style="fill: Linen" startOffset="0">Linen</text>
  <text x="410" y="215" style="fill: Magenta" startOffset="0">Magenta</text>
  <text x="410" y="230" style="fill: Maroon" startOffset="0">Maroon</text>
  <text x="410" y="245" style="fill: MediumAquamarine" startOffset="0">MediumAquamarine</text>
  <text x="410" y="260" style="fill: MediumBlue" startOffset="0">MediumBlue</text>
  <text x="410" y="275" style="fill: MediumOrchid" startOffset="0">MediumOrchid</text>
  <text x="410" y="290" style="fill: MediumPurple" startOffset="0">MediumPurple</text>
  <text x="410" y="305" style="fill: MediumSeaGreen" startOffset="0">MediumSeaGreen</text>
  <text x="410" y="320" style="fill: MediumSlateBlue" startOffset="0">MediumSlateBlue</text>
  <text x="410" y="335" style="fill: MediumSpringGreen" startOffset="0">MediumSpringGreen</text>
  <text x="410" y="350" style="fill: MediumTurquoise" startOffset="0">MediumTurquoise</text>
  <text x="410" y="365" style="fill: MediumVioletRed" startOffset="0">MediumVioletRed</text>
  <text x="410" y="380" style="fill: MidnightBlue" startOffset="0">MidnightBlue</text>
  <text x="410" y="395" style="fill: MintCream" startOffset="0">MintCream</text>
  <text x="410" y="410" style="fill: MistyRose" startOffset="0">MistyRose</text>
  <text x="410" y="425" style="fill: Moccasin" startOffset="0">Moccasin</text>
  <text x="410" y="440" style="fill: NavajoWhite" startOffset="0">NavajoWhite</text>
  <text x="410" y="455" style="fill: Navy" startOffset="0">Navy</text>
  <text x="410" y="470" style="fill: OldLace" startOffset="0">OldLace</text>
  <text x="410" y="485" style="fill: Olive" startOffset="0">Olive</text>
  <text x="410" y="500" style="fill: OliveDrab" startOffset="0">OliveDrab</text>
  <text x="410" y="515" style="fill: Orange" startOffset="0">Orange</text>
  <text x="410" y="530" style="fill: OrangeRed" startOffset="0">OrangeRed</text>
  <text x="410" y="545" style="fill: Orchid" startOffset="0">Orchid</text>
  <text x="410" y="560" style="fill: PaleGoldenRod" startOffset="0">PaleGoldenRod</text>
  <text x="410" y="575" style="fill: PaleGreen" startOffset="0">PaleGreen</text>
  <text x="410" y="590" style="fill: PaleTurquoise" startOffset="0">PaleTurquoise</text>
  <text x="620" y="50" style="fill: PaleVioletRed" startOffset="0">PaleVioletRed</text>
  <text x="620" y="65" style="fill: PapayaWhip" startOffset="0">PapayaWhip</text>
  <text x="620" y="80" style="fill: PeachPuff" startOffset="0">PeachPuff</text>
  <text x="620" y="95" style="fill: Peru" startOffset="0">Peru</text>
  <text x="620" y="110" style="fill: Pink" startOffset="0">Pink</text>
  <text x="620" y="125" style="fill: Plum" startOffset="0">Plum</text>
  <text x="620" y="140" style="fill: PowderBlue" startOffset="0">PowderBlue</text>
  <text x="620" y="155" style="fill: Purple" startOffset="0">Purple</text>
  <text x="620" y="170" style="fill: Red" startOffset="0">Red</text>
  <text x="620" y="185" style="fill: RosyBrown" startOffset="0">RosyBrown</text>
  <text x="620" y="200" style="fill: RoyalBlue" startOffset="0">RoyalBlue</text>
  <text x="620" y="215" style="fill: SaddleBrown" startOffset="0">SaddleBrown</text>
  <text x="620" y="230" style="fill: Salmon" startOffset="0">Salmon</text>
  <text x="620" y="245" style="fill: SandyBrown" startOffset="0">SandyBrown</text>
  <text x="620" y="260" style="fill: SeaGreen" startOffset="0">SeaGreen</text>
  <text x="620" y="275" style="fill: SeaShell" startOffset="0">SeaShell</text>
  <text x="620" y="290" style="fill: Sienna" startOffset="0">Sienna</text>
  <text x="620" y="305" style="fill: Silver" startOffset="0">Silver</text>
  <text x="620" y="320" style="fill: SkyBlue" startOffset="0">SkyBlue</text>
  <text x="620" y="335" style="fill: SlateBlue" startOffset="0">SlateBlue</text>
  <text x="620" y="350" style="fill: SlateGray" startOffset="0">SlateGray</text>
  <text x="620" y="365" style="fill: SlateGrey" startOffset="0">SlateGrey</text>
  <text x="620" y="380" style="fill: Snow" startOffset="0">Snow</text>
  <text x="620" y="395" style="fill: SpringGreen" startOffset="0">SpringGreen</text>
  <text x="620" y="410" style="fill: SteelBlue" startOffset="0">SteelBlue</text>
  <text x="620" y="425" style="fill: Tan" startOffset="0">Tan</text>
  <text x="620" y="440" style="fill: Teal" startOffset="0">Teal</text>
  <text x="620" y="455" style="fill: Thistle" startOffset="0">Thistle</text>
  <text x="620" y="470" style="fill: Tomato" startOffset="0">Tomato</text>
  <text x="620" y="485" style="fill: Turquoise" startOffset="0">Turquoise</text>
  <text x="620" y="500" style="fill: Violet" startOffset="0">Violet</text>
  <text x="620" y="515" style="fill: Wheat" startOffset="0">Wheat</text>
  <text x="620" y="530" style="fill: White" startOffset="0">White</text>
  <text x="620" y="545" style="fill: WhiteSmoke" startOffset="0">WhiteSmoke</text>
  <text x="620" y="560" style="fill: Yellow" startOffset="0">Yellow</text>
  <text x="620" y="575" style="fill: YellowGreen" startOffset="0">YellowGreen</text>
</svg>
'! !

ShoreDemo1Page subclass: #ShoreDemo1Introduction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo1'!

!ShoreDemo1Introduction class methodsFor: 'as yet unclassified' stamp: 'pk 5/17/2006 16:25'!
initialize

	self registerToMenu
! !

!ShoreDemo1Introduction class methodsFor: 'as yet unclassified' stamp: 'pk 5/17/2006 16:13'!
menuName

	^ 'Introduction' translated! !

!ShoreDemo1Introduction class methodsFor: 'as yet unclassified' stamp: 'pk 5/17/2006 16:17'!
menuPriority

	^ 1

	! !

!ShoreDemo1Introduction methodsFor: 'accessing' stamp: 'pk 7/3/2005 17:01'!
pageTitle

	^ 'Introduction' translated! !

!ShoreDemo1Introduction methodsFor: 'rendering' stamp: 'pk 12/11/2005 14:59'!
renderContentOn: html

	html heading: self pageTitle.
	
	html paragraph: 'Welcome to the ShoreComponents demonstration application.' translated.

	! !

ShoreDemo1Page subclass: #ShoreDemo1ListsDemo
	instanceVariableNames: 'list list1 list2 list3 list4'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo1'!

!ShoreDemo1ListsDemo class methodsFor: 'as yet unclassified' stamp: 'pk 5/17/2006 16:25'!
initialize

	self registerToMenu
! !

!ShoreDemo1ListsDemo class methodsFor: 'as yet unclassified' stamp: 'pk 5/17/2006 16:13'!
menuName

	^ 'Lists' translated! !

!ShoreDemo1ListsDemo methodsFor: 'accessing' stamp: 'pk 5/1/2006 09:40'!
children

	^ Array with: list with: list1 with: list2 with: list3 with: list4! !

!ShoreDemo1ListsDemo methodsFor: 'initialization' stamp: 'pk 6/14/2006 10:33'!
initialize

	| data |

	data := Smalltalk allClasses select: [:c | c name beginsWith: #Shore ].

	super initialize.

	list := ShoreList parent: self.
	list showItemBlock: [:item :filterText | filterText match: item name displayString].
	list onClickBlock: [:item | self inform: item ].
	list data: data.


	list1 := ShoreBatchedList parent: self.
	list1 title: 'Shore Batched List'.
	list1 data: data.

	list2 := ShoreBatchedList parent: self.
	list2 title: 'Shore Batched List'.
	list2 data: data.
	list2 itemBlock: 
			[:item :html | 
			html anchor callback: [self call: (WABrowser fullOnClass: item)];
				text: item displayString].
	list2 noteBlock: [:item :html | html text: item name size displayString].
	list2 showItemBlock: [:item :filterText | filterText match: item name displayString].
	list2 addSorter: 'name' translated block: [:a :b | a name <= b name].
	list2 addSorter: 'descending' translated block: [:a :b | b name <= a name].

	list3 := ShoreLiveBatchedList parent: self.
	list3 title: 'Shore Live Batched List'.
	list3 data: data.

	list4 := ShoreLiveBatchedList parent: self.
	list4 title: 'Shore Live Batched List'.
	list4 data: data.
	list4 itemBlock: 
			[:item :html | 
			html anchor callback: [self call: (WABrowser fullOnClass: item)];
				text: item displayString].
	list4 noteBlock: [:item :html | html text: item name size displayString].
	list4 showItemBlock: [:item :filterText | filterText match: item name displayString].
	list4 addSorter: 'name' translated block: [:a :b | a name <= b name].
	list4 addSorter: 'descending' translated block: [:a :b | b name <= a name]! !

!ShoreDemo1ListsDemo methodsFor: 'accessing' stamp: 'pk 7/3/2005 10:34'!
pageTitle

	^ 'ShoreBatchedList demo' translated! !

!ShoreDemo1ListsDemo methodsFor: 'rendering' stamp: 'pk 5/1/2006 09:43'!
renderContentOn: html

	html heading: self pageTitle.

	html paragraph: 'Simple list' translated.
	html render: list.

	html paragraph: 'Simple batched list' translated.
	html render: list1.

	html paragraph: 'Batched list with actions, sorting and notes' translated.
	html render: list2.

	html paragraph: 'Simple live batched list' translated.
	html render: list3.

	html paragraph: 'Live batched list with actions, sorting and notes' translated.
	html render: list4.

	html heading: 'Component description' translated level: 2.
	ShoreBatchedList renderDescriptionOn: html.


! !

!ShoreDemo1ListsDemo methodsFor: 'style informations' stamp: 'pk 7/3/2005 10:29'!
style

	^ '

.leftPanel {
	vertical-align: top;
	width: 220px;
	margin: 0px; 
	padding: 0px;
	height: 100%;
	background-color: rgb(116, 150, 226);

}

.layoutTable {
	width: 100%;
	height: 100%;
	padding: 0px;
}

.main {
	width: 100%;
	padding: 5px;
	margin: 0px;
	margin-bottom: 0px;
	height: 100%;
	padding-bottom: 20px;
}





'! !

ShoreDemo1Page subclass: #ShoreDemo1NestedFormsDemo
	instanceVariableNames: 'component1 component2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo1'!

!ShoreDemo1NestedFormsDemo class methodsFor: 'as yet unclassified' stamp: 'pk 5/17/2006 16:25'!
initialize

	self registerToMenu
! !

!ShoreDemo1NestedFormsDemo class methodsFor: 'as yet unclassified' stamp: 'pk 5/17/2006 16:14'!
menuName

	^ 'Nested forms' translated! !

!ShoreDemo1NestedFormsDemo class methodsFor: 'as yet unclassified' stamp: 'pk 5/17/2006 16:17'!
menuPriority

	^ 10

	! !

!ShoreDemo1NestedFormsDemo methodsFor: 'accessing' stamp: 'pk 4/11/2006 11:20'!
children

	^ Array with: component1 with: component2.! !

!ShoreDemo1NestedFormsDemo methodsFor: 'initialization' stamp: 'tbn 7/11/2005 21:56'!
initialize
	super initialize.
	component1 := ShoreDemo1ComponentWithForm parent: self.
	component2 := ShoreDemo1ComponentWithForm2 parent: self! !

!ShoreDemo1NestedFormsDemo methodsFor: 'accessing' stamp: 'pk 7/3/2005 21:27'!
pageTitle

	^ 'Nested forms demo' translated! !

!ShoreDemo1NestedFormsDemo methodsFor: 'rendering' stamp: 'pk 7/18/2005 12:28'!
renderContentOn: html

	html heading: self pageTitle.

	html paragraph: 'Simple component with a form:' translated.
	html render: component1.
	
	html paragraph: 'The component with a form which includes the next component with a form:' translated.
	html render: component2.
! !

!ShoreDemo1Page class methodsFor: 'as yet unclassified' stamp: 'pk 5/17/2006 16:15'!
menuName

	^ 'Demo' translated! !

!ShoreDemo1Page class methodsFor: 'as yet unclassified' stamp: 'pk 5/17/2006 16:16'!
menuPriority

	^ 100

	! !

!ShoreDemo1Page class methodsFor: 'as yet unclassified' stamp: 'pk 5/17/2006 16:29'!
registerToMenu

	ShoreDemo1DemosMenu register: self.! !

!ShoreDemo1Page methodsFor: 'as yet unclassified' stamp: 'pk 5/17/2006 15:51'!
pageTitle

	^ 'Demo'! !

!ShoreDemo1Page methodsFor: 'as yet unclassified' stamp: 'pk 10/31/2005 16:51'!
updateUrl: aUrl

	aUrl path add: self class name! !

ShoreDemo1Page subclass: #ShoreDemo1RichEditDemo
	instanceVariableNames: 'editor value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo1'!

!ShoreDemo1RichEditDemo class methodsFor: 'as yet unclassified' stamp: 'pk 5/17/2006 16:25'!
initialize

	self registerToMenu
! !

!ShoreDemo1RichEditDemo class methodsFor: 'as yet unclassified' stamp: 'pk 5/17/2006 16:11'!
menuName

	^ 'Rich eidt' translated! !

!ShoreDemo1RichEditDemo methodsFor: 'accessing' stamp: 'pk 4/11/2006 11:20'!
children

	^ Array with: editor.! !

!ShoreDemo1RichEditDemo methodsFor: 'initialization' stamp: 'pk 7/3/2005 20:16'!
initialize

	super initialize.

	editor := ShoreRichEdit parent: self.

! !

!ShoreDemo1RichEditDemo methodsFor: 'accessing' stamp: 'pk 7/3/2005 21:06'!
pageTitle

	^ 'Rich edit demo'.! !

!ShoreDemo1RichEditDemo methodsFor: 'rendering' stamp: 'pk 12/11/2005 22:19'!
renderContentOn: html

	html heading: self pageTitle.
	
	html form with: [
		html render: editor.
		html buttons: [		
			html submitButton.].
	].

	html paragraph: 'The content of the ShoreRichEdit:'.
	html html: editor content.

	html heading: 'Component description' translated level: 2.
	ShoreRichEdit renderDescriptionOn: html.! !

ShoreDemo1Page subclass: #ShoreDemo1StandardDialogsDemo
	instanceVariableNames: 'sampleInput'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo1'!

!ShoreDemo1StandardDialogsDemo class methodsFor: 'as yet unclassified' stamp: 'pk 5/17/2006 16:25'!
initialize

	self registerToMenu
! !

!ShoreDemo1StandardDialogsDemo class methodsFor: 'as yet unclassified' stamp: 'pk 5/17/2006 16:11'!
menuName

	^ 'Standard dialogs' translated! !

!ShoreDemo1StandardDialogsDemo class methodsFor: 'as yet unclassified' stamp: 'pk 5/17/2006 16:17'!
menuPriority

	^ 10

	! !

!ShoreDemo1StandardDialogsDemo methodsFor: 'rendering' stamp: 'pk 6/14/2006 10:33'!
numberLink: number on: html

	html paragraph with: [
		html anchor callback: [ self inform: number ];
			text: number displayString. ]! !

!ShoreDemo1StandardDialogsDemo methodsFor: 'rendering' stamp: 'pk 6/14/2006 10:34'!
numberLiveLink: number on: html

	html paragraph with: [
		html anchor inform: number;
			text: number displayString. ]! !

!ShoreDemo1StandardDialogsDemo methodsFor: 'accessing' stamp: 'tbn 7/8/2005 17:30'!
pageTitle

	^ 'Standard dialogs demo' translated! !

!ShoreDemo1StandardDialogsDemo methodsFor: 'rendering' stamp: 'pk 6/14/2006 10:34'!
renderContentOn: html

	html heading: self pageTitle.

	html form: [

		html unorderedList list: (OrderedCollection new
			add: [ html anchor 
				callback: [ self inform: 'Any message' translated ];
				with: 'inform' translated];

			add: [html anchor
				callback: [ self inform: (self confirm: 'Any message' translated) ];
				with: 'confirm' translated];

			add: [html anchor
				callback: [ self error: 'Any message' translated ];
				with: 'error' translated];

			add: [html anchor 
				callback: [ self inform: self getString];
				with: 'get string' translated];

			add: [html anchor
				callback: [ self inform: (self getString: 'Seaside' message: 'Your favorite framework' translated)]; 
				with: 'get string with a message and initial value' translated];
			yourself).

		html heading: 'Live dialogs' translated level: 2.

		html unorderedList list: (OrderedCollection new
			add: [ 
				html anchor inform: 'Any message';
					text: 'inform' translated];

			add: [ 
				html div class: #bordered; inform: 'Any message' translated ;
					with: 'click here...'];

			add: [ 			
				html anchor confirm: 'Any message' translated andDo: [self inform: 'Confirmed' translated ];
					text: 'confirm' translated];	

			add: [ 
				html button confirm: 'Any message' translated andDo: [self inform: 'Confirmed' translated ];
					text: 'confirm button' translated];	

			add: [ html anchor 
				showDialog: [:h | 
					h fixDialogSize.
					h paragraph: 'dialog' translated.
					1 to: 10 do: [:i | 
						self numberLink: i on: h ].
					h buttons: [h button closeDialog; text: 'close'] ] 
				caption: 'Custom dialog' translated;
				with: 'custom dialog' translated];

			add: [ html anchor 
				showDialog: [:h | 
					h fixDialogSize.
					h paragraph: 'dialog' translated.
					1 to: 100 do: [:i | 
						self numberLink: i on: h ].
					h buttons: [h button closeDialog; text: 'close'] ] 
				caption: 'Custom dialog' translated;
				with: 'long custom dialog' translated];

			add: [ html anchor 
				showDialog: [:h | 
					h form: [
						h fixDialogSize.
						h text: 'Sample input: ' translated.
						h textInput on: #sampleInput of: self.
						1 to: 5 do: [:i | 
							self numberLiveLink: i on: h ].
						h buttons: [
							h submitButton callback: [ self inform: self sampleInput ].	
							h space.
							h button closeDialog; text: 'close'] ] ] 
				caption: 'Custom dialog' translated;
				with: 'custom form dialog' translated];

			add: [html anchor getString: 'Seaside' message: 'Your favorite framework' translated andDo: [:string| self inform: string];
				with: 'get string with a message and initial value' translated];

			yourself)
	].





! !

!ShoreDemo1StandardDialogsDemo methodsFor: 'accessing' stamp: 'pk 4/22/2006 20:08'!
sampleInput
	"Answer the value of sampleInput"

	^ sampleInput! !

!ShoreDemo1StandardDialogsDemo methodsFor: 'accessing' stamp: 'pk 5/17/2006 12:38'!
sampleInput: anObject
	"Set the value of sampleInput"

	sampleInput := anObject! !

!ShoreDemo1StandardDialogsDemo methodsFor: 'style information' stamp: 'pk 7/3/2005 11:06'!
style

	^ '

.leftPanel {
	vertical-align: top;
	width: 220px;
	margin: 0px; 
	padding: 0px;
	height: 100%;
	background-color: rgb(116, 150, 226);

}

.layoutTable {
	width: 100%;
	height: 100%;
	padding: 0px;
}

.main {
	width: 100%;
	padding: 5px;
	margin: 0px;
	margin-bottom: 0px;
	height: 100%;
	padding-bottom: 20px;
}





'! !

ShoreDemo1Page subclass: #ShoreDemo1TabControlDemo
	instanceVariableNames: 'tab tab2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo1'!

!ShoreDemo1TabControlDemo class methodsFor: 'as yet unclassified' stamp: 'pk 5/17/2006 16:25'!
initialize

	self registerToMenu
! !

!ShoreDemo1TabControlDemo class methodsFor: 'as yet unclassified' stamp: 'pk 5/17/2006 16:10'!
menuName

	^ 'Tab control' translated! !

!ShoreDemo1TabControlDemo methodsFor: 'accessing' stamp: 'pk 4/29/2006 11:18'!
children

	^ Array with: tab with: tab2! !

!ShoreDemo1TabControlDemo methodsFor: 'initialization' stamp: 'pk 5/17/2006 16:42'!
initialize

	super initialize.

	tab := ShoreTabControl parent: self.

	(Array with: ShoreDemo1Introduction with: ShoreDemo1StandardDialogsDemo with: ShoreDemo1NestedFormsDemo)
	 do: [:demoClass |
		tab add: (demoClass parent: tab) label: demoClass menuName ].

	tab select: tab options first.
		
	tab2 := ShoreTabControl2 parent: self.

	(Array with: ShoreDemo1Introduction with: ShoreDemo1StandardDialogsDemo with: ShoreDemo1NestedFormsDemo)
	 do: [:demoClass |
		tab2 add: (demoClass parent: tab) label: demoClass menuName ].
	
	tab2 select: tab2 options first.

! !

!ShoreDemo1TabControlDemo methodsFor: 'accessing' stamp: 'pk 12/14/2005 19:37'!
pageTitle

	^ 'Tab control demo'.! !

!ShoreDemo1TabControlDemo methodsFor: 'rendering' stamp: 'pk 4/29/2006 11:19'!
renderContentOn: html

	html heading: self pageTitle.
	
	html render: tab.
	html render: tab2.
	
	html heading: 'Component description' translated level: 2.
	ShoreTabControl renderDescriptionOn: html.! !

ShoreDemo1Page subclass: #ShoreDemo1TableDemo
	instanceVariableNames: 'table'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo1'!

!ShoreDemo1TableDemo class methodsFor: 'as yet unclassified' stamp: 'pk 5/17/2006 16:25'!
initialize

	self registerToMenu
! !

!ShoreDemo1TableDemo class methodsFor: 'as yet unclassified' stamp: 'pk 5/17/2006 16:10'!
menuName

	^ 'Table report' translated! !

!ShoreDemo1TableDemo methodsFor: 'accessing' stamp: 'pk 12/14/2005 20:28'!
children

	^ Array with: table! !

!ShoreDemo1TableDemo methodsFor: 'initialization' stamp: 'pk 6/18/2006 09:30'!
initialize

	super initialize.

	table := ShoreTable parent: self.
	
	table rows: (Smalltalk allClasses first: 15);
		columns: 
			(Array with: (ShoreTableColumn selector: #yourself title: 'class' translated)
			with: ( ShoreTableColumn new
				title: 'name length' translated;
				valueBlock: [:ea | ea name size])
			with:
			 (ShoreTableColumn new
				title: 'reversed name' translated;
				valueBlock: [:ea | ea name reversed])).

		

! !

!ShoreDemo1TableDemo methodsFor: 'accessing' stamp: 'pk 12/14/2005 20:38'!
pageTitle

	^ 'Table report demo'.! !

!ShoreDemo1TableDemo methodsFor: 'rendering' stamp: 'pk 12/14/2005 20:37'!
renderContentOn: html

	html heading: self pageTitle.
	
	html render: table.
	
	html heading: 'Component description' translated level: 2.
	ShoreTable renderDescriptionOn: html.! !

ShoreDemo1Page subclass: #ShoreDemo1TableDemo2
	instanceVariableNames: 'table'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo1'!

!ShoreDemo1TableDemo2 class methodsFor: 'as yet unclassified' stamp: 'pk 5/17/2006 16:25'!
initialize

	self registerToMenu
! !

!ShoreDemo1TableDemo2 class methodsFor: 'as yet unclassified' stamp: 'pk 5/17/2006 16:09'!
menuName

	^ 'Table report (enhanced)' translated! !

!ShoreDemo1TableDemo2 methodsFor: 'accessing' stamp: 'pk 12/14/2005 20:46'!
children

	^ Array with: table! !

!ShoreDemo1TableDemo2 methodsFor: 'initialization' stamp: 'pk 6/18/2006 20:12'!
initialize

	| rows columns |
   
	super initialize.
 
	rows := #(6 5 4 3 2 1).
	columns := OrderedCollection new
		add: ((ShoreTableColumn selector: #yourself title: 'original' translated)
			clickBlock: [:row | self tellMeMoreAbout: row];
			sortBlock: [:a :b | a  <= b ];
			hasTotal: true;
			 yourself);   
		add: ((ShoreTableColumn selector: #factorial title: 'factorial' translated)
			hasTotal: true;
			styleBlock: [:rowItem | rowItem factorial  >=100 ifTrue: ['big'] ifFalse: [''] ];
			yourself);
		add: (ShoreTableColumn new 
			valueBlock: [:rowItem | rowItem even ifTrue: ['even' translated] ifFalse: ['odd' translated]];
			title: 'odd/even' translated;
			yourself);
		yourself.
	

	table := ShoreTable parent: self.
	table rows: rows; columns: columns.
	
	table renderFooter: true.

! !

!ShoreDemo1TableDemo2 methodsFor: 'accessing' stamp: 'pk 12/14/2005 20:46'!
pageTitle

	^ 'Table report enhanced demo'.! !

!ShoreDemo1TableDemo2 methodsFor: 'rendering' stamp: 'pk 12/14/2005 21:04'!
renderContentOn: html

	html heading: self pageTitle.
	
	html div class: #ShoreDemo1TableDemo2; with: [
		html render: table ].
	
	html heading: 'Component description' translated level: 2.
	ShoreTable renderDescriptionOn: html.! !

!ShoreDemo1TableDemo2 methodsFor: 'style' stamp: 'pk 6/18/2006 19:31'!
style
	^ '
.ShoreDemo1TableDemo2 th { background-color: #525252; color: white;}
.ShoreDemo1TableDemo2 th a { color: white;}
.ShoreDemo1TableDemo2 td {text-align: right;}
.ShoreDemo1TableDemo2 td.big {color: red; font-weight: bold;}
.ShoreDemo1TableDemo2 tr+tr>th {text-align: right}
.ShoreDemo1TableDemo2 tr.odd { background-color: #dfdffa}
.ShoreDemo1TableDemo2 tr.even { background-color: white}
'! !

!ShoreDemo1TableDemo2 methodsFor: 'rendering' stamp: 'pk 12/14/2005 20:53'!
tellMeMoreAbout: aNumber

	self inform: 'The number ' translated, aNumber printString , ' is a very pretty number.' translated! !

ShoreDemo1Page subclass: #ShoreDemo1TableDemo3
	instanceVariableNames: 'table'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo1'!

!ShoreDemo1TableDemo3 class methodsFor: 'as yet unclassified' stamp: 'pk 6/18/2006 20:11'!
initialize

	self registerToMenu
! !

!ShoreDemo1TableDemo3 class methodsFor: 'as yet unclassified' stamp: 'pk 6/18/2006 20:29'!
menuName

	^ 'Live table' translated! !

!ShoreDemo1TableDemo3 methodsFor: 'accessing' stamp: 'pk 6/18/2006 20:11'!
children

	^ Array with: table! !

!ShoreDemo1TableDemo3 methodsFor: 'initialization' stamp: 'pk 6/26/2006 11:13'!
initialize

	| rows columns |
   
	super initialize.
 
	rows := Smalltalk allClasses select: [:class | class name beginsWith: 'Shore' ].
	columns := OrderedCollection new
		add: ((ShoreTableColumn selector: #superclass title: 'superclass' translated)
			sortBlock: [:a :b | 
				a name compare: b name ];
			yourself);	
		add: ((ShoreTableColumn selector: #yourself title: 'class' translated)
			clickBlock: [:row | self inform: row];
			sortBlock: [:a :b | 
				a name compare: b name ];
			yourself);
		add: ((ShoreTableColumn selector: #hasMethods title: 'has methods' translated)
			sortBlock: [:a :b | 
				a displayString compare: b displayString ];
			yourself);		
	yourself.
	

	table := ShoreLiveTable parent: self.
	table rows: rows; columns: columns.
	table previewBlock: [:html :row | 
		html html: (row definition asXHtml) ].

	table actionsBlock: [:html |
		table renderSelectAllAnchorOn: html.
		html separator.
		table renderSelectNoneAnchorOn: html.
		html separator.
		html anchor callback: [ self inform: table selection];
			text: 'show selected' translated. ].
	

! !

!ShoreDemo1TableDemo3 methodsFor: 'accessing' stamp: 'pk 6/21/2006 16:45'!
pageTitle

	^ 'Live table demo'.! !

!ShoreDemo1TableDemo3 methodsFor: 'rendering' stamp: 'pk 6/18/2006 20:11'!
renderContentOn: html

	html heading: self pageTitle.
	
	html div class: #ShoreDemo1TableDemo2; with: [
		html render: table ].
	
	html heading: 'Component description' translated level: 2.
	ShoreTable renderDescriptionOn: html.! !

!ShoreDemo1TableDemo3 methodsFor: 'style' stamp: 'pk 6/24/2006 13:57'!
style
	^ '

.ShoreDemo1TableDemo2 table { 
	border-left: 1px solid #e7dfce;
	border-top: 1px solid #e7dfce;
}


.ShoreDemo1TableDemo2 th { 
	margin: 0px;
	padding: 2px;
	background-color: #efebde; 
	color: black;
	border-right: 1px solid #a5aa94;
	border-bottom: 3px solid #cec7bd;
 }

.ShoreDemo1TableDemo2 th img { 
	padding-left: 5px;
 }

.shoreLiveTableSelector { 
	margin: 0px;
}

.ShoreDemo1TableDemo2 th:hover { 
	margin: 0px;
	padding: 2px;
	background-color: #f8f5ed; 
	color: black;
	border-right: 1px solid #a5aa94;
	border-bottom: 3px solid #f6cd4f;
 }

.shoreTableColumnSortIndex {
	color: #a5aa94;
	padding-left: 3px;
}

.sortable { 
	cursor: pointer;
 }


.ShoreDemo1TableDemo2 td {
	border-right: 1px solid #e7dfce;
	border-bottom: 1px solid #e7dfce;
	text-align: left;
}
.ShoreDemo1TableDemo2 td.big {color: red; font-weight: bold;}
.ShoreDemo1TableDemo2 tr+tr>th {text-align: right}
.ShoreDemo1TableDemo2 tr.odd { background-color: #fbf8f0}
.ShoreDemo1TableDemo2 tr.even { background-color: white}

.shoreLiveTableOffset {
	background-color: white;
}

.shoreLiveTableGroup {
	font-weight: bold;
}

.shoreLiveTableGroupHeader {
	width: 15px;
}

'! !

!ShoreDemo1TableDemo3 methodsFor: 'rendering' stamp: 'pk 6/18/2006 20:11'!
tellMeMoreAbout: aNumber

	self inform: 'The number ' translated, aNumber printString , ' is a very pretty number.' translated! !

ShoreDemo1Page subclass: #ShoreDemo1TableDemo4
	instanceVariableNames: 'table'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo1'!

!ShoreDemo1TableDemo4 class methodsFor: 'as yet unclassified' stamp: 'pk 6/24/2006 14:15'!
initialize

	self registerToMenu
! !

!ShoreDemo1TableDemo4 class methodsFor: 'as yet unclassified' stamp: 'pk 6/24/2006 14:16'!
menuName

	^ 'Grouping live table' translated! !

!ShoreDemo1TableDemo4 methodsFor: 'accessing' stamp: 'pk 6/24/2006 14:15'!
children

	^ Array with: table! !

!ShoreDemo1TableDemo4 methodsFor: 'initialization' stamp: 'pk 6/26/2006 11:13'!
initialize

	| rows columns |
   
	super initialize.
 
	rows := Smalltalk allClasses select: [:class | class name beginsWith: 'Shore' ].
	columns := OrderedCollection new
		add: ((ShoreTableColumn selector: #superclass title: 'superclass' translated)
			sortBlock: [:a :b | 
				a name compare: b name ];
			groupBy: true;
			visible: false;
			yourself);	
		add: ((ShoreTableColumn selector: #yourself title: 'class' translated)
			clickBlock: [:row | self inform: row];
			sortBlock: [:a :b | 
				a name compare: b name ];
			yourself);
		add: ((ShoreTableColumn selector: #hasMethods title: 'has methods' translated)
			sortBlock: [:a :b | 
				a displayString compare: b displayString ];
			yourself);		
	yourself.
	

	table := ShoreLiveTable parent: self.
	table rows: rows; columns: columns.
	table previewBlock: [:html :row | 
		html html: (row definition asXHtml) ].
	
	table actionsBlock: [:html |
		table renderSelectAllAnchorOn: html.
		html separator.
		table renderSelectNoneAnchorOn: html.
		html separator.
		html anchor callback: [ self inform: table selection];
			text: 'show selected' translated. ].
	

! !

!ShoreDemo1TableDemo4 methodsFor: 'accessing' stamp: 'pk 6/24/2006 14:15'!
pageTitle

	^ 'Grouping live table demo'.! !

!ShoreDemo1TableDemo4 methodsFor: 'rendering' stamp: 'pk 6/24/2006 14:15'!
renderContentOn: html

	html heading: self pageTitle.
	
	html div class: #ShoreDemo1TableDemo2; with: [
		html render: table ].
	
	html heading: 'Component description' translated level: 2.
	ShoreTable renderDescriptionOn: html.! !

!ShoreDemo1TableDemo4 methodsFor: 'style' stamp: 'pk 6/24/2006 14:15'!
style
	^ '

.ShoreDemo1TableDemo2 table { 
	border-left: 1px solid #e7dfce;
	border-top: 1px solid #e7dfce;
}


.ShoreDemo1TableDemo2 th { 
	margin: 0px;
	padding: 2px;
	background-color: #efebde; 
	color: black;
	border-right: 1px solid #a5aa94;
	border-bottom: 3px solid #cec7bd;
 }

.ShoreDemo1TableDemo2 th img { 
	padding-left: 5px;
 }

.shoreLiveTableSelector { 
	margin: 0px;
}

.ShoreDemo1TableDemo2 th:hover { 
	margin: 0px;
	padding: 2px;
	background-color: #f8f5ed; 
	color: black;
	border-right: 1px solid #a5aa94;
	border-bottom: 3px solid #f6cd4f;
 }

.shoreTableColumnSortIndex {
	color: #a5aa94;
	padding-left: 3px;
}

.sortable { 
	cursor: pointer;
 }


.ShoreDemo1TableDemo2 td {
	border-right: 1px solid #e7dfce;
	border-bottom: 1px solid #e7dfce;
	text-align: left;
}
.ShoreDemo1TableDemo2 td.big {color: red; font-weight: bold;}
.ShoreDemo1TableDemo2 tr+tr>th {text-align: right}
.ShoreDemo1TableDemo2 tr.odd { background-color: #fbf8f0}
.ShoreDemo1TableDemo2 tr.even { background-color: white}

.shoreLiveTableOffset {
	background-color: white;
}

.shoreLiveTableGroup {
	font-weight: bold;
}

.shoreLiveTableGroupHeader {
	width: 15px;
}

'! !

ShoreDemo1Page subclass: #ShoreDemo1TableDemo5
	instanceVariableNames: 'table'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo1'!

!ShoreDemo1TableDemo5 class methodsFor: 'as yet unclassified' stamp: 'pk 6/24/2006 14:17'!
initialize

	self registerToMenu
! !

!ShoreDemo1TableDemo5 class methodsFor: 'as yet unclassified' stamp: 'pk 6/24/2006 14:17'!
menuName

	^ 'Grouping live table 2' translated! !

!ShoreDemo1TableDemo5 methodsFor: 'accessing' stamp: 'pk 6/24/2006 14:17'!
children

	^ Array with: table! !

!ShoreDemo1TableDemo5 methodsFor: 'initialization' stamp: 'pk 6/26/2006 11:13'!
initialize

	| rows columns |
   
	super initialize.
 
	rows := Smalltalk allClasses select: [:class | class name beginsWith: 'Shore' ].
	columns := OrderedCollection new
		add: ((ShoreTableColumn selector: #yourself title: 'class' translated)
			clickBlock: [:row | self inform: row];
			sortBlock: [:a :b | 
				a name compare: b name ];
			yourself);
		add: ((ShoreTableColumn selector: #hasMethods title: 'has methods' translated)
			sortBlock: [:a :b | 
				a displayString compare: b displayString ];
			groupBy: true;
			yourself);		
		add: ((ShoreTableColumn selector: #superclass title: 'superclass' translated)
			sortBlock: [:a :b | 
				a name compare: b name ];
			groupBy: true;
			yourself);	
	yourself.
	

	table := ShoreLiveTable parent: self.
	table rows: rows; columns: columns.
	table previewBlock: [:html :row | 
		html html: (row definition asXHtml) ].
	
	table actionsBlock: [:html |
		table renderSelectAllAnchorOn: html.
		html separator.
		table renderSelectNoneAnchorOn: html.
		html separator.
		html anchor callback: [ self inform: table selection];
			text: 'show selected' translated. ].
	

! !

!ShoreDemo1TableDemo5 methodsFor: 'accessing' stamp: 'pk 6/24/2006 14:17'!
pageTitle

	^ 'Grouping live table demo 2'.! !

!ShoreDemo1TableDemo5 methodsFor: 'rendering' stamp: 'pk 6/24/2006 14:17'!
renderContentOn: html

	html heading: self pageTitle.
	
	html div class: #ShoreDemo1TableDemo2; with: [
		html render: table ].
	
	html heading: 'Component description' translated level: 2.
	ShoreTable renderDescriptionOn: html.! !

!ShoreDemo1TableDemo5 methodsFor: 'style' stamp: 'pk 6/24/2006 14:17'!
style
	^ '

.ShoreDemo1TableDemo2 table { 
	border-left: 1px solid #e7dfce;
	border-top: 1px solid #e7dfce;
}


.ShoreDemo1TableDemo2 th { 
	margin: 0px;
	padding: 2px;
	background-color: #efebde; 
	color: black;
	border-right: 1px solid #a5aa94;
	border-bottom: 3px solid #cec7bd;
 }

.ShoreDemo1TableDemo2 th img { 
	padding-left: 5px;
 }

.shoreLiveTableSelector { 
	margin: 0px;
}

.ShoreDemo1TableDemo2 th:hover { 
	margin: 0px;
	padding: 2px;
	background-color: #f8f5ed; 
	color: black;
	border-right: 1px solid #a5aa94;
	border-bottom: 3px solid #f6cd4f;
 }

.shoreTableColumnSortIndex {
	color: #a5aa94;
	padding-left: 3px;
}

.sortable { 
	cursor: pointer;
 }


.ShoreDemo1TableDemo2 td {
	border-right: 1px solid #e7dfce;
	border-bottom: 1px solid #e7dfce;
	text-align: left;
}
.ShoreDemo1TableDemo2 td.big {color: red; font-weight: bold;}
.ShoreDemo1TableDemo2 tr+tr>th {text-align: right}
.ShoreDemo1TableDemo2 tr.odd { background-color: #fbf8f0}
.ShoreDemo1TableDemo2 tr.even { background-color: white}

.shoreLiveTableOffset {
	background-color: white;
}

.shoreLiveTableGroup {
	font-weight: bold;
}

.shoreLiveTableGroupHeader {
	width: 15px;
}

'! !

ShoreDemo1Page subclass: #ShoreDemo1WebTree
	instanceVariableNames: 'tree'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo1'!

!ShoreDemo1WebTree commentStamp: '<historical>' prior: 0!
This class represents an example for html based tree views.!

!ShoreDemo1WebTree class methodsFor: 'as yet unclassified' stamp: 'pk 5/17/2006 16:25'!
initialize

	self registerToMenu
! !

!ShoreDemo1WebTree class methodsFor: 'as yet unclassified' stamp: 'pk 5/17/2006 16:18'!
menuName

	^ 'Tree' translated! !

!ShoreDemo1WebTree class methodsFor: 'private' stamp: 'pk 12/14/2005 18:08'!
nodeFor: anObject 

	^ ShoreWebTreeNode for: anObject! !

!ShoreDemo1WebTree class methodsFor: 'private' stamp: 'tbn 7/8/2005 17:23'!
simpleTreeFor: anArray

	^(self nodeFor: anArray first)
		addChild: (self nodeFor: anArray second);
		addChild: (self nodeFor: anArray last);
		yourself
	! !

!ShoreDemo1WebTree class methodsFor: 'examples' stamp: 'tbn 7/8/2005 17:19'!
webTree1
 
	^ OrderedCollection new
		add: (self simpleTreeFor: #('A' 'D' 'E' ));
		
		add: (self simpleTreeFor: #('B' 'F' 'G' ));
		
		add: (self nodeFor: 'Z');
		
		add: (self simpleTreeFor: #('C' 'H' 'I' ));
		 yourself! !

!ShoreDemo1WebTree class methodsFor: 'examples' stamp: 'tbn 7/8/2005 17:19'!
webTree2
 
	^OrderedCollection new
		add: (self simpleTreeFor: #('A' 'D' 'E'));
		add: (self simpleTreeFor: #('B' 'F' 'G'));		
		add: (self simpleTreeFor: #('C' 'H' 'I'));
		add: (self nodeFor: 'Z');
		yourself! !

!ShoreDemo1WebTree class methodsFor: 'examples' stamp: 'tbn 7/8/2005 17:19'!
webTree3
 
	
	^OrderedCollection 
		with: (self simpleTreeFor: #('A' 'D' 'E')) 		 
	 

	
	
	! !

!ShoreDemo1WebTree class methodsFor: 'examples' stamp: 'tbn 7/8/2005 17:19'!
webTree4
 
	|node|
	node := self simpleTreeFor: #('B' 'F' 'G').	
	node addChild: (self simpleTreeFor: #('J' 'K' 'L')).
	^OrderedCollection new
		add: (self simpleTreeFor: #('A' 'D' 'E'));
		add: node;
		add: (self nodeFor: 'Z');
		add: (self simpleTreeFor: #('C' 'H' 'I'));
		yourself


	
	! !

!ShoreDemo1WebTree class methodsFor: 'examples' stamp: 'tbn 7/8/2005 17:27'!
webTree5
 
	^ OrderedCollection with: ShoreWebTreeNode smalltalkHierarchy! !

!ShoreDemo1WebTree methodsFor: 'hierarchy' stamp: 'pk 12/14/2005 18:18'!
children

	^ Array with: tree! !

!ShoreDemo1WebTree methodsFor: 'interface creation' stamp: 'pk 12/14/2005 18:11'!
createTreeView1

	^ (self treeComponentClass parent: self)
		 rootNodes: self testTreeProvider webTree1;
		 yourself! !

!ShoreDemo1WebTree methodsFor: 'interface creation' stamp: 'pk 12/14/2005 18:12'!
createTreeView2

	^ (self treeComponentClass parent: self)
		 rootNodes: self testTreeProvider webTree2;
		 yourself! !

!ShoreDemo1WebTree methodsFor: 'interface creation' stamp: 'pk 12/14/2005 18:12'!
createTreeView3

	^ (self treeComponentClass parent: self)
		 rootNodes: self testTreeProvider webTree3;
		 yourself! !

!ShoreDemo1WebTree methodsFor: 'interface creation' stamp: 'pk 12/14/2005 18:12'!
createTreeView4

	^ (self treeComponentClass parent: self)
		rootNodes: self testTreeProvider webTree4;			
		yourself! !

!ShoreDemo1WebTree methodsFor: 'interface creation' stamp: 'pk 12/14/2005 18:12'!
createTreeView5

	^ (self treeComponentClass parent: self)
		 rootNodes: self testTreeProvider webTree5;
		 yourself! !

!ShoreDemo1WebTree methodsFor: 'initialization' stamp: 'pk 12/14/2005 18:11'!
initialize

	super initialize.
	
	tree := ShoreComponent parent: self.! !

!ShoreDemo1WebTree methodsFor: 'accessing' stamp: 'pk 7/18/2005 12:31'!
pageTitle

	^ 'Sample Trees' translated! !

!ShoreDemo1WebTree methodsFor: 'rendering' stamp: 'pk 12/14/2005 18:20'!
renderContentOn: html 

	html heading: self pageTitle.
	
	html unorderedList list: (Array 
		with: [ html anchor callback: [tree show: self createTreeView1 ]; text: 'Sample tree 1'.]
		with: [ html anchor callback: [tree show: self createTreeView2 ]; text: 'Sample tree 2'.]
		with: [ html anchor callback: [tree show: self createTreeView3 ]; text: 'Sample tree 3'.]
		with: [ html anchor callback: [tree show: self createTreeView4 ]; text: 'Sample tree 4'.]
		with: [ html anchor callback: [tree show: self createTreeView5 ]; text: 'Smalltalk Hierarchy'.]).
		
	html render: tree.

	html heading: 'Component description' translated level: 2.
	ShoreWebTree renderDescriptionOn: html.! !

!ShoreDemo1WebTree methodsFor: 'attributes' stamp: 'tbn 7/8/2005 17:20'!
testTreeProvider
	"Returns an object providing access to test examples for trees"

	^self class! !

!ShoreDemo1WebTree methodsFor: 'attributes' stamp: 'pk 12/14/2005 16:44'!
treeComponentClass
	"Returns the component used for rendering trees"

	^ShoreWebTree! !

ShoreComponent subclass: #ShoreDemo1Root
	instanceVariableNames: 'panel target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo1'!

!ShoreDemo1Root methodsFor: 'accessing' stamp: 'pk 4/11/2006 11:20'!
children

	^ Array with: panel with: target ! !

!ShoreDemo1Root methodsFor: 'initialization' stamp: 'pk 10/31/2005 16:43'!
initialize

	| path |

	super initialize.

	self pageTitle: 'Simple demo'.

	panel := ShoreXPPanel parent: self.
	panel addSection: (ShoreDemo1DemosMenu parent: panel) .
	panel addSection: (ShoreDemo1SimpleComponent parent: panel) .

	target := ShoreDemo1Introduction  parent: self.

	path := self session currentRequest url allButFirst: self session application basePath size.
	(path notEmpty and: [ path ~= '/' ]) 
		ifTrue: [ self processStatic: path allButFirst].



	! !

!ShoreDemo1Root methodsFor: 'initialization' stamp: 'pk 4/23/2006 20:49'!
processStatic: path 

	| classMapping |

	classMapping := ShoreDemo1DemosMenu demoMapping  
		detect: [:association | association value = path ] 
		ifNone: [ ^ self].

	self target show: ((Smalltalk at: classMapping value asSymbol) parent: self).
	



	! !

!ShoreDemo1Root methodsFor: 'rendering' stamp: 'pk 12/11/2005 12:34'!
renderContentOn: html

	html table layout with: [
		html tableRow with: [
			html tableData class: #leftPanel; with: [
				html div class: #leftPanel; with: [
					html render: panel ].].
	
			html tableData
				class: #main;
				attributeAt: #valign put: #top;
				with: [ html render: target] ] ].



! !

!ShoreDemo1Root methodsFor: 'style information' stamp: 'pk 7/3/2005 10:33'!
style

	^ '

.leftPanel {
	vertical-align: top;
	width: 220px;
	margin: 0px; 
	padding: 0px;
	height: 100%;
	background-color: rgb(116, 150, 226);

}

.main {
	width: 100%;
	padding: 5px;
	margin: 0px;
	margin-bottom: 0px;
	height: 100%;
	padding-bottom: 20px;
}





'! !

!ShoreDemo1Root methodsFor: 'hierarchy' stamp: 'pk 7/3/2005 10:35'!
target

	^ target.! !

ShoreComponent subclass: #ShoreDemo1SimpleComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo1'!

!ShoreDemo1SimpleComponent methodsFor: 'accessing' stamp: 'pk 6/30/2005 14:05'!
name

	^ 'Simple component'! !

!ShoreDemo1SimpleComponent methodsFor: 'rendering' stamp: 'pk 6/14/2006 10:33'!
renderContentOn: html

	html paragraph: 'This is a simple ShoreComponent' translated.

	html paragraph: 'Today: ' translated, Date today displayString.! !

ShoreComponent subclass: #ShoreDynamicPanel
	instanceVariableNames: 'sections id providers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Panels'!

!ShoreDynamicPanel methodsFor: 'sections' stamp: 'pk 4/23/2006 20:26'!
addSection: aComponent

	aComponent addDecoration: ShoreDynamicPanelDecoration new.
	sections add: aComponent.
! !

!ShoreDynamicPanel methodsFor: 'accessing' stamp: 'pk 4/23/2006 20:24'!
children

	^ sections! !

!ShoreDynamicPanel methodsFor: 'accessing' stamp: 'pk 4/23/2006 22:26'!
id
	"Answer the value of id"

	^ id! !

!ShoreDynamicPanel methodsFor: 'initialization' stamp: 'pk 5/17/2006 14:40'!
initialize
	"Initializes the receiver"

	super initialize.

	id := ShoreComponent newId.
	providers := Set with: self.
	"self session registerObjectForBacktracking: self. "
	
	sections := OrderedCollection new.
! !

!ShoreDynamicPanel methodsFor: 'accessing' stamp: 'pk 4/23/2006 22:04'!
providers

	^ providers! !

!ShoreDynamicPanel methodsFor: 'accessing' stamp: 'pk 5/17/2006 12:40'!
providers: anObject
	"Set the value of providers"

	providers := anObject! !

!ShoreDynamicPanel methodsFor: 'rendering' stamp: 'pk 6/29/2006 10:55'!
renderContentOn: html
	"renders the receivers content on the given html object"

	html unorderedList
		id: id;
		script: (html sortable
			constraint: false;
			dropOnEmpty: true;
			containment: (self providers collect: [:panel | panel id ]);
			onUpdate: (html updater
			"	id: id;"
				triggerSortable: id
					callback: [ :values | self sections: values]";
		       callback: [ :renderer | self renderSectionsOn: renderer ]"));
		class: #shorePanel;
		class: #shoreDynamicPanel;
		with: [ sections do: [ :section |
		"	section decoration class halt."
			html listItem 
				passenger: section;
				onClick: (html effect
					id: (section decoration id);
					perform: #pulsate);
				"onClick: (html updater
					callback: [:h |  ]);"
				with: [ html roundedDivColor: '#555577' top: true bottom: false with: [html div class: #shorePanelSectionHeader;class: #shoreDynamicPanelSectionHeader; with: section name ].
					html render: section]] ] . 
! !

!ShoreDynamicPanel methodsFor: 'rendering' stamp: 'pk 4/24/2006 00:25'!
renderSectionsOn: html

	 sections do: [ :section |
			 html listItem 
				passenger: section;
				with: [ html render: section name.
					html render: section]] ! !

!ShoreDynamicPanel methodsFor: 'accessing' stamp: 'pk 4/23/2006 22:26'!
sections
	"Answer the value of sections"

	^ sections! !

!ShoreDynamicPanel methodsFor: 'accessing' stamp: 'pk 5/17/2006 12:40'!
sections: anObject
	"Set the value of sections"

	sections := anObject! !

ShoreComponent subclass: #ShoreFormDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Dialogs'!

ShoreFormDialog subclass: #ShoreFormDialogWithResult
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Dialogs'!

!ShoreFormDialogWithResult methodsFor: 'rendering' stamp: 'tbn 7/11/2005 21:40'!
renderBackButtonOn: html
! !

ShoreFormDialogWithResult subclass: #ShoreGetStringDialog
	instanceVariableNames: 'message string'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Dialogs'!

!ShoreGetStringDialog methodsFor: 'accessing' stamp: 'pk 11/1/2005 10:11'!
initialize

	super initialize.

	string := String new.! !

!ShoreGetStringDialog methodsFor: 'accessing' stamp: 'pk 11/1/2005 10:07'!
message
	"Returns the receivers message"

	^message! !

!ShoreGetStringDialog methodsFor: 'accessing' stamp: 'pk 11/1/2005 10:07'!
message: anObject
	"Sets the receivers message"

	message := anObject! !

!ShoreGetStringDialog methodsFor: 'rendering' stamp: 'pk 6/29/2006 10:26'!
renderDialogOn: html
	"Render the receiver as a dialog on the given html object"

	html paragraph: [
		html text: self message. 
		html break.
		html textInput
			class: #shoreFormDialogTextInput;
			class: #shoreFormInput;
			on: #string of: self.].

	html buttons: [
		html submitButton callback: [ self answer: string ]; text: 'OK' translated. ] ! !

!ShoreGetStringDialog methodsFor: 'accessing' stamp: 'pk 11/1/2005 10:08'!
string
	^string! !

!ShoreGetStringDialog methodsFor: 'accessing' stamp: 'pk 11/1/2005 10:08'!
string: anObject
	string := anObject! !

!ShoreGetStringDialog methodsFor: 'accessing' stamp: 'pk 11/1/2005 10:09'!
title
	"Returns the receivers title"

	^ 'Input' translated .! !

ShoreFormDialogWithResult subclass: #ShoreInformDialog
	instanceVariableNames: 'message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Dialogs'!

ShoreInformDialog subclass: #ShoreConfirmDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Dialogs'!

!ShoreConfirmDialog methodsFor: 'rendering' stamp: 'pk 12/11/2005 14:03'!
renderDialogOn: html
	"Renders the receiver as a dialog on the given html object"

	html paragraph: [
		html text: self message. ].

	html buttons: [
		html submitButton callback: [ self answer: true ]; text: 'Yes' translated.
		html space.
		html submitButton callback: [ self answer: false ]; text: 'No' translated. ]! !

!ShoreConfirmDialog methodsFor: 'accessing' stamp: 'tbn 7/11/2005 21:37'!
title
	"Returns the receivers title"

	^ 'Confirmation' translated! !

ShoreInformDialog subclass: #ShoreErrorDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Dialogs'!

!ShoreErrorDialog methodsFor: 'accessing' stamp: 'tbn 7/11/2005 21:38'!
title
	"Returns the receivers title"

	^ 'Error' translated .! !

!ShoreInformDialog methodsFor: 'accessing' stamp: 'tbn 7/11/2005 21:41'!
message
	"Returns the receivers message"

	^message! !

!ShoreInformDialog methodsFor: 'accessing' stamp: 'tbn 7/11/2005 21:41'!
message: anObject
	"Sets the receivers message"

	message := anObject! !

!ShoreInformDialog methodsFor: 'rendering' stamp: 'pk 12/11/2005 14:02'!
renderDialogOn: html
	"Render the receiver as a dialog on the given html object"

	html paragraph: [
		html text: self message. ].

	html buttons: [
		html submitButton 
			callback: [ self answer ];
			text: 'OK' translated. ]! !

!ShoreInformDialog methodsFor: 'accessing' stamp: 'tbn 7/11/2005 21:41'!
title
	"Returns the receivers title"

	^ 'Information' translated .! !

!ShoreFormDialog methodsFor: 'initialization' stamp: 'pk 7/3/2005 09:40'!
initialize

	super initialize.
! !

!ShoreFormDialog methodsFor: 'accessing' stamp: 'tbn 7/11/2005 21:38'!
pageTitle
	"Returns the receivers page title"

	^ self title.! !

!ShoreFormDialog methodsFor: 'rendering' stamp: 'tbn 7/11/2005 21:39'!
renderBackButtonOn: html
	"Render a back button on the given html object"

	html anchorWithAction: [ self answer ] text: ( '<< Back' translated  ) ! !

!ShoreFormDialog methodsFor: 'rendering' stamp: 'pk 6/29/2006 10:28'!
renderContentOn: html
	"Renders the receivers content on the given html object"

	html div class: #shoreFormDialog; class: #shoreForm; with: [
		html table with: [
			html tableRow with: [
				html tableData with:  [ 
					html div 
						class: #shoreFormButton; 
						class: #shoreBackButton; 
						with: [ self renderBackButtonOn: html ] ].
				html tableData with: [
					html heading: self title.] ] ].
		html form with: [self renderDialogOn: html] ].
! !

!ShoreFormDialog methodsFor: 'rendering' stamp: 'tbn 7/11/2005 21:40'!
renderDialogOn: html
	"Render the receiver as form dialog on the given html object"! !

!ShoreFormDialog methodsFor: 'accessing' stamp: 'tbn 7/11/2005 21:39'!
title
	"Returns the receivers title"

	^ 'Dialog' translated.! !

ShoreComponent subclass: #ShoreList
	instanceVariableNames: 'data itemBlock filterText showItemBlock id onClickBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Lists'!

ShoreList subclass: #ShoreDemo3FullHeightList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo3'!

!ShoreDemo3FullHeightList methodsFor: 'as yet unclassified' stamp: 'pk 5/17/2006 14:39'!
renderContentOn: html 

	| script script2 divId |

	divId := ShoreComponent newId.

	script := '
		if (resizedElement) {
			resizedElement.style.height = resizedElement.parentNode.clientHeight -2 + "px";
		}'.

	script2 := '
		if (resizedElement) {
			resizedElement.style.height = resizedElement.parentNode.clientHeight -24 + "px";
		}'.

	html div id: divId; class: #shoreBatchedList; onResize: script; with: [
		self renderFiltersOn: html. 
		html div id: id; class: #shoreLisData; onResize: script2; with: [ self renderComponentOn: html ].
	].

	html registerOnResizeHandlerFor: divId.
	html registerOnResizeHandlerFor: id.
! !

!ShoreList methodsFor: 'accessing' stamp: 'pk 5/1/2006 09:16'!
data
	^data! !

!ShoreList methodsFor: 'accessing' stamp: 'pk 5/17/2006 20:41'!
data: anObject

	data := anObject
	! !

!ShoreList methodsFor: 'accessing' stamp: 'pk 5/1/2006 09:16'!
filteredData
	"This needs to be more generic, since we do not always batch on classes"

	(filterText isEmptyOrNil or: [self showItemBlock isNil]) 
		ifTrue: [^data]
		ifFalse: [^data select: [:e | self showItemBlock value: e value: filterText]]! !

!ShoreList methodsFor: 'initialization' stamp: 'pk 5/17/2006 14:40'!
initialize 

	super initialize. 

	self session registerObjectForBacktracking: self. 

	id := ShoreComponent newId.
! !

!ShoreList methodsFor: 'accessing' stamp: 'pk 5/1/2006 09:16'!
itemBlock
	^itemBlock! !

!ShoreList methodsFor: 'accessing' stamp: 'pk 5/1/2006 09:16'!
itemBlock: anObject
	itemBlock := anObject! !

!ShoreList methodsFor: 'accessing' stamp: 'pk 5/1/2006 10:22'!
onClickBlock
	^onClickBlock! !

!ShoreList methodsFor: 'accessing' stamp: 'pk 5/1/2006 10:22'!
onClickBlock: anObject
	onClickBlock := anObject! !

!ShoreList methodsFor: 'rendering' stamp: 'pk 5/1/2006 09:23'!
renderComponentOn: html 

	| pageData |
	
	pageData := self filteredData.
	self renderPageData: pageData on: html.
! !

!ShoreList methodsFor: 'rendering' stamp: 'pk 6/29/2006 11:58'!
renderContentOn: html 

	html div class: #shoreComponent;  class: #shoreBatchedList; with: [
		self renderFiltersOn: html. 
		html div id: id; class: #shoreLisData; with: [ self renderComponentOn: html ].
	].

! !

!ShoreList methodsFor: 'rendering' stamp: 'pk 6/29/2006 11:32'!
renderFiltersOn: html 

	| script inputId |

	inputId := ShoreComponent newId. 
	script := '
		if (resizedElement && !!document.all) {
			resizedElement.style.width = resizedElement.parentNode.scrollWidth-70 + "px";
		}'.

	showItemBlock ifNotNil: 
		[ html form class: #shoreComponentImportantPart; class: #shoreBatchedListFilter; with: [ 
			html textInput id: inputId; onResize: script; class: #shoreComponentInput; class: #shoreBatchedListFilterInput; callback: [:v |
				filterText := v.
					(filterText beginsWith: '*') 
						ifFalse: [filterText size > 1 ifTrue: [filterText := '*' , filterText]].
					(filterText endsWith: '*') 
						ifFalse: [filterText size > 1 ifTrue: [filterText := filterText , '*']]].
			html submitButton class: #shoreComponentButton; class: #shoreBatchedListFilterButton; text: 'Filter On']].

	html registerOnResizeHandlerFor: inputId.
! !

!ShoreList methodsFor: 'rendering' stamp: 'pk 6/14/2006 10:34'!
renderPageData: pageData on: html 

	| itemDiv |

	pageData do: [:item | 
		html div: [
			itemDiv := html div class: #shoreBatchedListItem.
			onClickBlock ifNotNil: [
				itemDiv onClickAction: [ onClickBlock value: item ].
				itemDiv style: 'cursor: pointer'].
			itemDiv with: [
				itemBlock 
					ifNil: [html text: item displayString]
					ifNotNil: [itemBlock value: item value: html]]]]

! !

!ShoreList methodsFor: 'accessing' stamp: 'pk 5/1/2006 09:16'!
showItemBlock
	^ showItemBlock! !

!ShoreList methodsFor: 'accessing' stamp: 'pk 5/1/2006 09:16'!
showItemBlock: aBlock
	showItemBlock := aBlock! !

ShoreComponent subclass: #ShorePageHeader
	instanceVariableNames: 'title subtitle image'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Hierarchy'!

!ShorePageHeader methodsFor: 'accessing' stamp: 'pk 7/2/2005 23:00'!
image
	^image! !

!ShorePageHeader methodsFor: 'accessing' stamp: 'pk 7/2/2005 23:00'!
image: anObject
	image := anObject! !

!ShorePageHeader methodsFor: 'initialization' stamp: 'tbn 7/11/2005 21:50'!
initialize
	"Initializes the receiver"

	super initialize.
	self session registerObjectForBacktracking: self.

	title := 'Title' translated.
	subtitle := 'Subtitle' translated.
	image := nil.


	! !

!ShorePageHeader methodsFor: 'rendering' stamp: 'pk 12/11/2005 11:54'!
renderContentOn: html

	html div 
		class: #shorePageHeader; 
		style: (html backgroundImage: image );
		with: [
			html text: title; break.
			html div class: #shorePageHeaderSubtitle; with: subtitle ].

	! !

!ShorePageHeader methodsFor: 'accessing' stamp: 'pk 7/2/2005 23:00'!
subtitle
	^subtitle! !

!ShorePageHeader methodsFor: 'accessing' stamp: 'pk 7/2/2005 23:00'!
subtitle: anObject
	subtitle := anObject! !

!ShorePageHeader methodsFor: 'accessing' stamp: 'pk 7/2/2005 23:00'!
title
	^title! !

!ShorePageHeader methodsFor: 'accessing' stamp: 'pk 7/2/2005 23:00'!
title: anObject
	title := anObject! !

!ShorePageHeader methodsFor: 'initialization' stamp: 'tbn 7/11/2005 21:50'!
updateRoot: anHtmlRoot
	"Updates the root of the html document by adding the title and subtitle"	

	super updateRoot: anHtmlRoot.	
	anHtmlRoot title: (self title, ' - ', self subtitle).

	! !

ShoreComponent subclass: #ShorePanel
	instanceVariableNames: 'sections id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Panels'!

!ShorePanel methodsFor: 'sections' stamp: 'pk 5/7/2006 21:22'!
addSection: aComponent

	aComponent addDecoration: ShorePanelDecoration new.
	sections add: aComponent.
! !

!ShorePanel methodsFor: 'sections' stamp: 'pk 5/8/2006 18:47'!
addSection: aComponent enabled: aBoolean

	| decor |

	decor := ShorePanelDecoration new.
	decor enabled: aBoolean.

	aComponent addDecoration: decor.
	sections add: aComponent.
! !

!ShorePanel methodsFor: 'accessing' stamp: 'pk 5/7/2006 21:21'!
children

	^ sections! !

!ShorePanel methodsFor: 'accessing' stamp: 'pk 5/7/2006 21:21'!
id
	"Answer the value of id"

	^ id! !

!ShorePanel methodsFor: 'initialization' stamp: 'pk 5/17/2006 14:40'!
initialize
	"Initializes the receiver"

	super initialize.

	id := ShoreComponent newId.
	"self session registerObjectForBacktracking: self. "
	
	sections := OrderedCollection new.
! !

!ShorePanel methodsFor: 'rendering' stamp: 'pk 5/8/2006 14:14'!
renderContentOn: html
	"renders the receivers content on the given html object"

	html div
		id: id;
		class: #shoreDynamicPanel;
		with: [ 
			sections do: [ :section |
				html div with: [ html render: section]] ] . 
! !

!ShorePanel methodsFor: 'rendering' stamp: 'pk 5/7/2006 21:21'!
renderSectionsOn: html

	 sections do: [ :section |
			 html listItem 
				passenger: section;
				with: [ html render: section name.
					html render: section]] ! !

!ShorePanel methodsFor: 'accessing' stamp: 'pk 5/7/2006 21:21'!
sections
	"Answer the value of sections"

	^ sections! !

!ShorePanel methodsFor: 'accessing' stamp: 'pk 5/17/2006 12:42'!
sections: anObject
	"Set the value of sections"

	sections := anObject! !

ShoreComponent subclass: #ShoreRichEdit
	instanceVariableNames: 'content rtid valueHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Editors'!

!ShoreRichEdit class methodsFor: 'images' stamp: 'pk 5/6/2006 15:58'!
boldImage

^ ShoreMIMEDocument type: 'image/png' content:

 'iVBORw0KGgoAAAANSUhEUgAAABkAAAAYCAYAAAAPtVbGAAAAOUlEQVR4XmP4/5/2gOH/yLdk
5FsyYJYwMDDixVTzCTZDSbFoBFsy8uNk4C2hWz4Z+WXXyLdkhFsCAE/dpwVaD0JkAAAAAElF
TkSuQmCC'! !

!ShoreRichEdit class methodsFor: 'images' stamp: 'pk 5/6/2006 15:58'!
centreJustifyImage

^ ShoreMIMEDocument type: 'image/png' content:
 'iVBORw0KGgoAAAANSUhEUgAAABkAAAAYCAYAAAAPtVbGAAAANUlEQVR4XmP4/5/2gOH/yLdk
5FsCF2RgJAsP3uCi1AcjP05GfpyM/DgZCnEy8i0Z+ZZQBQAAlPyAOfo4O28AAAAASUVORK5C
YII='! !

!ShoreRichEdit class methodsFor: 'style' stamp: 'pk 7/3/2005 20:22'!
editorStyle

^ '

.rte {
	font-family: sans-serif;
	font-size: 9pt;
	background-color: white;
	padding: 2px;
	margin: 2px;
}

.rte p {
	margin: 0px;
	padding: 0px;
}

.rte li {
	margin: 0px;
	padding: 0px;
}

.rte ol {
	padding-top: 0px;
	padding-bottom: 0px;
	margin-top: 0px;
	margin-bottom: 0px;
}

.rte ul {
	padding-top: 0px;
	padding-bottom: 0px;
	margin-top: 0px;
	margin-bottom: 0px;
}

.rte BLOCKQUOTE {
	padding-top: 0px;
	padding-bottom: 0px;
	margin-top: 0px;
	margin-bottom: 0px;
}
'! !

!ShoreRichEdit class methodsFor: 'images' stamp: 'pk 5/6/2006 15:59'!
fullJustifyImage

^ ShoreMIMEDocument type: 'image/png' content:
 'iVBORw0KGgoAAAANSUhEUgAAABkAAAAYCAYAAAAPtVbGAAAAMElEQVR4XmP4/5/2gOH/yLdk
5FsCF2RgJAuPfJ+MfJ+MfJ+MfJ+M/FJ45Fsy5C0BALWjXGkwkJkBAAAAAElFTkSuQmCC'! !

!ShoreRichEdit class methodsFor: 'images' stamp: 'pk 5/6/2006 16:00'!
indentImage

^ ShoreMIMEDocument type: 'image/png' content:
 'iVBORw0KGgoAAAANSUhEUgAAABkAAAAYCAYAAAAPtVbGAAAATklEQVR4XmP4/5/2gOH/yLeE
VpYwMDAOQZ+AXI2MsYlhw4PRJw0EfUexT0CWoFtENUtghiNjmgYXsT6hS5yM/Hwy8D4Z+aXw
yK8ZR5glANQZfLrAh89LAAAAAElFTkSuQmCC'! !

!ShoreRichEdit class methodsFor: 'images' stamp: 'pk 5/6/2006 16:00'!
italicImage

^ ShoreMIMEDocument type: 'image/png' content:
 'iVBORw0KGgoAAAANSUhEUgAAABkAAAAYCAYAAAAPtVbGAAAAVklEQVR4XuXUMQoAIAxD0Xjz
3rzi4KRDUwkIEVz7+IoiU7+Q/og/8g0CjGNLSvbwiNCUrMHVgufjqlbQSKeCRjoVFNKtoJBu
RQm5vQvpnfj/Xf6IKTIBH6gCIao2vIUAAAAASUVORK5CYII='! !

!ShoreRichEdit class methodsFor: 'images' stamp: 'pk 5/6/2006 16:01'!
leftJustifyImage

^ ShoreMIMEDocument type: 'image/png' content:
 'iVBORw0KGgoAAAANSUhEUgAAABkAAAAYCAYAAAAPtVbGAAAAMklEQVR4XmP4/5/2gOH/yLdk
5FsCF2RgJAsPXZ+M/DgZ+XEy8uNkOMTJyLdk5FtCFQAAyI+AORc6ynsAAAAASUVORK5CYII='! !

!ShoreRichEdit class methodsFor: 'images' stamp: 'pk 5/6/2006 16:01'!
listImage

^ ShoreMIMEDocument type: 'image/png' content:
 'iVBORw0KGgoAAAANSUhEUgAAABkAAAAYCAYAAAAPtVbGAAAAN0lEQVR4XmP4/5/2gOH/yLdk
5FuCIsHQAMd0tYSBgZEgHnw+GfkRP/IjfuRH/MiP+JFvyXCxBABda8NWFW8K+wAAAABJRU5E
rkJggg=='! !

!ShoreRichEdit class methodsFor: 'documentation' stamp: 'pk 7/14/2005 23:40'!
maintainer

	^ 'Pavel Krivanek'! !

!ShoreRichEdit class methodsFor: 'images' stamp: 'pk 5/6/2006 16:02'!
numberedListImage

^ ShoreMIMEDocument type: 'image/png' content:
 'iVBORw0KGgoAAAANSUhEUgAAABkAAAAYCAYAAAAPtVbGAAAATElEQVR4XmP4/5/2gOH/yLdk
SFnCwNBAW0tAFqBbwsDASBAPXp9Qw6KBjXhq+YIonyBbNPIjfnBEPM19QpccT63IHxz5ZORb
MjwtAQCiItJEkr6wJwAAAABJRU5ErkJggg=='! !

!ShoreRichEdit class methodsFor: 'images' stamp: 'pk 5/6/2006 16:03'!
outdentImage

^ ShoreMIMEDocument type: 'image/png' content:
 'iVBORw0KGgoAAAANSUhEUgAAABkAAAAYCAYAAAAPtVbGAAAATElEQVR4XmP4/5/2gOH/yLeE
VpYwMDAOQZ+AXI2MsYlhw4PRJw0EfUeRT0AW0NQSmAXImCbBRapP6BInIz+fDLxPRn4pPPJr
xhFmCQCsSXy62PA3vgAAAABJRU5ErkJggg=='! !

!ShoreRichEdit class methodsFor: 'images' stamp: 'pk 5/6/2006 16:03'!
rightJustifyImage

^ ShoreMIMEDocument type: 'image/png' content: 'iVBORw0KGgoAAAANSUhEUgAAABkAAAAYCAYAAAAPtVbGAAAAMklEQVR4XmP4/5/2gOH/yLdk
5FuCIsHASBYe/ME1dH0y8uNk5MfJyI+TkW/JyLeEDgAAvRaAOSXgEKcAAAAASUVORK5CYII='! !

!ShoreRichEdit class methodsFor: 'images' stamp: 'pk 5/6/2006 16:04'!
ruleImage

^ ShoreMIMEDocument type: 'image/png' content:
 'iVBORw0KGgoAAAANSUhEUgAAABkAAAAYCAYAAAAPtVbGAAAANUlEQVR4XmP4/5/2gOH/yLdk
5Fsy8i0Z4ZYYGxuTjYm2ZObMmWTjkR/xI9+SkW/JyLeEDgAAYnIhXi6XUkkAAAAASUVORK5C
YII='! !

!ShoreRichEdit class methodsFor: 'documentation' stamp: 'pk 7/14/2005 23:42'!
shortDescription

	^ 'Rich editbox with text formating (simple WYSIWYG XHTML editor)'! !

!ShoreRichEdit class methodsFor: 'documentation' stamp: 'pk 7/14/2005 23:43'!
state

	^ 'usable, needs testing'! !

!ShoreRichEdit class methodsFor: 'documentation' stamp: 'pk 7/14/2005 23:48'!
todo

	^ '- check more rich edits on single page
- improve look
- text styles'! !

!ShoreRichEdit class methodsFor: 'images' stamp: 'pk 5/6/2006 16:04'!
underlineImage

^ ShoreMIMEDocument type: 'image/png' content: 'iVBORw0KGgoAAAANSUhEUgAAABkAAAAYCAYAAAAPtVbGAAAASklEQVR4XmP4/5/2gOH/yLdk
5FuCVQEDIwrGJUaxT7AZRqwFI9+SkW8JcZY0NDSA+SCa6pZgyxvEWjB4czw5Phr5pfDIt2SI
WwIAoNq+56FzBmUAAAAASUVORK5CYII='! !

!ShoreRichEdit class methodsFor: 'documentation' stamp: 'pk 7/14/2005 23:47'!
XHTMLValid

	^ true! !

!ShoreRichEdit methodsFor: 'accessing' stamp: 'pk 7/3/2005 16:55'!
content
	
	^content ifNil:['']
! !

!ShoreRichEdit methodsFor: 'accessing' stamp: 'pk 7/3/2005 16:55'!
content: anObject

	content := anObject! !

!ShoreRichEdit methodsFor: 'initialization' stamp: 'pk 5/17/2006 14:40'!
initialize
	"Initializes the receiver"

	super initialize.
	self session registerObjectForBacktracking: self. 
	
	rtid  := ShoreComponent newId.
	valueHolder := ShoreComponent newId.
	
	content = String new.
	
! !

!ShoreRichEdit methodsFor: 'rendering' stamp: 'pk 6/29/2006 09:29'!
renderButtonOn: html image: img id: aSymbol atl: alt action: action

	| imgPath |
	
	imgPath := (self fileProvider urlFor: 'ShoreRichEdit/', img).
	html image
		altText: alt;
		url: imgPath;
		onClick: 'FormatText(''', rtid, ''', ''', action, ''', '''')'.! !

!ShoreRichEdit methodsFor: 'rendering' stamp: 'pk 6/29/2006 09:32'!
renderButtonsOn: html

	html div class: #shoreRichEditButtons; with: [
		self renderButtonOn: html image: #boldImage id: #ShoreRichEditBoldImage 
			atl: 'bold' translated action: 'bold'.
		self renderButtonOn: html image: #italicImage id: #ShoreRichEditItalicImage 
			atl: 'italic' translated action: 'italic'.
		self renderButtonOn: html image: #underlineImage id: #ShoreRichEditUnderlineImage 
			atl: 'underline' translated action: 'underline'.
		
		self separatorOn: html.

		self renderButtonOn: html image: #leftJustifyImage id: #ShoreRichEditLeftJustifyImage 
			atl: 'left' translated action: 'justifyleft'.
		self renderButtonOn: html image: #centreJustifyImage id: #ShoreRichEditCentreJustifyImage 
			atl: 'centre' translated action: 'justifycenter'.
		self renderButtonOn: html image: #rightJustifyImage id: #ShoreRichEditRightJustifyImage 
			atl: 'right' translated action: 'justifyright'.
		self renderButtonOn: html image: #fullJustifyImage id: #ShoreRichEditFullJustifyImage 
			atl: 'full' translated action: 'justifyfull'.

		self separatorOn: html.

		self renderButtonOn: html image: #ruleImage id: #ShoreRichEditRulerImage 
			atl: 'horizontal rule' translated action: 'inserthorizontalrule'.

		self separatorOn: html.

		self renderButtonOn: html image: #numberedListImage id: #ShoreRichEditNumberedListImage 
			atl: 'numbered list' translated action: 'insertorderedlist'.
		self renderButtonOn: html image: #listImage id: #ShoreRichEditListImage 
			atl: 'list' translated action: 'insertunorderedlist'.

		self separatorOn: html.

		self renderButtonOn: html image: #outdentImage  id: #ShoreRichEditOutdentImage 
			atl: 'outdent' translated action: 'outdent'.
		self renderButtonOn: html image: #indentImage  id: #ShoreRichEditIndentImage 
			atl: 'indent' translated action: 'indent'.
	]


! !

!ShoreRichEdit methodsFor: 'rendering' stamp: 'pk 12/11/2005 18:31'!
renderContentOn: html

	| style |

	html form 
		attributeAt: #onSubmit put: 'updateRTEs();';
		with: [
		html  div class: #shoreRichEdit; with: [
			html hiddenInput
				id: valueHolder;
				value: self content;
				callback: [:val | self content: val].
	
			self renderButtonsOn: html.
			self renderIFrameOn: html.

			style := 	self sessionCacheAt: #ShoreRichEditStyle 
				ifAbsentPut: [html sessionEntryForDocument: self class editorStyle].

			html html: '<script language="JavaScript" type="text/javascript">
				initRTE("', style, '");
				registerRTE(''', rtid, ''', ''', valueHolder ,''');
				enableDesignMode(''', rtid, ''', false, ''', valueHolder ,''');
				</script>'.
		].
	].





! !

!ShoreRichEdit methodsFor: 'rendering' stamp: 'pk 12/11/2005 18:28'!
renderIFrameOn: html

	html div class: #shoreRichEditField; with: [
		html iframe
			class: #shoreRichEditEditor;
			scrolling: true;
			frameBorder: 0;
			id: rtid;
			name: rtid ].! !

!ShoreRichEdit methodsFor: 'java script' stamp: 'pk 7/3/2005 16:58'!
script 

	^ 
'// Cross-Browser Rich Text Editor
// http://www.kevinroth.com/rte/demo.htm
// Written by Kevin Roth (kevin@NOSPAMkevinroth.com - remove NOSPAM)
// Visit the support forums at http://www.kevinroth.com/forums/index.php?c=2

//init variables
var rng;
var currentRTE;
var allRTEs = "";
var allValueHolders = "";

var isGecko;
var isSafari;
var isKonqueror;

var cssFile;


function initRTE(css) {
	//set browser vars
	var ua = navigator.userAgent.toLowerCase();
	isGecko = (ua.indexOf("gecko") !!= -1);
	isSafari = (ua.indexOf("safari") !!= -1);
	isKonqueror = (ua.indexOf("konqueror") !!= -1);
	
	//set paths vars
	cssFile = css;
	
}

function registerRTE(rte, valueHolder) {
		if (allRTEs.length > 0) allRTEs += ";";
		if (allRTEs.length > 0) allValueHolders += ";";
		allRTEs += rte;
		allValueHolders += valueHolder;
}

function enableDesignMode(rte, readOnly, valueHolder) 
{
	var html = document.getElementById(valueHolder).value;
	
		var frameHtml = "<html id=\"" + rte + "\">\n";
	frameHtml += "<head>\n";
	//to reference your stylesheet, set href property below to your stylesheet path and uncomment
	if (cssFile.length > 0) {
		frameHtml += "<link media=\"all\" type=\"text/css\" href=\"" + cssFile + "\" rel=\"stylesheet\">\n";
	} else {
		frameHtml += "<style>\n";
		frameHtml += "body {\n";
		frameHtml += "	background: #FFFFFF;\n";
		frameHtml += "	margin: 0px;\n";
		frameHtml += "	padding: 0px;\n";
		frameHtml += "}\n";
		frameHtml += "</style>\n";
	}
	frameHtml += "</head>\n";
	frameHtml += "<body class=rte>\n";
	frameHtml +=  html + "\n";
	frameHtml += "</body>\n";
	frameHtml += "</html>";
	
	if (document.all) {
		var oRTE = frames[rte].document;
		oRTE.open();
		oRTE.write(frameHtml);
		oRTE.close();
		if (!!readOnly) oRTE.designMode = "On";
	} else {
		try {
			if (!!readOnly) document.getElementById(rte).contentDocument.designMode = "on";
			try {
				var oRTE = document.getElementById(rte).contentWindow.document;
				oRTE.open();
				oRTE.write(frameHtml);
				oRTE.close();
				if (isGecko && !!readOnly) {
					//attach a keyboard handler for gecko browsers to make keyboard shortcuts work
					oRTE.addEventListener("keypress", kb_handler, true);
				}
			} catch (e) {
				alert("Error preloading content.");
			}
		} catch (e) {
			//gecko may take some time to enable design mode.
			//Keep looping until able to set.
			if (isGecko) {
				var expr = "enableDesignMode(''" + rte + "'', " + readOnly + ", ''" + valueHolder + "'');";
				setTimeout(expr, 10);
			} else {
				return false;
			}
		}
	}
}

function updateRTEs() {
	var vRTEs = allRTEs.split(";");
	var vValueHolders = allValueHolders.split(";");
	for (var i = 0; i < vRTEs.length; i++) {
		updateRTE(vRTEs[i], vValueHolders[i]);
	}
}

function updateRTE(rte, valueHolder) 
{

	//set message value
	var oHdnMessage = document.getElementById(valueHolder);
	var oRTE = document.getElementById(rte);
	var readOnly = false;
	
	//check for readOnly mode
	if (document.all) {
		if (frames[rte].document.designMode !!= "On") readOnly = true;
	} else {
		if (document.getElementById(rte).contentDocument.designMode !!= "on") readOnly = true;
	}
	
	//if viewing source, switch back to design view
	
	if (oHdnMessage.value == null) oHdnMessage.value = "";
	if (document.all) {
		oHdnMessage.value = frames[rte].document.body.innerHTML;
	} else {
		oHdnMessage.value = oRTE.contentWindow.document.body.innerHTML;
	}
	
	//if there is no content (other than formatting) set value to nothing
	if (stripHTML(oHdnMessage.value.replace("&nbsp;", " ")) == "" 
		&& oHdnMessage.value.toLowerCase().search("<hr") == -1
		&& oHdnMessage.value.toLowerCase().search("<img") == -1) oHdnMessage.value = "";
	//fix for gecko
	if (escape(oHdnMessage.value) == "%3Cbr%3E%0D%0A%0D%0A%0D%0A") oHdnMessage.value = "";
	
}

//Function to format text in the text box
function FormatText(rte, command, option) {
	var oRTE;
	if (document.all) {
		oRTE = frames[rte];
		
		//get current selected range
		var selection = oRTE.document.selection; 
		if (selection !!= null) {
			rng = selection.createRange();
		}
	} else {
		oRTE = document.getElementById(rte).contentWindow;
		
		//get currently selected range
		var selection = oRTE.getSelection();
		rng = selection.getRangeAt(selection.rangeCount - 1).cloneRange();
	}
	
	try {
			oRTE.focus();
		  	oRTE.document.execCommand(command, false, option);
			oRTE.focus();
	} catch (e) {
		alert(e);
	}
}

function Select(rte, selectname) {
	var oRTE;
	if (document.all) {
		oRTE = frames[rte];
		
		//get current selected range
		var selection = oRTE.document.selection; 
		if (selection !!= null) {
			rng = selection.createRange();
		}
	} else {
		oRTE = document.getElementById(rte).contentWindow;
		
		//get currently selected range
		var selection = oRTE.getSelection();
		rng = selection.getRangeAt(selection.rangeCount - 1).cloneRange();
	}
	
	var idx = document.getElementById(selectname).selectedIndex;
	// First one is always a label
	if (idx !!= 0) {
		var selected = document.getElementById(selectname).options[idx].value;
		var cmd = selectname.replace(''_'' + rte, '''');
		oRTE.focus();
		oRTE.document.execCommand(cmd, false, selected);
		oRTE.focus();
		document.getElementById(selectname).selectedIndex = 0;
	}
}

function Replace(rte, text) {
	var oRTE;
	if (document.all) {
		oRTE = frames[rte];
		
		//get current selected range
		var selection = oRTE.document.selection; 
		if (selection !!= null) {
			rng = selection.createRange();
		}
	} else {
		oRTE = document.getElementById(rte).contentWindow;
		
		//get currently selected range
		var selection = oRTE.getSelection();
		rng = selection.getRangeAt(selection.rangeCount - 1).cloneRange();
	}
	
	var idx = document.getElementById(selectname).selectedIndex;
	// First one is always a label
	if (idx !!= 0) {
		var selected = text;
		var cmd = selectname.replace(''_'' + rte, '''');
		oRTE.focus();
		oRTE.document.execCommand(cmd, false, selected);
		oRTE.focus();
		document.getElementById(selectname).selectedIndex = 0;
	}
}

function kb_handler(evt) {
	var rte = evt.target.id;
	
	//contributed by Anti Veeranna (thanks Anti!!)
	if (evt.ctrlKey) {
		var key = String.fromCharCode(evt.charCode).toLowerCase();
		var cmd = '''';
		switch (key) {
			case ''b'': cmd = "bold"; break;
			case ''i'': cmd = "italic"; break;
			case ''u'': cmd = "underline"; break;
		};

		if (cmd) {
			FormatText(rte, cmd, true);
			//evt.target.ownerDocument.execCommand(cmd, false, true);
			// stop the event bubble
			evt.preventDefault();
			evt.stopPropagation();
		}
 	}
}


function stripHTML(oldString) {
	var newString = oldString.replace(/(<([^>]+)>)/ig,"");
	
	//replace carriage returns and line feeds
   newString = newString.replace(/\r\n/g," ");
   newString = newString.replace(/\n/g," ");
   newString = newString.replace(/\r/g," ");
	
	//trim string
	newString = trim(newString);
	
	return newString;
}

function trim(inputString) {
   // Removes leading and trailing spaces from the passed string. Also removes
   // consecutive spaces and replaces it with one space. If something besides
   // a string is passed in (null, custom object, etc.) then return the input.
   if (typeof inputString !!= "string") return inputString;
   var retValue = inputString;
   var ch = retValue.substring(0, 1);
	
   while (ch == " ") { // Check for spaces at the beginning of the string
      retValue = retValue.substring(1, retValue.length);
      ch = retValue.substring(0, 1);
   }
   ch = retValue.substring(retValue.length - 1, retValue.length);
	
   while (ch == " ") { // Check for spaces at the end of the string
      retValue = retValue.substring(0, retValue.length - 1);
      ch = retValue.substring(retValue.length - 1, retValue.length);
   }
	
	// Note that there are two spaces in the string - look for multiple spaces within the string
   while (retValue.indexOf("  ") !!= -1) {
		// Again, there are two spaces in each of the strings
      retValue = retValue.substring(0, retValue.indexOf("  ")) + retValue.substring(retValue.indexOf("  ") + 1, retValue.length);
   }
   return retValue; // Return the trimmed string back to the user
}

'! !

!ShoreRichEdit methodsFor: 'rendering' stamp: 'tbn 7/11/2005 21:53'!
separatorOn: html
	"Renders a separator on the given html object"

	html space; space.! !

ShoreComponent subclass: #ShoreRootComponent
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Kernel'!

ShoreRootComponent subclass: #ShoreDemo1
	instanceVariableNames: 'header root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo1'!

!ShoreDemo1 class methodsFor: 'as yet unclassified' stamp: 'pk 4/23/2006 18:39'!
applicationClass

	^ ShoreDemo1Application! !

!ShoreDemo1 class methodsFor: 'as yet unclassified' stamp: 'pk 5/16/2006 16:22'!
initialize

	" self initialize "

	self initializeApplication! !

!ShoreDemo1 class methodsFor: 'images' stamp: 'pk 5/6/2006 15:37'!
logo

	^ ShoreMIMEDocument type: 'image/png' content: 'iVBORw0KGgoAAAANSUhEUgAAACAAAAAgCAYAAABzenr0AAABq0lEQVR4XmMAgv8DjAeLAyo+
/Geo/08ezrz0n0HVG8NwZmaG/zIyDP89PRn+x8Ux/F+8GIKfPKGmAzwm/GdgZoMbKCTE8D85
meH/xYsM/4GyWPGHD9RygPc0uEGiogz/16/HbSn1HVD8/D8DCydYr5UVcRZT1wE+M8H62NlJ
s5x6DrCvA+tTVBwoB/jNGeAQKHgIT/3NzQPhABA2SIDn9zt3BsIBpa/+M/BIgPXz8TH8//yZ
3g4A4cTD8KhQVh4IB4Bw0FK4gY6OA+EAEHZqgRu6du1AOACEFZ3AZmloDJQDoHWDgMBAOcCy
CGyWktJAOACkn0sUbFZm5kA4QDcKbA4LC8P/b9/o7QDndriBU6fSOxs6NMIN8/enZ0FU8/M/
g3Ea3CAbG3rWBTk3/jPIWMIN8fWlZ23o1gtvijEyMvyvr6dXewDka3l7uEZ+fob/Bw+Sbjnp
Dih7+5/BJPM/AyMzSmL784c8y4l3AIgPSuHs/ChN7+3bybeYOAdkXf3PYJ7/n4GNB66Ik5Ph
f18f5Rbjd4BV6X8GCQOUrhWowZmVRVlwE++Akdo7BgA4MJhiPU7hPAAAAABJRU5ErkJggg=='! !

!ShoreDemo1 methodsFor: 'accessing' stamp: 'pk 4/11/2006 11:18'!
children

	^ Array with: header with: root.! !

!ShoreDemo1 methodsFor: 'initialization' stamp: 'pk 11/1/2005 10:52'!
header

	^ header! !

!ShoreDemo1 methodsFor: 'initialization' stamp: 'pk 10/31/2005 16:43'!
initialize

	super initialize.

	header := ShorePageHeader parent: self.
	header title: 'ShoreComponents Demonstration'.

	root := ShoreDemo1Root  parent: self.



	! !

!ShoreDemo1 methodsFor: 'rendering' stamp: 'pk 12/14/2005 16:00'!
renderContentOn: html

	| logo |

	logo := self fileProvider urlFor: 'ShoreDemo1/logo'.

	header image: logo.
	html render: header.

	html render: root.



! !

!ShoreDemo1 methodsFor: 'hierarchy' stamp: 'pk 7/3/2005 09:15'!
root

	^ root.


! !

!ShoreDemo1 methodsFor: 'hierarchy' stamp: 'pk 10/31/2005 16:36'!
target

	^ root! !

ShoreRootComponent subclass: #ShoreDemo2
	instanceVariableNames: 'header leftPanel rightPanel target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo2'!

!ShoreDemo2 class methodsFor: 'as yet unclassified' stamp: 'pk 4/23/2006 18:40'!
applicationClass

	^ ShoreDemo2Application! !

!ShoreDemo2 class methodsFor: 'as yet unclassified' stamp: 'pk 6/14/2006 09:41'!
initialize

	" self initialize "

	self initializeApplication.! !

!ShoreDemo2 methodsFor: 'accessing' stamp: 'pk 4/27/2006 17:07'!
children

	^ Array with: header with: leftPanel with: rightPanel with: target ! !

!ShoreDemo2 methodsFor: 'initialization' stamp: 'pk 4/23/2006 16:28'!
header

	^ header! !

!ShoreDemo2 methodsFor: 'initialization' stamp: 'pk 5/16/2006 15:28'!
initialize

	super initialize.

	self pageTitle: 'Simple demo'.

	header := ShorePageHeader parent: self.
	header title: 'ShoreComponents Demonstration'.

	leftPanel := ShoreDynamicPanel parent: self.
	leftPanel addSection: (ShoreDemo1DemosMenu parent: leftPanel).
	leftPanel addSection: (ShoreDemo1SimpleComponent parent: leftPanel) .

	rightPanel := ShoreDynamicPanel parent: self.
	rightPanel addSection: (ShoreDemo1DemosMenu parent: leftPanel) .
	rightPanel addSection: (ShoreDemo1SimpleComponent parent: leftPanel) .

	leftPanel providers add: rightPanel.
	rightPanel providers add: leftPanel.

	target := ShoreDemo1Introduction  parent: self.



	! !

!ShoreDemo2 methodsFor: 'rendering' stamp: 'pk 6/29/2006 11:07'!
renderContentOn: html

	| logo |

	logo := self fileProvider urlFor: 'ShoreDemo1/logo'.
	header image: logo.

	html div id: id; class: #shoreLayoutHolder; with: [
		html render: header. 

	html div class: #shoreLayoutLeftColumn; with: [
		html div class: #shoreLayoutColumn; with: [
			self renderLeftColumnOn: html ] ].
	html div class: #shoreLayoutRightColumn; with: [
		html div class: #shoreLayoutColumn; with: [
			self renderRightColumnOn: html	] ].
	html div class: #shoreLayoutMiddleColumn; with: [
		self renderMiddleColumnOn: html ].

	html div class: #shoreLayoutCleaner; with: [html space].
		

	html div class: #shorePageFooter; class: #shoreLayoutFooter; with: [
			self renderFooterOn: html ] .

	]
! !

!ShoreDemo2 methodsFor: 'rendering' stamp: 'pk 4/27/2006 18:09'!
renderFooterOn: html

	html text: 'ShoreComponents demonstration application #2' translated

! !

!ShoreDemo2 methodsFor: 'rendering' stamp: 'pk 4/27/2006 17:08'!
renderLeftColumnOn: html

	html render: leftPanel

	


! !

!ShoreDemo2 methodsFor: 'rendering' stamp: 'pk 4/27/2006 17:08'!
renderMiddleColumnOn: html

	html render: target.





! !

!ShoreDemo2 methodsFor: 'rendering' stamp: 'pk 4/27/2006 17:09'!
renderRightColumnOn: html

	html render: rightPanel




! !

!ShoreDemo2 methodsFor: 'hierarchy' stamp: 'pk 4/29/2006 19:44'!
root

	^ target.! !

!ShoreDemo2 methodsFor: 'hierarchy' stamp: 'pk 4/29/2006 19:44'!
target

	^ target.! !

ShoreDemo2 subclass: #ShoreDemo4
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo4'!

!ShoreDemo4 class methodsFor: 'as yet unclassified' stamp: 'pk 5/16/2006 16:26'!
applicationClass

	^ ShoreDemo4Application! !

!ShoreDemo4 class methodsFor: 'as yet unclassified' stamp: 'pk 5/16/2006 16:26'!
initialize

	" self initialize "

	self initializeApplication.! !

!ShoreDemo4 methodsFor: 'initialization' stamp: 'pk 5/16/2006 16:30'!
initialize

	super initialize.

	self pageTitle: 'Simple demo'.

	header := ShorePageHeader parent: self.
	header title: 'ShoreComponents Demonstration'.

	leftPanel := ShorePanel parent: self.
	leftPanel addSection: (ShoreDemo1DemosMenu parent: leftPanel).
	leftPanel addSection: (ShoreDemo1SimpleComponent parent: leftPanel) .

	rightPanel := ShorePanel parent: self.
	rightPanel addSection: (ShoreDemo1DemosMenu parent: leftPanel) enabled: false .
	rightPanel addSection: (ShoreDemo1SimpleComponent parent: leftPanel) .

	target := ShoreDemo1Introduction  parent: self.



	! !

ShoreRootComponent subclass: #ShoreDemo3
	instanceVariableNames: 'systemCategories contents model message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo3'!

!ShoreDemo3 class methodsFor: 'as yet unclassified' stamp: 'pk 4/30/2006 08:03'!
applicationClass

	^ ShoreDemo3Application! !

!ShoreDemo3 class methodsFor: 'as yet unclassified' stamp: 'pk 5/16/2006 16:28'!
initialize

	self initializeApplication.! !

!ShoreDemo3 methodsFor: 'as yet unclassified' stamp: 'pk 5/17/2006 12:39'!
accept
	|save|
	SeasidePlatformSupport ensureAuthorInitials: [self request: 'Please enter your initials:'].
	message := nil.
	save := contents.
	model contents: contents notifying: self.
	contents ?= save.
! !

!ShoreDemo3 methodsFor: 'hierarchy' stamp: 'pk 5/1/2006 12:37'!
children

	^ Array with: systemCategories! !

!ShoreDemo3 methodsFor: 'accessing' stamp: 'pk 5/1/2006 13:22'!
contents
	^contents! !

!ShoreDemo3 methodsFor: 'accessing' stamp: 'pk 5/17/2006 12:39'!
contents: aString
	contents := aString! !

!ShoreDemo3 methodsFor: 'hierarchy' stamp: 'pk 4/30/2006 08:02'!
fullWindow

	^ true! !

!ShoreDemo3 methodsFor: 'accessing' stamp: 'pk 5/3/2006 12:30'!
initialize
	super initialize.
"	self model: Browser new."! !

!ShoreDemo3 methodsFor: 'rendering' stamp: 'pk 5/17/2006 14:39'!
renderContentOn: html

	| script1 script2 script3 id1 id2 id3 id4 id5 |

	id1 := ShoreComponent newId.
	id2 := ShoreComponent newId.
	id3 := ShoreComponent newId.
	id4 := ShoreComponent newId.
	id5 := ShoreComponent newId.

	script1 := '
		if (resizedElement) {
			if (document.all) {
				resizedElement.style.height = document.documentElement.clientWidth+ "px";
				resizedElement.style.height = document.documentElement.clientHeight-2+ "px";
			} else {
				resizedElement.style.width = window.innerWidth-2+ "px";
				resizedElement.style.height = window.innerHeight-2+ "px";
			}
		}'.

	script2 := '
		if (resizedElement) {
			resizedElement.style.width = resizedElement.parentNode.clientWidth-2 + "px";
			resizedElement.style.height = resizedElement.parentNode.clientHeight-2 + "px";
		}'.

	script3 := '
		if (resizedElement) {
			resizedElement.style.width = resizedElement.parentNode.clientWidth + "px";
			resizedElement.style.height = resizedElement.parentNode.clientHeight + "px";
		}
'.

	html div id: id; class: #shoreBrowser; onResize: script1; with: [

		html div class: #shoreBrowserPanel1; with: [
			html div id: id1; class: #shoreBrowserPanelContent; 
			onResize: script2;
			with: [ html render: systemCategories]].
		html div class: #shoreBrowserPanel2; with: [
			html div id: id2; class: #shoreBrowserPanelContent; 
			onResize: script2;
			with: [
				html heading: '2' ]].
		html div class: #shoreBrowserPanel3; with: [
			html div id: id3; class: #shoreBrowserPanelContent; 
			onResize: script2;
			with: [
				html heading: '3' ]].
		html div class: #shoreBrowserPanel4; with: [
			html div id: id4; class: #shoreBrowserPanelContent; 
			onResize: script2;
			with: [
				html heading: '4' ]].
		html div class: #shoreBrowserPanel5; with: [
			html textArea id: id5; class: #shoreBrowserCode;
			onResize: script3].
	].

	html assignContextMenuTo: id5.

	html registerOnResizeHandlerFor: id.
	html registerOnResizeHandlerFor: id1.
	html registerOnResizeHandlerFor: id2.
	html registerOnResizeHandlerFor: id3.
	html registerOnResizeHandlerFor: id4.
	html registerOnResizeHandlerFor: id5.
! !

!ShoreDemo3 methodsFor: 'accessing' stamp: 'pk 5/1/2006 13:23'!
renderContentPaneOn: html
	html form: [
		html
			textAreaOn: #contents of: self;
			break;
			submitButtonOn: #accept of: self.
	]! !

!ShoreDemo3 methodsFor: 'accessing' stamp: 'pk 5/1/2006 13:23'!
showClass
	self model indicateClassMessages! !

!ShoreDemo3 methodsFor: 'accessing' stamp: 'pk 5/1/2006 13:23'!
showHelp
	self model plusButtonHit! !

!ShoreDemo3 methodsFor: 'accessing' stamp: 'pk 5/1/2006 13:24'!
showInstance
	self model indicateInstanceMessages! !

!ShoreDemo3 methodsFor: 'rendering' stamp: 'pk 5/1/2006 12:36'!
style

	^ '
.shoreBrowser {
	overflow: hidden;
	background-color: white;
	margin: 0px;
	padding: 0px;
	border: 1px solid gray;
}

.shoreBrowserPanel  {
	background-color: red;
	position: absolute;
	top: 50%;
	width: 50%;
	height: 10%;
	padding: 0px;
	border: 0px solid gray;
}

.shoreBrowserPanel1 {
	overflow: hidden;
	background-color: #444444;
	position: absolute;
	top: 0%;
	left: 0%;
	width: 25%;
	height: 50%;
	padding: 0px;
	margin: 0px;
}

.shoreBrowserPanel2 {
	overflow: hidden;
	background-color: #666666;
	position: absolute;
	top: 0%;
	left: 25%;
	width: 25%;
	height: 50%;
	padding: 0px;
	margin: 0px;
}

.shoreBrowserPanel3 {
	overflow: hidden;
	background-color: #888888;
	position: absolute;
	top: 0px;
	left: 50%;
	width: 25%;
	height: 50%;
	padding: 0px;
	margin: 0px;
}

.shoreBrowserPanel4 {
	overflow: hidden;
	background-color: #aaaaaa;
	position: absolute;
	top: 0px;
	left: 75%;
	width: 25%;
	height: 50%;
	padding:0px;
	margin: 0px;
}

.shoreBrowserPanel5 {
	overflow: hidden;
	background-color: #cccccc;
	position: absolute;
	top: 50%;
	left: 0%;
	width: 100%;
	height: 50%;
	padding: 0px;
	margin: 0px;
}

.shoreBrowserPanelContent {
	left: 6px;
	top: 6px;
	overflow: none;
	margin: 0px;
	border: 1px solid black;
}

.shoreBrowserCode {
	overflow: scroll;
	border-width: 0px;
	padding: 0px;
	margin: 0px;
}

'! !

!ShoreDemo3 methodsFor: 'as yet unclassified' stamp: 'pk 5/17/2006 12:39'!
update: aSymbol
	contents := model contents! !

!ShoreRootComponent class methodsFor: 'as yet unclassified' stamp: 'pk 4/22/2006 10:59'!
canBeRoot
	
	^ true! !

!ShoreRootComponent class methodsFor: 'as yet unclassified' stamp: 'pk 6/29/2006 11:51'!
initializeApplication

	| app |
	
	self register.

	app := self registerAsApplication: self applicationClass appName.
	app libraries addLast: SULibrary. 
	app libraries addLast: ShoreStandardStyles.
	app libraries addLast: ShoreStandardScripts.
	app libraries addLast: ShoreStandardScheme.
	
! !

!ShoreRootComponent class methodsFor: 'as yet unclassified' stamp: 'pk 6/14/2006 10:20'!
register

	SeasidePlatformSupport addToStartUpList: self.! !

!ShoreRootComponent class methodsFor: 'vw' stamp: 'pk 5/16/2006 16:22'!
returnFromSnapshot

	self startUp.! !

!ShoreRootComponent class methodsFor: 'as yet unclassified' stamp: 'pk 6/29/2006 11:59'!
startUp
	
	| app |
	
	app := WADispatcher default entryPoints 
		detect: [:point | point name = 'ShoreDemo1' ] 
		ifNone: [ ^ self ].
		! !

!ShoreRootComponent methodsFor: 'as yet unclassified' stamp: 'pk 4/29/2006 22:40'!
fullWindow

	^ false! !

!ShoreRootComponent methodsFor: 'rendering' stamp: 'pk 5/17/2006 14:40'!
initialize

	super initialize.

	id := ShoreComponent newId.! !

!ShoreRootComponent methodsFor: 'rendering' stamp: 'pk 5/1/2006 11:30'!
renderHelpersOn: html

	html div id: #shoreModalDialogOverlay; class: #hidden.
	html div id: #shoreModalDialogBox; class: #hidden;
		with: [ 
			html div id: #shoreModalDialogBoxHeader; with: [].
			html div id: #shoreModalDialog].

	html div id: #shoreContextMenu; class: #hidden; with: [
		html div id: #shoreContextMenuContent].

	html script: 'shoreResizeHandler(null);'.

! !

!ShoreRootComponent methodsFor: 'rendering' stamp: 'pk 5/17/2006 16:37'!
renderWithContext: aRenderingContext
	| html callbacks |
	callbacks := aRenderingContext callbacksFor: self.
	html := (self rendererClass context: aRenderingContext callbacks: callbacks)
				painter: self.
	(self showHalo and: [aRenderingContext isDebugMode])
		ifTrue: [(WAHalo for: self) 
			renderContentOn: html]
		ifFalse: [
			self renderContentOn: html.
			self renderHelpersOn: html.
].
	html close.! !

ShoreComponent subclass: #ShoreTabControl
	instanceVariableNames: 'components selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Hierarchy'!

ShoreTabControl subclass: #ShoreTabControl2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Hierarchy'!

!ShoreTabControl2 class methodsFor: 'images' stamp: 'pk 5/6/2006 16:06'!
backgroundImage

^ ShoreMIMEDocument type: 'image/png' content:
 'iVBORw0KGgoAAAANSUhEUgAAABQAAAAtCAYAAACu/EtoAAAA3ElEQVR4XtXOzQ7BQBiF4XOT
bsEtuE9CqJBqi1YpSrX05wgLSbvQTByLLp6ZyZeZNwPLHtIS0gfnqxGVOhBcuGMqdSBoexMq
tQfdqZHW4MqbGYGztqgEdzOnErztgkpY+0sqYRPY78O33QRMH/w96IdODYK9SyXsDh6VJMEw
2n52vBYl7I8+f3E4BTVoDkxF510NmoNf4RiHVEJ8jaiE8yXiN22B5n39Dy/JiUpI0phK+mCa
JlRClt2ohPs9pZI++HhkVEKe51RCURRU0gfLsqQSqqqiUgeCg36PSk9FDxRWo4KGXgAAAABJ
RU5ErkJggg=='! !

!ShoreTabControl2 class methodsFor: 'images' stamp: 'pk 5/6/2006 16:06'!
leftImage 

^ ShoreMIMEDocument type: 'image/png' content:

 'iVBORw0KGgoAAAANSUhEUgAAAAkAAACWCAYAAAAMoaKGAAABKElEQVR4XuXSz07CQBDH8X18
jz6CiXdPJhxENEbloIkKilUIItJQhVJR/imH0e+YXRopTzBNJk12P/nN7GZd/ntuX0vj5kCq
x7tS3t+W0t6WVgDNxqmcVXaE//CtI4v5RJbLby0FD3cnUr8qyTh7DRv50hYkjLMkLH4tZpo0
m35oORJI+r85+UxDOVKS+HEN0Jr091FfHKdgsQiMhr3fehHHEfP9PcrSWEE66BYjWgC4ikHS
/kNFKSQANiIPOBAVUD4F0O9FEndvhXtU5O+DWZgDwGandSlPzYsV8kcmhQQ2W9G5XrQi2pDC
LMxAigdR/WiFmIVWHvEaADydNcQ8zAK6rx3aR/aRfWQf2Uf2kX1kH9lH9pF9ZB/ZR/aRfWQf
2Uf2kX20Cf0AzvR6cWHqE8UAAAAASUVORK5CYII='! !

!ShoreTabControl2 class methodsFor: 'images' stamp: 'pk 5/6/2006 16:07'!
leftSelectedImage 

^ ShoreMIMEDocument type: 'image/png' content:
 'iVBORw0KGgoAAAANSUhEUgAAAAkAAACWCAYAAAAMoaKGAAABJUlEQVR4XuXSu2oCQRQGYF/S
B0iTPpVWAYtUKdMEayGQYkESCCHYpdNSAylSBQQVSVzdKzt73HN2ZzKbvYj1P/A3s9/OOXPp
2ONjPqPX8QPd317T4OqCepddiQHvk2e6u+nT29MjfX0uyDvsSQ8DnNGQVstvqhtZiWm2Qq8R
CHpxRlKibXS4Se6hFfEu7CZrEW/x1KigNE0rEWRPKKWKJCaC7MkkiSmOQ0kUBZIClUEU+hQG
niTw3RyV/swAf/C932zXP3Rwt39IA/5bA3e3kTQiXiFH62q5HO1MKVPONFzqKYccg/5DvSKn
/ggKqLF1mOrUYarKdegWOC13p8p31/YCzCs4+z3hI3yEj/ARPsJH+Agf4SN8hI/wET7CR/gI
H+EjfERH8p/OVpEepcEAAAAASUVORK5CYII='! !

!ShoreTabControl2 class methodsFor: 'images' stamp: 'pk 5/6/2006 16:07'!
rightImage 

^ ShoreMIMEDocument type: 'image/png' content:
 'iVBORw0KGgoAAAANSUhEUgAAAMgAAAAeCAYAAABpP1GsAAABq0lEQVR4XuXaWUsCYRSH8fn4
fYO+QdFFEkIoEbRSaYtWFtOChC22iERChY2c+B85w5v3XT3CDy/m3D6cd5asVpmzGh8fXGN7
wdrNqt3me5alv8mkMD4+oqL4sfH420YfA+t123Z2tGqb9Xn/LwPRAB8f1dfnyAN5H/bt7blr
3euGb5MyEg3w8VEpDhm83ln/IfdNctXZ8k3ix60Y4OMj0uYYDu59ezz2Or5BFEZzZ9EOd5cs
0wAfH1XEEdsjAon7kUwDfHxUiuPl6ebP9tAR6/J03Z9uZTp78fERKY7YHrOB5Ocb00BiiI+P
SNtj9nilOMoNogE+PqrYHgokPV6VgWiAj48q4ojtEXF0WvVpILrIx0eWHq0u2mv+BEs8EF3k
4yNSFOlNubaGvseSVmNlGogu8vFRxQ15xHFyULHj/WXngcSZi4+PSnHoSKWtoTD0Bl1v0vmB
8KHpfiPiSLeH4igD0RAfH5HiSANJt4e+6OUHwscPhB8IHx8/ED4+fiB8fPxA+Pj4gfDx8QPh
4+MHwsfHD4SPjx8IHx8/EH4gfHz8QPj4+IHw8f17IL+Vitch70tpuwAAAABJRU5ErkJggg=='! !

!ShoreTabControl2 class methodsFor: 'images' stamp: 'pk 5/6/2006 16:08'!
rightSelectedImage

^ ShoreMIMEDocument type: 'image/png' content: 'iVBORw0KGgoAAAANSUhEUgAAAMgAAAAeCAYAAABpP1GsAAABy0lEQVR4XuWbO07DQBBAfUlq
OmoKpLRInCANJ6ChoaOk4AAUFEiIAgSI/Czjj2LHieIMzMS7WRtfAL0nvc5VpKfZX6LRyZGM
+PIFe356LOOLM7m5upTHh3uJQoQPHyC73U6aZivrupJk8WFhaCAayt3ttfAD4cMPpA2kXKaS
fU87ofhI+D8VH34gqaTJROL5m8wmLxaJThJbbvF/Kj78QLqBfL0/2RRR+YHw4QfSC2T6+eyn
CD8QPvxABiaIqqdb/ED48AMZmCAaiB4BR/ohX740m6aR7XZjgSyLZHCCWCBaEV++NC2O9UpW
VeEDWcxe/waiH/HlS7RelVKVmRT5wu5AwuWVD0QL4suXZlXmbRyxXRL2l1c+EB0vfPnS1DBc
HDo9+ssrH4iOF758iebZ3PYe/ED48h2IQ6eHCyQ84nW2gcTCly/T7hRxkTj5exC+/L3Ibyhh
JE6NxQLZ7+b58qWZmXqLvg+lu+xSLRA9C+bLl+jhyDcM5bAE418U8uVbVz6W/nSxQDabWvjy
JRvGEsp/i8WXb/suyxmGw3/Ny5dv+7J3SAuE/88APnyG4QfChw8/ED58+IHw4cMPhA8ffiB8
+PAD4cPnfwTyA9kNcjkUQWlqAAAAAElFTkSuQmCC'! !

!ShoreTabControl2 methodsFor: 'as yet unclassified' stamp: 'pk 4/29/2006 12:47'!
renderContentOn: html

	html div class: 'shoreTabControl2'; with: [
		html div class: 'navigationOptions'; with: [self renderOptionsOn: html].
		html div class: 'navigationContent'; with: [self renderSelectionOn: html].
	]! !

!ShoreTabControl2 methodsFor: 'as yet unclassified' stamp: 'pk 4/29/2006 14:10'!
style	

	^ '
    .shoreTabControl2 .navigationOptions {
	_float: left;
	_width: 100%;

       background:#DAE0D2 url("', (self fileProvider urlFor: 'ShoreTabControl2/backgroundImage'), '") repeat-x bottom;
      line-height:normal;
      }

html>body .shoreTabControl2 .navigationOptions  {
	overflow: auto;
		}
    .shoreTabControl2 .navigationOptions ul {
      margin:0;
      padding:10px 10px 0;
      list-style:none;
      }
    .shoreTabControl2 .navigationOptions li {
      float:left;
      background:url("', (self fileProvider urlFor: 'ShoreTabControl2/leftImage'), '") no-repeat left top;
      margin:0;
      padding:0 0 0 9px;
      }
    .shoreTabControl2 .navigationOptions a {
      display:block;
      background:url("', (self fileProvider urlFor: 'ShoreTabControl2/rightImage'), '") no-repeat right top;
      padding:5px 15px 4px 6px;
      text-decoration:none;
       color:#765;
      }
    .shoreTabControl2 .navigationOptions a:hover {
      color:#333;
      }
    .shoreTabControl2 .navigationOptions .option-selected {
      background-image:url("', (self fileProvider urlFor: 'ShoreTabControl2/leftSelectedImage'), '");
      }
    .shoreTabControl2 .navigationOptions .option-selected a {
      background-image:url("', (self fileProvider urlFor: 'ShoreTabControl2/rightSelectedImage'), '");
      color:#333;
      padding-bottom:5px;
      }

.shoreTabControl2 .navigationContent {
	background : #fff;
	border : 1px solid #776655;
	border-top : none;
	margin : 0px;
	padding : 15px;
	line-height: 1.1;  /* IE6 CSS workaround - http://www.dracos.co.uk/web/css/ie6floatbug/ */
}

'! !

!ShoreTabControl methodsFor: 'accessing' stamp: 'pk 12/14/2005 19:29'!
add: aComponent label: aString

	components add: aString -> aComponent! !

!ShoreTabControl methodsFor: 'hierarchy' stamp: 'pk 12/14/2005 19:29'!
children

	^Array with: self selectedComponent.! !

!ShoreTabControl methodsFor: 'initialization' stamp: 'pk 12/14/2005 19:45'!
initialize
	
	super initialize.

	components := OrderedCollection new.
	selection := WAStateHolder new! !

!ShoreTabControl methodsFor: 'accessing' stamp: 'pk 6/25/2006 15:58'!
labelForOption: anObject

	^ anObject displayString! !

!ShoreTabControl methodsFor: 'accessing' stamp: 'pk 12/14/2005 19:29'!
labels
	"Return the tabs labels"

	^ self options! !

!ShoreTabControl methodsFor: 'accessing' stamp: 'pk 12/14/2005 19:30'!
options

	^ components collect: [:ea | ea key]! !

!ShoreTabControl methodsFor: 'rendering' stamp: 'pk 4/27/2006 18:43'!
renderContentOn: html

	html div class: 'shoreTabControl'; with: [
		html div class: 'navigationOptions'; with: [self renderOptionsOn: html].
		html div class: 'navigationContent'; with: [self renderSelectionOn: html].
	]! !

!ShoreTabControl methodsFor: 'rendering' stamp: 'pk 12/15/2005 08:39'!
renderOptionsOn: html

	html unorderedList
		selected: self selection;
		callback: [:v | self select: v];
		labels: [:ea | self labelForOption: ea];
		list: self options;
		with: nil
! !

!ShoreTabControl methodsFor: 'rendering' stamp: 'pk 12/14/2005 19:30'!
renderSelectionOn: html

	html render: self selectedComponent! !

!ShoreTabControl methodsFor: 'selection' stamp: 'pk 12/14/2005 19:30'!
selectedComponent

	^ (components detect: [:ea | ea key = self selection] ifNone: [^ nil]) value! !

!ShoreTabControl methodsFor: 'selection' stamp: 'pk 12/14/2005 19:31'!
selection

	^ selection contents! !

!ShoreTabControl methodsFor: 'selection' stamp: 'pk 12/14/2005 19:32'!
selectionChanged
	! !

!ShoreTabControl methodsFor: 'selection' stamp: 'pk 12/14/2005 19:32'!
select: anObject

	selection contents: anObject.
	self selectionChanged! !

ShoreComponent subclass: #ShoreTable
	instanceVariableNames: 'rows sortColumn isReversed columns rowPeriod rowColors renderFooter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Tables'!

ShoreTable subclass: #ShoreLiveTable
	instanceVariableNames: 'id previewBlock sortCallbacks previewUpdateScripts sorters selection selectable actionsBlock checkBoxRequest previewRequest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Tables'!

!ShoreLiveTable class methodsFor: 'images' stamp: 'pk 6/21/2006 16:10'!
down

^ ShoreMIMEDocument type: 'image/gif' content:
'R0lGODlhDAAMAMIEAKWqlK2mnK2qlK2qnP///////////////yH+FUNyZWF0ZWQgd2l0aCBU
aGUgR0lNUAAh+QQBCgAEACwAAAAADAAMAAADGki63P5QBSHCqCOwMDnQTfYJUBcRwKmu7JMA
ADs='! !

!ShoreLiveTable class methodsFor: 'images' stamp: 'pk 6/18/2006 19:24'!
minus

^ ShoreMIMEDocument type: 'image/gif' content:

'R0lGODlhDAAMAMZaABoaGiAgICgoKCwsLC0tLTAwMDIyMjMzMzQ0NDo6Ojs7Ozw8PEJCQkND
Q0dHR0hISElJSU1NTU9PT1BQUFNTU1RUVFVVVVhYWFlZWVtbW1xcXF9fX2BgYGFhYWVlZWlp
aWpqam1tbXh4eH5+foKCgoWFhYeHh4iIiIqKio+Pj5GRkZaWlpqampycnKOjo6SkpKampqio
qKmpqa2tra6urrCwsLGxsbOzs7a2trm5ubq6uru7u7y8vMHBwcPDw8TExMbGxsjIyMnJycvL
y8zMzNDQ0NHR0dLS0tPT09XV1dbW1tjY2NnZ2dra2t7e3t/f3+Dg4Ojo6Ozs7O7u7u/v7/f3
9/j4+Pn5+fr6+v39/f//////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
/////////////////////////yH+FUNyZWF0ZWQgd2l0aCBUaGUgR0lNUAAh+QQBCgB/ACwA
AAAADAAMAAAHgIB/gn84NC4tg4M9SlBOSUA0KYM8TVNWVVJLOiofgkRRV1lYVEozIxl/NkdP
QEhJQTQnHhUPNUY7BRQaFhALFxINMEFDKC8xLCUgHA4IKzdCRU1MPy8jGAkEfysyOT4+NiUa
DNl/ISIkKComHQgCAYMRFBMbGg4DAImCBwoKBomBADs='! !

!ShoreLiveTable class methodsFor: 'images' stamp: 'pk 6/18/2006 19:24'!
plus

^ ShoreMIMEDocument type: 'image/gif' content:

'R0lGODlhDAAMAMZdABoaGiAgICgoKCwsLC0tLTAwMDIyMjMzMzQ0NDo6Ojs7Ozw8PEJCQkND
Q0dHR0hISEtLS01NTU9PT1BQUFFRUVNTU1RUVFhYWFlZWVtbW1xcXF9fX2BgYGJiYmVlZWZm
ZmdnZ2lpaWpqam1tbXBwcHJycnd3d3h4eHl5eXt7e3x8fH5+foKCgoSEhIWFhYeHh4iIiIqK
io+Pj5GRkZWVlZaWlpycnJ6enqKioqOjo6ampqmpqa2tra6urq+vr7CwsLGxsbOzs7S0tLa2
tre3t7m5ubq6uru7u7y8vL6+vr+/v8HBwcbGxsjIyMnJycvLy8zMzNDQ0NHR0dLS0tbW1tra
2tvb297e3t/f3+Pj4+jo6O7u7vn5+QAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAACH+FUNyZWF0ZWQgd2l0aCBUaGUgR0lNUAAh+QQBCgB/ACwA
AAAADAAMAAAHgIB/gn9DPjk2g4NLVFZOREk9MoNIVVtXOB1HRjMhglBaXFktJko8Kxl/QFNY
TEokITcwHhYPP1JHBRAFBAwLFxINOk1PMTQXFCgiHA4INUFOUUwlIDQrGAkEfzU7RUIkHyka
DNl/IycsLy4qGwgCAYMRFRMbGg4DAImCBwoKBomBADs='! !

!ShoreLiveTable class methodsFor: 'images' stamp: 'pk 6/21/2006 16:13'!
up

^ ShoreMIMEDocument type: 'image/gif' content:

'R0lGODlhDAAMAMIEAKWqlK2mnK2qlK2qnP///////////////yH+FUNyZWF0ZWQgd2l0aCBU
aGUgR0lNUAAh+QQBCgAEACwAAAAADAAMAAADGUi63P7QgUiCCHAEYF2wH8dY11BiVKquSgIA
Ow=='! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/21/2006 21:58'!
actionsBlock

	^ actionsBlock! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/21/2006 21:59'!
actionsBlock: anObject

	actionsBlock := anObject! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/25/2006 14:09'!
columns: anArray
	
	columns := (Array with: self selectionColumn with: self previewColumn), anArray.

	sorters := anArray select: [:col |
		col canSort ].! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/26/2006 11:08'!
compare: a with: b using: restSorters

	| res sorter va vb |
	sorter := restSorters first.	
	va := sorter valueForRow: a.
	vb := sorter valueForRow: b.

	res := sorter sortBlock value: va value: vb.
	sorter isReversed ifTrue: [
		res := (res - 2) negated + 2 ].
	((res = 2) and: [restSorters size > 1]) ifTrue: [
		res := self compare: a with: b using:  restSorters allButFirst. ].

	^ res.! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/25/2006 13:38'!
contentIdFor: rowIndex

	^ self id, '-', rowIndex displayString, 'content'! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/24/2006 13:02'!
groupByColumns 

	^ sorters select: [:col | col groupBy ].
! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/24/2006 11:32'!
group: rowsDict by: restGroupByColumns 

	| groupByColumn newDict |

	restGroupByColumns ifEmpty: [ ^ rowsDict ].

	groupByColumn := restGroupByColumns first.

	newDict := OrderedCollection new.
	(self group: rowsDict by: (restGroupByColumns allButFirst) ) do: [:assoc |
		(self privGroup: assoc value by: [:row | groupByColumn valueForRow: row ])
			do: [:group |
				newDict add: (((Array with: group key), assoc key) -> group value) ]].

	^ newDict.! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/18/2006 20:07'!
id
	"Answer the value of id"

	^ id! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/26/2006 11:04'!
id: anObject
	"Set the value of id"

	id := anObject! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/24/2006 09:06'!
initialize

	super initialize.
	
	id := ShoreComponent newId.
	sortCallbacks := IdentityDictionary new.

	sortColumn := nil.
	selectable := false.
! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/18/2006 20:08'!
previewBlock
	"Answer the value of previewBlock"

	^ previewBlock! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/26/2006 11:04'!
previewBlock: anObject
	"Set the value of previewBlock"

	previewBlock := anObject! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/25/2006 14:09'!
previewColumn

	^ (ShoreTableColumn new)
		renderBlock: [:row :html | 
			| updateScript rowIndex switchId |
			rowIndex := (rows indexOf: row) displayString.
			switchId := self switchIdFor: rowIndex.
			updateScript := previewRequest displayString.
			updateScript := updateScript copyReplaceAll: 'PARAM01' with: rowIndex.
			updateScript := updateScript copyReplaceAll: 'PARAM02' with: ( self contentIdFor: rowIndex).
			html span
				class: #shoreTablePreviewButton;
				id: switchId;
				onClick: (self swapPreviewScriptFor: (self previewIdFor: rowIndex) switchId: switchId style: 'shoreLiveTablePreview' updateScript: updateScript);
				with: [ html image url: (self fileProvider urlFor: 'ShoreLiveTable/plus') ].

			    ];
		yourself.! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/25/2006 09:55'!
previewContentIdFor: rowIndex

	^ self id, '-', rowIndex displayString, 'content'! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/25/2006 09:26'!
previewIdFor: rowIndex

	^ self id, '-', rowIndex displayString, 'preview'! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/25/2006 13:41'!
previewUpdateScriptFor: rowIndex canvas: html id: contentId
	
	| arg |

	arg := ValueHolder new.
	
	^ html updater
		id: contentId;
		callback: [ :val | 
			arg contents: (rows at: val asInteger) ] value: rowIndex;
		callback: [ :h | 
			previewBlock value: h value: arg contents ];
		yourself.
! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/26/2006 11:05'!
privGroup: collection by: keyBlock

	| result key |
	result := OrderedCollection new.
	collection do: 
		[:e | 
		| assoc |
		key := keyBlock value: e.
		assoc := result detect: [:ass | ass key = key] ifNone: [result add: (key -> OrderedCollection new)].
		assoc value add: e. ].

	^ result! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/21/2006 22:01'!
renderActionsOn: html

	actionsBlock ifNil: [ ^ self ].

	html div class: #shoreLiveTableActions; with: [
		actionsBlock value: html.		
	].
! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/25/2006 13:33'!
renderContentOn: html

	sortCallbacks := IdentityDictionary new.
	columns do: [:col |
		sortCallbacks at: col put: (self sortCallbackFor: col canvas: html )].

	previewRequest := self previewUpdateScriptFor: 'PARAM01' canvas: html id: 'PARAM02'.

	selection := Set new.

	checkBoxRequest := html request
		callback: [:val | 
			| row |
			row := rows at: val asInteger.
			(selection includes: row)
				ifTrue: [ selection remove: row ]
				ifFalse: [ selection add: row ] ]
		value: 'PARAM01'.

	html form with: [
		html div id: id; with: [
			self renderTableOn: html ].
		self renderActionsOn: html.  ].! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/24/2006 14:05'!
renderGroupHeader: header on: html lastHeader: lastHeader

	| col |

	col := OrderedCollection new.
	lastHeader isNil 
		ifFalse: [
			| changed | 
			changed := false.
			col := lastHeader reversed with: header reversed collect: [:last :new |
				(changed not and: [last = new])
					ifTrue: [ nil ]
					ifFalse: [ changed := true. new ] ] ]
		ifTrue: [ col := header reversed ].

	col withIndexDo: [:head :index |
		head ifNotNil: [
			html tableRow with: [ 
				(index > 1) ifTrue: [
					html tableData
						class: #shoreLiveTableOffset;
						colSpan: index-1;
						with: [ html space ] ].
				html tableData
					class: #shoreLiveTableGroup;
					colSpan: self visibleColumns size - index +1+(self groupByColumns size);
					with: head.]]]
		
! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/24/2006 15:56'!
renderHeaderForColumn: aColumn on: html

	| th |
	
	th := html tableHeading.
	aColumn canSort ifTrue: [
		th class: 'sortable'.
		th onClick: (sortCallbacks at: aColumn)].
	th with: [
		 aColumn title isNil 
			ifFalse: [ html text: aColumn title ]
			ifTrue: [ html space ].
		aColumn canSort ifTrue: [
			aColumn isReversed 
				ifFalse: [ html image url: (self fileProvider urlFor: 'ShoreLiveTable/down') ]
				ifTrue: [ html image url: (self fileProvider urlFor: 'ShoreLiveTable/up')  ].
			html 
				span class: #shoreTableColumnSortIndex; 
				with: (sorters indexOf: aColumn) displayString]
	]! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/25/2006 13:39'!
renderRowNumber: index item: row on: html

	| rowId contentId styleClass rowIndex |

	styleClass := self styleClassForRow: index item: row.
	
	html tableRow
		class: styleClass;
		with: [ 
			self groupByColumns isEmpty ifFalse: [
				html tableData
					class: #shoreLiveTableOffset;
					colSpan: self groupByColumns size;
					with: [ html space ]].

			self visibleColumns do: [:ea | 
				self renderColumn: ea row: row on: html] ].

	rowIndex := rows indexOf: row.

	rowId := self previewIdFor: rowIndex.
	contentId := self contentIdFor: rowIndex.

	html tableRow
		id: rowId;
		class: 'hidden';
		with: [ 
			self groupByColumns isEmpty ifFalse: [
				html tableData
					colSpan: self groupByColumns size;
					with: [ html space ]].
			html tableData
				colSpan: self visibleColumns size;
				with: [ 
					html div 				
					id: contentId;
						with: [html space ]]].
! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/24/2006 13:03'!
renderRowsOn: html

	| groupByCols groups index lastHead |

	groupByCols := self groupByColumns reversed.

	groups := self group: (OrderedCollection with: (Array new->self rows)) by: groupByCols.

	index := 1.
	lastHead := nil.
	groups do: [:assoc | 
		| groupKey groupCol |
		groupKey := assoc key.
		groupCol := assoc value.
		self renderGroupHeader: groupKey on: html lastHeader: lastHead.
		lastHead := groupKey.

		groupCol do: [:row |
			self renderRowNumber: index item: row on: html.
			index := index + 1 ]].! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/25/2006 14:30'!
renderSelectAllAnchorOn: html
	
	| script |

	script := '
		for(i=1; i<', rows size displayString, '; i++)
		{
			var elm = document.getElementById("', self id, '-" + i + "checkbox");
			if (elm) {
				elm.checked = true;
			}					
		}'.

	html anchor 
		onClick: script;
		onClick: (html request 
			callback: [ self selection addAll: rows ]);
		text: 'all' translated! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/25/2006 14:33'!
renderSelectNoneAnchorOn: html
	
	| script |

	script := '
		for(i=1; i<', rows size displayString, '; i++)
		{
			var elm = document.getElementById("', self id, '-" + i + "checkbox");
			if (elm) {
				elm.checked = false;
			}					
		}'.

	html anchor 
		onClick: script;
		onClick: (html request 
			callback: [ self selection: Set new ]);
		text: 'none' translated! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/21/2006 22:22'!
renderSelectorFor: aRow on: html

	html checkbox
		class: #shoreLiveTableSelector;
		value: false;
		callback: [:val | 
			val ifTrue: [ selection add: aRow] ].! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/24/2006 14:06'!
renderTableFooterOn: html


	self renderFooter ifTrue: [
		self groupByColumns isEmpty ifFalse: [
			html tableHeading
				colSpan: (self groupByColumns size);
				with: [ html space ]].
		html tableRow with: [ 
			self visibleColumns do: [ :ea | 
				self renderFooterForColumn: ea on: html] ] ]! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/24/2006 14:05'!
renderTableHeaderOn: html

	html tableRow with: [ 
		self groupByColumns isEmpty ifFalse: [
			self groupByColumns size timesRepeat: [
				html tableHeading
					class: #shoreLiveTableGroupHeader;
					with: [ html space ]]].
		self visibleColumns do: [ :ea | 
			self renderHeaderForColumn: ea on: html] ]! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/18/2006 18:00'!
renderTableOn: html

	super renderContentOn: html .


! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/21/2006 18:12'!
rows

	sorters isEmpty ifTrue: [^ rows].
	^ self sortRows: rows.
! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/21/2006 22:27'!
selection
	
	^ selection! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/25/2006 14:25'!
selectionColumn

	^ (ShoreTableColumn new)
		renderBlock: [:row :html | 
				| checkBoxId |
				checkBoxId := rows indexOf: row.
				html checkbox
					class: #shoreLiveTableSelector;
					id: (self id, '-', checkBoxId displayString, 'checkbox');
					value: false;
					onClick: (checkBoxRequest displayString copyReplaceAll: 'PARAM01' with: checkBoxId displayString) ];
		yourself.! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/25/2006 14:37'!
selection: anObject

	selection := anObject! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/26/2006 11:08'!
sortBlockFrom: restSorters

	^ [:a :b | 
		| av bv res |
		av := a value.
		bv := b value.
		res := restSorters first sortBlock value: av value: bv.
		restSorters first isReversed ifTrue: [
			res := res negated ].
		((res = 0) and: [restSorters size > 1]) ifTrue: [
			res := (self sortBlockFrom: restSorters allButFirst) value: av value: bv.].
		 res ].! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/18/2006 14:38'!
sortCallbackFor: col canvas: html

	^ html updater 
		id: self id;
		callback: [:h | self sortColumn: col. self renderTableOn: h].! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/18/2006 14:02'!
sortColumn

	^ sortColumn! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/21/2006 17:38'!
sortColumn: anObject 

	anObject = sorters first
		ifTrue: [ anObject isReversed: anObject isReversed not].
	
	sorters remove: anObject.
	sorters addFirst: anObject.! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/21/2006 19:51'!
sortRows: anArray 
	| |
	^ anArray asSortedCollection: [:a :b |
		(self compare: a with: b using: sorters) <= 2].
	! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/18/2006 19:37'!
swapPreviewScriptFor: rowId style: styleClass updateScript: updateScript


 ^ '	shoreTableSwapPreview("{1}","{2}","{3}","{4}","{5}")' 

	format: (OrderedCollection new
		add: rowId;
		add: styleClass;
		add: updateScript;
		add: (self fileProvider urlFor: 'ShoreLiveTable/plus');
		add: (self fileProvider urlFor: 'ShoreLiveTable/minus');
		yourself)! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/25/2006 09:39'!
swapPreviewScriptFor: rowId switchId: switchId style: styleClass updateScript: updateScript


 ^ '	shoreTableSwapPreview("{1}","{2}","{3}","{4}","{5}","{6}")' 

	format: (OrderedCollection new
		add: rowId;
		add: switchId;
		add: styleClass;
		add: updateScript;
		add: (self fileProvider urlFor: 'ShoreLiveTable/plus');
		add: (self fileProvider urlFor: 'ShoreLiveTable/minus');
		yourself)! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/25/2006 09:35'!
switchIdFor: rowIndex

	^ self id, '-', rowIndex displayString, 'switch'! !

!ShoreLiveTable methodsFor: 'accessing' stamp: 'pk 6/24/2006 14:08'!
visibleColumns

	^ columns select: [:col | col visible ].! !

!ShoreTable methodsFor: 'as yet unclassified' stamp: 'pk 12/14/2005 20:12'!
chooseRow: aRow column: aColumn	
	
	aColumn chooseRow: aRow! !

!ShoreTable methodsFor: 'accessing' stamp: 'pk 12/14/2005 20:11'!
columns: anArray

	columns:= anArray! !

!ShoreTable methodsFor: 'accessing' stamp: 'pk 6/18/2006 09:30'!
initialize

	super initialize.

	rows := #().
	isReversed := false.
	columns := #().
	sortColumn := WAStateHolder new.
	renderFooter := false.! !

!ShoreTable methodsFor: 'as yet unclassified' stamp: 'pk 12/14/2005 20:12'!
isReversed

	^ isReversed! !

!ShoreTable methodsFor: 'rendering' stamp: 'pk 6/21/2006 21:31'!
renderColumn: aColumn row: aRow on: html

	|text|
	
	text := aColumn textForRow: aRow.
	text isEmpty ifTrue: [text := ' '].
	html tableData 
		class: (aColumn styleBlock ifNotNil: [aColumn styleBlock value: aRow] ifNil: ['']);
		with: [
			aColumn renderBlock 
				ifNotNil: [ aColumn renderBlock value: aRow value: html ]
				ifNil: [
					aColumn canChoose
						ifFalse: [html text: text]
						ifTrue: [html anchor callback: [self chooseRow: aRow column: aColumn]; text: text] ]
	]! !

!ShoreTable methodsFor: 'rendering' stamp: 'pk 6/18/2006 10:05'!
renderContentOn: html

	| table |
	
	table := html table.
	table 
		class: #shoreTable.
	table attributes
		cellspacing: 0;
		cellpadding: 5. 

	table with: [
		self renderTableHeaderOn: html.
		self renderRowsOn: html.
		self renderTableFooterOn: html.
	]! !

!ShoreTable methodsFor: 'accessing' stamp: 'pk 5/16/2006 16:18'!
renderFooter

	^ renderFooter! !

!ShoreTable methodsFor: 'rendering' stamp: 'pk 6/18/2006 10:55'!
renderFooterForColumn: aColumn on: html

	html tableHeading with: [ html text: (aColumn totalForRows: rows)]
! !

!ShoreTable methodsFor: 'accessing' stamp: 'pk 5/16/2006 16:18'!
renderFooter: aBoolean

	renderFooter := aBoolean! !

!ShoreTable methodsFor: 'rendering' stamp: 'pk 12/14/2005 22:22'!
renderHeaderForColumn: aColumn on: html

	html tableHeading with: [
		aColumn canSort
			ifTrue: [
				html anchor callback: [self sortColumn: aColumn]; text: aColumn title]
			ifFalse: [
				html text: aColumn title]
	]! !

!ShoreTable methodsFor: 'rendering' stamp: 'pk 6/24/2006 14:07'!
renderRowNumber: index item: row on: html

	html tableRow
		class: (self styleClassForRow: index item: row);
		with: [ 
			self visibleColumns do: [:ea | 
				self renderColumn: ea row: row on: html] ]! !

!ShoreTable methodsFor: 'rendering' stamp: 'pk 12/14/2005 20:19'!
renderRowsOn: html

	self rows withIndexDo: [:row :i | 
		self renderRowNumber: i item: row on: html ]! !

!ShoreTable methodsFor: 'rendering' stamp: 'pk 6/24/2006 14:06'!
renderTableFooterOn: html


	self renderFooter ifTrue: [
		html tableRow with: [ 
			self visibleColumns do: [ :ea | 
				self renderFooterForColumn: ea on: html] ] ]! !

!ShoreTable methodsFor: 'rendering' stamp: 'pk 6/24/2006 14:07'!
renderTableHeaderOn: html

	html tableRow with: [ 
		self visibleColumns do: [ :ea | 
			self renderHeaderForColumn: ea on: html] ]! !

!ShoreTable methodsFor: 'accessing' stamp: 'pk 12/14/2005 20:11'!
rowColors: colorArray

	rowColors := colorArray! !

!ShoreTable methodsFor: 'accessing' stamp: 'pk 12/14/2005 22:28'!
rows

	| r |
	
	self sortColumn ifNil: [^ rows].
	r := self sortColumn sortRows: rows.
	^ self isReversed ifTrue: [r reversed] ifFalse: [r]! !

!ShoreTable methodsFor: 'accessing' stamp: 'pk 12/14/2005 20:39'!
rows: aCollection

	rows := aCollection! !

!ShoreTable methodsFor: 'state variables' stamp: 'pk 12/14/2005 20:12'!
sortColumn

	^ sortColumn contents! !

!ShoreTable methodsFor: 'state variables' stamp: 'pk 6/18/2006 14:37'!
sortColumn: anObject 

	anObject = sortColumn contents
		ifTrue: [ self halt. isReversed := isReversed not]
		ifFalse: [isReversed := false].
	sortColumn contents: anObject! !

!ShoreTable methodsFor: 'styles' stamp: 'pk 6/18/2006 09:58'!
styleClassForRow: rowIndex item: row

	^ rowIndex even
		ifTrue: [ #even ]
		ifFalse: [ #odd ].! !

!ShoreTable methodsFor: 'rendering' stamp: 'pk 6/24/2006 16:29'!
visibleColumns

	^ columns select: [:col | col visible ].! !

ShoreComponent subclass: #ShoreTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Kernel'!

!ShoreTask methodsFor: 'testing' stamp: 'pk 6/29/2005 21:07'!
decoration: oldDecoration shouldWrap: newDecoration

	^ (oldDecoration isGlobal and: [newDecoration isGlobal not])
		or: [oldDecoration isLocal and: [newDecoration isDelegation]]! !

!ShoreTask methodsFor: 'running' stamp: 'pk 6/29/2005 21:08'!
go

	self subclassResponsibility! !

!ShoreTask methodsFor: 'rendering' stamp: 'pk 6/29/2005 21:07'!
renderContentOn: html

	self session redirectTo: (html urlForAction: [[self answer: self go] repeat])! !

ShoreComponent subclass: #ShoreWebTree
	instanceVariableNames: 'rootNodes eventHandler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Webtree'!

!ShoreWebTree commentStamp: 'TBn 4/28/2004 20:11' prior: 0!
This class represents a component for providing html table based
web tree views. You can set the background color and add root
nodes (typically instances of WAWebTreeNode) using #addRootNode:
to it.

It is also possible to set an event handler to receive #onCollapseNode: 
and #onExpandNode: messages when the user clicks in the tree.

!

!ShoreWebTree class methodsFor: 'images' stamp: 'pk 5/6/2006 16:50'!
branchImageBottom

^ ShoreMIMEDocument type: 'image/gif' content:

 'R0lGODlhEwAQAOcAAAAAAICAgAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAkAAAAALAAAAAATABAAAAgrAAEIHCgwAMGD
CBMqTGhwocOHCBtCnOhQIsWLBw1qBLDRIsaPIEOKHAkyIAA7'! !

!ShoreWebTree class methodsFor: 'images' stamp: 'pk 5/6/2006 16:50'!
branchImageCenter

^ ShoreMIMEDocument type: 'image/gif' content:
 'R0lGODlhEwAQAOcAAAAAAICAgAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAkAAAAALAAAAAATABAAAAgvAAEIHCgwAMGD
CBMqTGhwocOHCBtCnOhQIsWLBw1qBLDRIkaGH0MWFBnSI0mCAQEAOw=='			! !

!ShoreWebTree class methodsFor: 'images' stamp: 'pk 5/6/2006 16:51'!
minusImageBottom

^ ShoreMIMEDocument type: 'image/gif' content:

 'R0lGODlhEwAQAOcAAAAAAAAAAYCAgP///wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAkAAAAALAAAAAATABAAAAhLAAEIHChQAMGD
CBMqTGhwocOHBQVInCjRoYABADBqbKjQoMaMADgy/LjRIoAAKFGGXGlQ5EWQJRd6hLlSJsmM
IhFS3Amxp8+fCwMCADs='	! !

!ShoreWebTree class methodsFor: 'images' stamp: 'pk 5/6/2006 16:51'!
minusImageCenter

^ ShoreMIMEDocument type: 'image/gif' content:
 'R0lGODlhEwAQAOcAAAAAAICAgAAAAf///wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAkAAAAALAAAAAATABAAAAhLAAEIHCgwAMGD
CBMqTGhwocOHBQNInCjRYYABADBqbKjQoMaMADgy/LjRIgABKFGGXGlQ5EWQJRd6hLlSJsmM
IhFS3AmxZ0efQAMCADs='! !

!ShoreWebTree class methodsFor: 'images' stamp: 'pk 5/6/2006 16:52'!
plusImageBottom

^ ShoreMIMEDocument type: 'image/gif' content:

 'R0lGODlhEwAQAOcAAAAAAICAgAAAAf///wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAkAAAAALAAAAAATABAAAAhQAAEIHCgwAMGD
CBMqTGhwocOHBQNInCjRYYABADBqbKjQIEYBGQFwZKhRwEaLAASoVCmypcGRFzOazDgSoceU
IWsejKmRpkWKFCEKHUp0YUAAOw=='! !

!ShoreWebTree class methodsFor: 'images' stamp: 'pk 5/6/2006 16:52'!
plusImageCenter

^ ShoreMIMEDocument type: 'image/gif' content:
 'R0lGODlhEwAQAOcAAAAAAICAgAAAAf///wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAkAAAAALAAAAAATABAAAAhQAAEIHCgwAMGD
CBMqTGhwocOHBQNInCjRYYABADBqbKjQIEYBGQFwZKhRwEaLAASoVCmypcGRFzOazDgSoceU
IWsejKmRpkWKFCEK7Ti0aEAAOw=='! !

!ShoreWebTree class methodsFor: 'images' stamp: 'pk 5/6/2006 16:53'!
verticalImage
	
^ ShoreMIMEDocument type: 'image/gif' content: 'R0lGODlhEAAQAOcAAAAAAICAgAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAkAAAAALAAAAAAQABAAAAgnAAEIHCgwAMGD
CBMqBGBwocOHDR9KRBhxokWGFzNWzAiRo8WNHgMCADs='! !

!ShoreWebTree methodsFor: 'operations' stamp: 'TBn 4/28/2004 17:22'!
addRootNode: aTreeNode

	self rootNodes add: aTreeNode! !

!ShoreWebTree methodsFor: 'accessing' stamp: 'pk 12/14/2005 17:23'!
eventHandler

	^eventHandler! !

!ShoreWebTree methodsFor: 'accessing' stamp: 'TBn 4/28/2004 17:17'!
eventHandler: anObject
	eventHandler := anObject
	! !

!ShoreWebTree methodsFor: 'node rendering' stamp: 'pk 12/14/2005 17:50'!
imageCellFor: image actionBlock: aBlock on: html

	html tableData
		with: [ 
			html anchor callback: aBlock;
			with: [ html image noBorder url: image ]].! !

!ShoreWebTree methodsFor: 'node rendering' stamp: 'pk 12/14/2005 17:49'!
imageCellFor: aForm  on: html
	
	html tableData with: [html image noBorder url: aForm]! !

!ShoreWebTree methodsFor: 'events' stamp: 'pk 12/14/2005 17:24'!
onCollapseNode: aNode 

	aNode collapse.
	eventHandler notNil
		ifTrue: [eventHandler onCollapseNode: aNode]! !

!ShoreWebTree methodsFor: 'events' stamp: 'pk 12/14/2005 17:24'!
onExpandNode: aNode 

	aNode expand.
	eventHandler notNil
		ifTrue: [eventHandler onExpandNode: aNode]
	 ! !

!ShoreWebTree methodsFor: 'rendering' stamp: 'pk 12/14/2005 17:25'!
renderContentOn: html	
	
	| nodes |
	
	nodes := self rootNodes.
	self renderNodes: nodes on: html

 ! !

!ShoreWebTree methodsFor: 'node rendering' stamp: 'pk 12/14/2005 17:52'!
renderImageForInnerNode: aNode on: html 

	aNode hasSubnodes
		ifFalse: [ ^ self imageCellFor: (self fileProvider urlFor: 'ShoreWebTree/branchImageCenter') on: html].
		
	aNode isExpanded
		ifTrue: [
			self imageCellFor: (self fileProvider urlFor: 'ShoreWebTree/minusImageCenter')
				actionBlock: [self onCollapseNode: aNode]
				on: html]
		ifFalse: [
			self imageCellFor: (self fileProvider urlFor: 'ShoreWebTree/plusImageCenter')
				actionBlock: [self onExpandNode: aNode]
				on: html]! !

!ShoreWebTree methodsFor: 'node rendering' stamp: 'pk 12/14/2005 17:53'!
renderImageForLastNode: aNode on: html 

	aNode hasSubnodes
		ifFalse: [^ self imageCellFor:(self fileProvider urlFor: 'ShoreWebTree/branchImageBottom') on: html].

	aNode isExpanded
		ifTrue: [
			self imageCellFor: (self fileProvider urlFor: 'ShoreWebTree/minusImageBottom')
				actionBlock: [self onCollapseNode: aNode]
				on: html]
		ifFalse: [
			self imageCellFor: (self fileProvider urlFor: 'ShoreWebTree/plusImageBottom')
				actionBlock: [self onExpandNode: aNode]
				on: html]! !

!ShoreWebTree methodsFor: 'node rendering' stamp: 'pk 12/14/2005 17:29'!
renderInnerNode: aNode on: html 

	html tableRow with: [
		self renderImageForInnerNode: aNode on: html.
		html tableData: aNode wrappedObject].

	aNode isExpanded 
		ifTrue: [
			html tableRow with: [
				html tableData
					style: (html backgroundImage: (self fileProvider urlFor: 'ShoreWebTree/verticalImage'));
					with: [ ].						
				html tableData: [
					self renderNodes: aNode subnodes on: html]]]! !

!ShoreWebTree methodsFor: 'node rendering' stamp: 'TBn 4/28/2004 17:24'!
renderLastNode: aNode on: html

	html tableRow: [
		self renderImageForLastNode: aNode on: html.
		html
			tableData: aNode wrappedObject 
	].
	aNode isExpanded ifTrue: [	 
		html tableRow: [
				 		 
		html 
			tableData: '';
			tableData: [self renderNodes: aNode subnodes on: html]
		].
	 ]! !

!ShoreWebTree methodsFor: 'rendering' stamp: 'pk 12/14/2005 16:54'!
renderNodes: nodes on: html
	"Renders the given collection of nodes on the renderer.
	 Leading nodes have a different appearance than the last node"

	nodes isEmpty ifTrue: [^self].
	
	html table layout with: [
		nodes size > 1 ifTrue: [
			(1 to: nodes size - 1) do: [:index | 
				self renderInnerNode: (nodes at: index) on: html ] ].
		self renderLastNode: nodes last on: html].
	! !

!ShoreWebTree methodsFor: 'accessing' stamp: 'TBn 4/28/2004 17:13'!
rootNodes

	rootNodes isNil ifTrue: [rootNodes := OrderedCollection new].
	^rootNodes! !

!ShoreWebTree methodsFor: 'accessing' stamp: 'TBn 4/28/2004 17:13'!
rootNodes: aCollection

	rootNodes := aCollection! !

ShoreComponent subclass: #ShoreXPPanel
	instanceVariableNames: 'sections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Panels'!

!ShoreXPPanel methodsFor: 'sections' stamp: 'pk 6/30/2005 12:59'!
addSection: aComponent

	aComponent addDecoration: ShoreXPPanelDecoration new.
	sections add: aComponent.
! !

!ShoreXPPanel methodsFor: 'accessing' stamp: 'pk 6/30/2005 11:20'!
children

	^ sections! !

!ShoreXPPanel methodsFor: 'initialization' stamp: 'tbn 7/11/2005 21:51'!
initialize
	"Initializes the receiver"

	super initialize.
	self session registerObjectForBacktracking: self. 
	
	sections := OrderedCollection new.! !

!ShoreXPPanel methodsFor: 'rendering' stamp: 'pk 12/11/2005 12:12'!
renderContentOn: html
	"renders the receivers content on the given html object"

	html div 
		class: #shoreXPPanel;
		with: [
			sections do: [ :section |
				html render: section] ] . 
! !

WAComponent subclass: #ShoreFileLibrary
	instanceVariableNames: 'application files'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Kernel'!

ShoreFileLibrary class
	instanceVariableNames: 'cache'!

!ShoreFileLibrary class methodsFor: 'as yet unclassified' stamp: 'pk 6/29/2006 08:39'!
cache

	^ cache ifNil: [ cache := Dictionary new ].! !

!ShoreFileLibrary class methodsFor: 'as yet unclassified' stamp: 'pk 6/29/2006 07:14'!
canBeRoot

	^ true! !

!ShoreFileLibrary class methodsFor: 'as yet unclassified' stamp: 'pk 6/29/2006 08:33'!
classesWithImages

	^ ShoreComponent withAllSubclasses,
	ShoreDecoration withAllSubclasses,
	ShoreTask withAllSubclasses,
	ShoreWidget withAllSubclasses! !

!ShoreFileLibrary class methodsFor: 'as yet unclassified' stamp: 'pk 6/29/2006 09:13'!
initialize

	| app |

	super initialize.

	app := self registerAsApplication: self libraryApplicationName.

	app preferenceAt: #sessionClass put: ShoreFileLibrarySession.
	
	self reset.

	! !

!ShoreFileLibrary class methodsFor: 'as yet unclassified' stamp: 'pk 6/29/2006 09:10'!
libraryApplicationName

	^ 'shoreFiles'! !

!ShoreFileLibrary class methodsFor: 'as yet unclassified' stamp: 'pk 6/29/2006 08:36'!
registerDocuments! !

!ShoreFileLibrary class methodsFor: 'as yet unclassified' stamp: 'pk 6/29/2006 08:38'!
registerStandardDocuments

	self classesWithImages do: [ :component |
		(component class organization listAtCategoryNamed: #images) do: [:selector |
			self cache at: (component name, '/', selector) put: (component perform: selector) ] ]! !

!ShoreFileLibrary class methodsFor: 'as yet unclassified' stamp: 'pk 6/29/2006 08:39'!
reset

	cache := Dictionary new.

	self registerStandardDocuments.
	self registerDocuments.! !

WASystemConfiguration subclass: #ShoreConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Kernel'!

!ShoreConfiguration methodsFor: 'as yet unclassified' stamp: 'pk 12/14/2005 10:46'!
attributes

	^ Array
		with: ((WAListAttribute key: #fileProviderClass) options: self fileProviderClasses)
! !

!ShoreConfiguration methodsFor: 'as yet unclassified' stamp: 'pk 12/14/2005 10:47'!
fileProviderClass

	^ ShoreFileProvider ! !

!ShoreConfiguration methodsFor: 'as yet unclassified' stamp: 'pk 12/14/2005 10:46'!
fileProviderClasses

	^ ShoreFileProvider withAllSubclasses! !

Object subclass: #ShoreFileProvider
	instanceVariableNames: 'application'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Kernel'!

!ShoreFileProvider class methodsFor: 'as yet unclassified' stamp: 'pk 5/6/2006 16:45'!
new

	^ super new initialize! !

!ShoreFileProvider methodsFor: 'accessing' stamp: 'pk 12/14/2005 14:16'!
application
	"Answer the value of application"

	^ application! !

!ShoreFileProvider methodsFor: 'accessing' stamp: 'pk 12/14/2005 14:16'!
application: anObject
	"Set the value of application"

	application := anObject! !

!ShoreFileProvider methodsFor: 'accessing' stamp: 'pk 6/29/2006 08:44'!
basePathChanged! !

!ShoreFileProvider methodsFor: 'accessing' stamp: 'pk 6/29/2006 09:11'!
library 

	^ ShoreFileLibrary! !

!ShoreFileProvider methodsFor: 'accessing' stamp: 'pk 6/29/2006 09:11'!
urlFor: documentName

	^ WADispatcher default basePath, '/', self library libraryApplicationName, '/', documentName.
! !

Object subclass: #ShoreMIMEDocument
	instanceVariableNames: 'document'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Support'!

!ShoreMIMEDocument commentStamp: '<historical>' prior: 0!
^ ShoreMIMEDocument type: 'image/png' content:


(Base64MimeConverter mimeEncode: ((FileStream readOnlyFileNamed: 'ShoreDemo1.gif') binary)) contents!

!ShoreMIMEDocument class methodsFor: 'as yet unclassified' stamp: 'pk 5/6/2006 16:38'!
type: mimeType content: base64String

	^self new document: (SeasidePlatformSupport mimeDocumentClass contentType: mimeType content: (SeasidePlatformSupport base64Decode: base64String) contents).! !

!ShoreMIMEDocument methodsFor: 'accessing' stamp: 'pk 5/6/2006 15:34'!
asMIMEDocument 
	
	^ document! !

!ShoreMIMEDocument methodsFor: 'accessing' stamp: 'pk 5/6/2006 15:28'!
document
	"Answer the value of document"

	^ document! !

!ShoreMIMEDocument methodsFor: 'accessing' stamp: 'pk 5/17/2006 12:41'!
document: anObject
	"Set the value of document"

	document := anObject! !

!ShoreMIMEDocument methodsFor: 'accessing' stamp: 'pk 5/6/2006 16:40'!
mimeType

	^ document contentType! !

Object subclass: #ShoreSessionEntry
	instanceVariableNames: 'url document'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Support'!

!ShoreSessionEntry class methodsFor: 'instance creation' stamp: 'tbn 7/11/2005 21:37'!
url: url document: doc
	"Creates a new instance of the receiver initialized with the given url and document"

	| entry |
	entry := self new.
	entry url: url.
	entry document: doc asMIMEDocument.
	^ entry.! !

!ShoreSessionEntry methodsFor: 'accessing' stamp: 'pk 7/3/2005 15:24'!
document
	"Answer the value of document"

	^ document! !

!ShoreSessionEntry methodsFor: 'accessing' stamp: 'pk 5/17/2006 12:41'!
document: anObject
	"Set the value of document"

	document := anObject! !

!ShoreSessionEntry methodsFor: 'accessing' stamp: 'pk 7/3/2005 15:24'!
url
	"Answer the value of url"

	^ url! !

!ShoreSessionEntry methodsFor: 'accessing' stamp: 'pk 5/17/2006 12:43'!
url: anObject
	"Set the value of url"

	url := anObject! !

Object subclass: #ShoreTableColumn
	instanceVariableNames: 'clickBlock formatBlock hasTotal title sortBlock valueBlock styleBlock renderBlock isReversed groupBy visible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Tables'!

!ShoreTableColumn class methodsFor: 'as yet unclassified' stamp: 'pk 12/14/2005 20:08'!
new
	^ super new initialize! !

!ShoreTableColumn class methodsFor: 'as yet unclassified' stamp: 'pk 12/14/2005 20:08'!
selector: aSymbol
	^ self selector: aSymbol title: aSymbol capitalized! !

!ShoreTableColumn class methodsFor: 'as yet unclassified' stamp: 'pk 12/14/2005 20:08'!
selector: aSymbol title: aString
	^ self selector: aSymbol title: aString onClick: nil! !

!ShoreTableColumn class methodsFor: 'as yet unclassified' stamp: 'pk 12/14/2005 20:08'!
selector: aSymbol title: aString onClick: aBlock
	^ self new
		title: aString;
		selector: aSymbol;
		clickBlock: aBlock! !

!ShoreTableColumn methodsFor: 'public' stamp: 'pk 12/14/2005 20:08'!
canChoose
	^ clickBlock notNil! !

!ShoreTableColumn methodsFor: 'public' stamp: 'pk 12/14/2005 20:08'!
canSort
	^ sortBlock notNil! !

!ShoreTableColumn methodsFor: 'public' stamp: 'pk 12/14/2005 20:08'!
chooseRow: row
	^ clickBlock value: row! !

!ShoreTableColumn methodsFor: 'accessing' stamp: 'pk 5/17/2006 12:43'!
clickBlock: aBlock
	clickBlock := aBlock! !

!ShoreTableColumn methodsFor: 'accessing' stamp: 'pk 12/14/2005 20:08'!
columnClickBlock: aBlock
	self clickBlock: [:r | aBlock value: (self valueForRow: r)]! !

!ShoreTableColumn methodsFor: 'accessing' stamp: 'pk 12/14/2005 20:08'!
formatBlock: anObject
	formatBlock := anObject! !

!ShoreTableColumn methodsFor: 'accessing' stamp: 'pk 6/24/2006 09:07'!
groupBy

	^ groupBy! !

!ShoreTableColumn methodsFor: 'accessing' stamp: 'pk 6/24/2006 09:07'!
groupBy: anObject
	groupBy := anObject! !

!ShoreTableColumn methodsFor: 'accessing' stamp: 'pk 5/17/2006 12:44'!
hasTotal: aBoolean
	hasTotal := aBoolean ! !

!ShoreTableColumn methodsFor: 'accessing' stamp: 'pk 5/17/2006 12:46'!
index: aNumber
	valueBlock := [:row | row at: aNumber]! !

!ShoreTableColumn methodsFor: 'accessing' stamp: 'pk 6/24/2006 15:57'!
initialize
	formatBlock := [:x | x displayString].
	valueBlock := [:row | nil].
	clickBlock := nil.
	title := nil.
	hasTotal := false.
	isReversed := false.
	groupBy := false.
	visible := true.
! !

!ShoreTableColumn methodsFor: 'accessing' stamp: 'pk 6/21/2006 17:33'!
isReversed

	^ isReversed! !

!ShoreTableColumn methodsFor: 'accessing' stamp: 'pk 6/21/2006 17:33'!
isReversed: aBoolean
	isReversed := aBoolean ! !

!ShoreTableColumn methodsFor: 'accessing' stamp: 'pk 6/21/2006 21:27'!
renderBlock

	^ renderBlock! !

!ShoreTableColumn methodsFor: 'accessing' stamp: 'pk 6/21/2006 21:27'!
renderBlock: aBlock
	renderBlock := aBlock! !

!ShoreTableColumn methodsFor: 'accessing' stamp: 'pk 5/17/2006 12:44'!
selector: aSymbol
	valueBlock := [:row | row perform: aSymbol]! !

!ShoreTableColumn methodsFor: 'accessing' stamp: 'pk 6/21/2006 18:14'!
sortBlock

	^ sortBlock! !

!ShoreTableColumn methodsFor: 'accessing' stamp: 'pk 12/14/2005 20:08'!
sortBlock: anObject
	sortBlock := anObject! !

!ShoreTableColumn methodsFor: 'public' stamp: 'pk 6/21/2006 17:52'!
sortRows2: anArray
	| assocs res |
	assocs := anArray collect: [:ea | ea -> (self valueForRow: ea)].
	assocs := assocs asSortedCollection: [:a :b | sortBlock value: a value value: b value].
	res := assocs collect: [:ea | ea key].
	self isReversed ifTrue: [ res := res reversed ].

	^ res.! !

!ShoreTableColumn methodsFor: 'public' stamp: 'pk 5/17/2006 12:44'!
sortRows: anArray
	|assocs|
	assocs := anArray collect: [:ea | ea -> (self valueForRow: ea)].
	assocs := assocs asSortedCollection: [:a :b | sortBlock value: a value value: b value].
	^ assocs collect: [:ea | ea key]! !

!ShoreTableColumn methodsFor: 'accessing' stamp: 'pk 12/14/2005 22:34'!
styleBlock

	^ styleBlock! !

!ShoreTableColumn methodsFor: 'accessing' stamp: 'pk 12/14/2005 22:35'!
styleBlock: aBlock

	styleBlock := aBlock! !

!ShoreTableColumn methodsFor: 'public' stamp: 'pk 12/14/2005 20:08'!
textForRow: row
	^ formatBlock value: (self valueForRow: row)! !

!ShoreTableColumn methodsFor: 'public' stamp: 'pk 12/14/2005 20:08'!
title
	^title! !

!ShoreTableColumn methodsFor: 'accessing' stamp: 'pk 5/17/2006 12:46'!
title: aString
	title := aString! !

!ShoreTableColumn methodsFor: 'public' stamp: 'pk 12/14/2005 20:08'!
totalForRows: aCollection
	^ hasTotal
		ifFalse: ['']
		ifTrue: [formatBlock value: (aCollection detectSum: [:r | self valueForRow: r])]! !

!ShoreTableColumn methodsFor: 'accessing' stamp: 'pk 5/17/2006 12:43'!
valueBlock: aBlock
	valueBlock := aBlock! !

!ShoreTableColumn methodsFor: 'public' stamp: 'pk 12/14/2005 20:08'!
valueForRow: row
	^ valueBlock value: row! !

!ShoreTableColumn methodsFor: 'accessing' stamp: 'pk 6/24/2006 14:03'!
visible

	^ visible! !

!ShoreTableColumn methodsFor: 'accessing' stamp: 'pk 6/24/2006 14:03'!
visible: aBoolean
	visible := aBoolean ! !

Object subclass: #ShoreWebTreeNode
	instanceVariableNames: 'wrappedObject subnodes isExpanded'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Webtree'!

!ShoreWebTreeNode commentStamp: 'TBn 4/28/2004 20:12' prior: 0!
This class represents a tree item for a web tree. It's a simple
wrapper for your objects.

!

!ShoreWebTreeNode class methodsFor: 'instance creation' stamp: 'tbn 7/8/2005 17:24'!
for: anObject

	^self new
		wrappedObject: anObject;
		yourself! !

!ShoreWebTreeNode class methodsFor: 'instance creation' stamp: 'tbn 7/8/2005 17:25'!
for: rootObject childBlock: aOneArgumentBlock 
	"self for: Object childBlock: [:each | each subclasses]"
	| coll node |
	coll := aOneArgumentBlock value: rootObject.
	node := self for: rootObject.
	coll isEmpty
		ifTrue: [^ node].
	coll
		do: [:child | node
				addChild: (self for: child childBlock: aOneArgumentBlock)].
	^ node! !

!ShoreWebTreeNode class methodsFor: 'instance creation' stamp: 'pk 5/6/2006 17:12'!
new

	^ super new initialize! !

!ShoreWebTreeNode class methodsFor: 'examples' stamp: 'tbn 7/8/2005 17:25'!
smalltalkHierarchy
	"Returns an instance of the receiver wrapping the smalltalk class 
	hierarchy using Object as root node"
	^ self
		for: Object
		childBlock: [:each | each subclasses]! !

!ShoreWebTreeNode methodsFor: 'accessing' stamp: 'TBn 4/28/2004 17:27'!
addChild: aChildNode
	self subnodes add: aChildNode! !

!ShoreWebTreeNode methodsFor: 'operations' stamp: 'TBn 4/28/2004 17:29'!
collapse

	self isExpanded: false! !

!ShoreWebTreeNode methodsFor: 'operations' stamp: 'TBn 4/28/2004 17:29'!
expand

	self isExpanded: true! !

!ShoreWebTreeNode methodsFor: 'testing' stamp: 'TBn 4/28/2004 17:30'!
hasSubnodes
	"the first test is necessary to avoid the lazy initialization in the getter"

	^subnodes notNil and: [self subnodes isEmpty not]! !

!ShoreWebTreeNode methodsFor: 'initialize-release' stamp: 'TBn 4/28/2004 17:29'!
initialize
	super initialize.
	self collapse! !

!ShoreWebTreeNode methodsFor: 'testing' stamp: 'TBn 4/28/2004 17:30'!
isCollapsed
	"Returns true if the node is a leaf node or the node is collapsed"

	^self isExpanded not! !

!ShoreWebTreeNode methodsFor: 'testing' stamp: 'TBn 4/28/2004 17:30'!
isExpanded
	"Returns true if the node is expanded. Note that leaf node always return false"

	^isExpanded and: [self hasSubnodes]! !

!ShoreWebTreeNode methodsFor: 'private-accessing' stamp: 'TBn 4/28/2004 17:30'!
isExpanded: aBoolean
	
	isExpanded := aBoolean! !

!ShoreWebTreeNode methodsFor: 'printing' stamp: 'TBn 4/28/2004 17:29'!
printOn: aStream
	"prints the receiver on aStream"

	aStream nextPutAll: '##('.
	self wrappedObject printOn: aStream.
	aStream nextPut: $)! !

!ShoreWebTreeNode methodsFor: 'accessing' stamp: 'TBn 4/28/2004 17:27'!
subnodes

	subnodes isNil ifTrue: [subnodes := OrderedCollection new].
	^subnodes! !

!ShoreWebTreeNode methodsFor: 'accessing' stamp: 'TBn 4/28/2004 17:28'!
wrappedObject

	^wrappedObject! !

!ShoreWebTreeNode methodsFor: 'accessing' stamp: 'TBn 4/28/2004 17:28'!
wrappedObject: anObject

	wrappedObject := anObject! !

Object subclass: #ShoreWidget
	instanceVariableNames: 'renderer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Widgets'!

!ShoreWidget class methodsFor: 'accessing' stamp: 'pk 10/3/2005 14:49'!
in: aHtmlRenderer

	^(self basicNew renderer: aHtmlRenderer) initialize! !

!ShoreWidget methodsFor: 'accessing' stamp: 'pk 12/14/2005 15:11'!
fileProvider

	^ self renderer painter session application fileProvider! !

!ShoreWidget methodsFor: 'accessing' stamp: 'pk 10/3/2005 13:42'!
renderer
	"Answer the value of renderer"

	^ renderer! !

!ShoreWidget methodsFor: 'accessing' stamp: 'pk 5/17/2006 12:46'!
renderer: anObject
	"Set the value of renderer"

	renderer := anObject! !

WARenderCanvas subclass: #ShoreCanvas
	instanceVariableNames: 'ids'
	classVariableNames: 'XHtmlCharacters'
	poolDictionaries: ''
	category: 'ShoreComponents-Kernel'!

!ShoreCanvas class methodsFor: 'as yet unclassified' stamp: 'pk 4/27/2006 07:40'!
encode: anObject

	| charOrString |
	^ String streamContents: [:s |
		anObject displayString do: [:char |
			charOrString := XHtmlCharacters at: char asInteger + 1 ifAbsent: [char asCharacter].
			charOrString isString
				ifTrue: [s nextPutAll: charOrString]
				ifFalse: [s nextPut: charOrString]]]! !

!ShoreCanvas class methodsFor: 'as yet unclassified' stamp: 'pk 5/17/2006 12:47'!
initialize
	"self initialize"
	XHtmlCharacters := Array new: 256.
	
	0 to: 255 do: [:ea | XHtmlCharacters at: ea + 1 put: ea asCharacter].
	
	#($" 'quot' $< 'lt' $& 'amp' $> 'gt') pairsDo:
		[:c :s | XHtmlCharacters at: (c asInteger + 1) put: ('&',s,';') ].

	XHtmlCharacters at: Character cr asciiValue +1 put: '<br/>'
	! !

!ShoreCanvas methodsFor: 'convenience' stamp: 'pk 7/14/2005 08:50'!
advanceKey

	"return new element id"

	^ 'id', self context advanceKey! !

!ShoreCanvas methodsFor: 'convenience' stamp: 'pk 4/30/2006 17:30'!
assignContextMenuTo: elementId

	| script |

	script := 'document.getElementById("{1}").oncontextmenu = ShoreContextMenu.current.shoreContextMenuStart;' format: elementId.

	self script: script.
! !

!ShoreCanvas methodsFor: 'convenience' stamp: 'pk 12/11/2005 11:52'!
backgroundImage: path 

	" returns style for background image"

	path ifNil: [ ^ String new ].
	^ 'background-image: url(', path, ')'.! !

!ShoreCanvas methodsFor: 'convenience' stamp: 'pk 12/11/2005 12:35'!
buttons: aBlock
	"Creates shore buttons using the given block"

	self div class: #shoreButtons; with: aBlock ! !

!ShoreCanvas methodsFor: 'documentation support' stamp: 'pk 6/14/2006 10:31'!
documentationRow: row label: label

	self tableRow with: [
		self  tableData 
			class: #shoreDocumentationTableLabel; 
			with: label displayString translated.
		
		self  tableData
			class: #shoreDocumentationTableContent;
			with: row displayString translated. ].! !

!ShoreCanvas methodsFor: 'convenience' stamp: 'pk 4/23/2006 15:29'!
fixDialogSize

	self script: 'ShoreModalDialog.current.fixSize()'.! !

!ShoreCanvas methodsFor: 'convenience' stamp: 'pk 4/22/2006 20:03'!
form

	(self document isKindOf: SUDocument)
		ifTrue: [
			| tag |
			tag := ShoreFormTag new.
			tag id: ShoreComponent newId.
			^ self brush: tag. ].

	(self painter nestedInForm)
		ifFalse: [ 
			| tag |
			tag := ShoreFormTag new.
			tag id: ShoreComponent newId.
			self painter form: tag.
			^ self brush: tag. ]
		ifTrue: [ 
			| tag | 
			tag := ShoreNestedFormTag new.
			tag parentForm: self painter wrappingForm.
			^ self brush: tag. ].! !

!ShoreCanvas methodsFor: 'convenience' stamp: 'pk 10/3/2005 17:34'!
formId

	^ (self callbacks instVarNamed: #owner) formId

	"| currentContext formMethod |

	currentContext := thisContext.
	formMethod := ShoreComponent>>#formOn:with:.

	[ currentContext sender isNil ]	
		 whileFalse: [ 
			currentContext sender method == formMethod
			ifTrue: [ 
				^ currentContext sender receiver formId ].
			currentContext := currentContext sender ].

	^ nil"
! !

!ShoreCanvas methodsFor: 'convenience' stamp: 'pk 7/14/2005 08:55'!
javascript: script

	self attributeAt: #type put: 'text/javascript'.
	self script: script.! !

!ShoreCanvas methodsFor: 'rectangles' stamp: 'pk 6/14/2006 10:31'!
rectangle: rect align: align class: cssClass

	" align: #absolute, #relative, #fixed ..."

	self html: 
	('<div class="{1} style="width: {2}; height: {3}; left: {4}; top: {5}; position: {6};"></div>'
	format: (OrderedCollection new 
		add: cssClass displayString;
		add: rect width displayString, 'px';
		add: rect height displayString, 'px';
		add: rect left displayString, 'px';
		add: rect top displayString, 'px';
		add: align displayString;
		yourself))  .


	! !

!ShoreCanvas methodsFor: 'rectangles' stamp: 'pk 6/14/2006 10:31'!
rectangle: rect align: align color: bgColor borderWidth: borderWidth borderColor: borderColor borderStyle: borderStyle for: aBlock

	" align: #absolute, #relative, #fixed ..."

	self html: 
	('<div style="
	width: {1};
	height: {2};
	left: {3}; 
	top: {4}; 
	background-color: {5}; 	
	border-color: {6};
	position: {7};
	border-width: {8};
	border-style: {9};
	font-size: 8pt;
">'
	format: (OrderedCollection new
		add: rect width displayString, 'px';
		add: rect height displayString, 'px';
		add: rect left displayString, 'px';
		add: rect top displayString, 'px';
		add: (bgColor ifNotNil: [bgColor asHTMLColor displayString] ifNil: ['none']);
		add: borderColor asHTMLColor displayString;
		add: align displayString;
		add: borderWidth displayString, 'px';
		add: borderStyle displayString;
		yourself))  .

	aBlock value.
	
	self html: '</div>'.

	! !

!ShoreCanvas methodsFor: 'rectangles' stamp: 'pk 7/6/2005 08:18'!
rectangle: rect align: align color: bgColor borderWidth: borderWidth borderColor: borderColor for: aBlock

	^ self rectangle: rect align: align color: bgColor borderWidth: borderWidth borderColor: borderColor borderStyle: 'solid' for: aBlock! !

!ShoreCanvas methodsFor: 'rectangles' stamp: 'pk 6/14/2006 10:31'!
rectangle: rect class: cssClass

	" align: #absolute, #relative, #fixed ..."

	self html: 
	('<div class="{1}" style="width: {2}; height: {3}; left: {4}; top: {5};"></div>'
	format: (OrderedCollection new
		add: cssClass displayString;
		add: rect width displayString, 'px';
		add: rect height displayString, 'px';
		add: rect left displayString, 'px';
		add: rect top displayString, 'px';
		yourself))  .


	! !

!ShoreCanvas methodsFor: 'rectangles' stamp: 'pk 6/14/2006 10:32'!
rectangle: rect class: cssClass color: color for: aBlock

	" align: #absolute, #relative, #fixed ..."

	self html: 
	('<div onClick="submit()" class="{1}" style="width: {2}; height: {3}; left: {4}; top: {5}; background-color: {6}">'
	format: (OrderedCollection new
		with: cssClass displayString;
		add: rect width displayString, 'px';
		add: rect height displayString, 'px';
		add: rect left displayString, 'px';
		add: rect top displayString, 'px';
		add: (color ifNotNil: [color asHTMLColor displayString] ifNil: ['none'])
		yourself)) .

	aBlock value.
	
	self html: '</div>'.


	! !

!ShoreCanvas methodsFor: 'rectangles' stamp: 'pk 6/14/2006 10:37'!
rectangle: rect class: cssClass color: color onClick: script1 onMouseOver: script2 onMouseOut: script3 for: aBlock

	" align: #absolute, #relative, #fixed ..."

	self html: 
	('<div onClick="{1}" onMouseOver="{2}" onMouseOut="{3}" class="{4}" style="width: {5}; height: {6}; left: {7}; top: {8}; background-color: {9}">'
	format: (OrderedCollection new
		add: script1 displayString;
		add: script2 displayString;
		add: script3 displayString;
		add: cssClass displayString;
		add: rect width displayString, 'px';
		add: rect height displayString, 'px';
		add: rect left displayString, 'px';
		add: rect top displayString, 'px';
		add: (color isString
			ifTrue: [ color ]
			ifFalse: [color ifNotNil: [color asHTMLColor displayString] ifNil: ['none']]);
		yourself)) .

	aBlock value.
	
	self html: '</div>'.


	! !

!ShoreCanvas methodsFor: 'rectangles' stamp: 'pk 6/14/2006 10:32'!
rectangle: rect class: cssClass for: aBlock

	" align: #absolute, #relative, #fixed ..."

	self html: 
	('<div class="{1}" style="width: {2}; height: {3}; left: {4}; top: {5};">'
	format: (OrderedCollection new
		add: cssClass displayString;
		add: rect width displayString, 'px';
		add: rect height displayString, 'px';
		add: rect left displayString, 'px';
		add: rect top displayString, 'px';
		yourself)) .

	aBlock value.
	
	self html: '</div>'.


	! !

!ShoreCanvas methodsFor: 'convenience' stamp: 'pk 6/14/2006 10:32'!
registerOnResizeHandlerFor: elementId

	| script |

	script := 'shoreAddOnResizeElement(document.getElementById("', elementId displayString, '"))'.

	self script: script.
! !

!ShoreCanvas methodsFor: 'round corners' stamp: 'pk 6/14/2006 10:32'!
roundedDivColor: color top: top bottom: bottom with: aBlock
	
	top ifTrue: [
		self div class: #shoreR1; style: 'border-top-color: ', color displayString. 
		self div class: #shoreR2; style: 'border-color: ', color displayString. 
		self div class: #shoreR3; style: 'border-color: ', color displayString.  ].

	self div with: aBlock.

	bottom ifTrue: [
		self div class: #shoreR3; style: 'border-color: ', color displayString. 
		self div class: #shoreR2; style: 'border-color: ', color displayString. 
		self div class: #shoreR1; style: 'border-color: ', color displayString.  ]

! !

!ShoreCanvas methodsFor: 'tables' stamp: 'pk 6/14/2006 10:32'!
rowLayout: cells

	| cellWidth |
	
	cellWidth := 100 / cells size.

	self attributes width: '100%'.
	self table: [
		self attributeAt: #height put:  '100%'.
		self tableRow: [
			cells do: [:cell | 
				self attributes width: cellWidth displayString, '%'.
				self tableData: cell ] ] ].! !

!ShoreCanvas methodsFor: 'convenience' stamp: 'tbn 7/11/2005 21:32'!
separator
	"Returns a separator"

	self space; text: '|'; space.! !

!ShoreCanvas methodsFor: 'caching' stamp: 'pk 6/29/2006 09:39'!
sessionEntryForDocument: document

	^ ShoreSessionEntry url: (self context urlForDocument: document mimeType: 'image/gif') document: document! !

!ShoreCanvas methodsFor: 'convenience' stamp: 'pk 12/11/2005 14:33'!
tableRowWithLabel: anObject column: aBlock

	self tableRow with: [
		self tableData class: #label; with: anObject.
		self tableData with: aBlock]! !

!ShoreCanvas methodsFor: 'overrides' stamp: 'pk 6/14/2006 10:32'!
text: aString

	self html: aString displayString asXHtml.! !

!ShoreCanvas methodsFor: 'convenience' stamp: 'pk 12/14/2005 09:03'!
urlForAction: actionBlock

	| url |

	url := context actionUrl withParameter: (self callbacks registerActionCallback: actionBlock).
	^ url displayString! !

!ShoreCanvas methodsFor: 'overrides' stamp: 'pk 7/8/2005 18:10'!
urlForLiveRequest: aBlock
	| text response renderer document |
	^ WACurrentSession value actionUrlForContinuation:
		[:req | 
		text := req at: 's' ifAbsent: [].
		response := WAResponse new.
		renderer := self class
						context: self context copy
						callbacks: self callbacks.
		document := WAHtmlStreamDocument new stream: response stream.
		renderer context document: document.
		aBlock value: text value: renderer.
		document close.
		WACurrentSession value returnResponse: response]! !

WASession subclass: #ShoreFileLibrarySession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Kernel'!

ShoreFileLibrarySession class
	instanceVariableNames: 'current'!

!ShoreFileLibrarySession methodsFor: 'as yet unclassified' stamp: 'pk 6/29/2006 09:18'!
documentFor: url

	^ ShoreFileLibrary cache at: url ifAbsent: [].! !

!ShoreFileLibrarySession methodsFor: 'as yet unclassified' stamp: 'pk 6/29/2006 09:19'!
handleRequest: aRequest
	
	| path response document |

	path := aRequest url allButFirst: self application basePath size.

	path := 	(path notEmpty and: [ path ~= '/' ]) 
		ifTrue: [ 
			document := self documentFor: path allButFirst.
			document isNil ifTrue: [ ^ WAResponse notFound: aRequest url ].

			response := WAResponse new contentType: document mimeType.
			response stream: document document contentStream.
			^  response ].

	^ WAResponse notFound: aRequest url.! !

!ShoreFileLibrarySession methodsFor: 'as yet unclassified' stamp: 'pk 6/29/2006 07:57'!
initializeWithApplication: anApplication
	application _ anApplication.
	self initialize.! !

!WASession methodsFor: '*ShoreComponents' stamp: 'tbn 7/8/2005 16:58'!
download: contents mimeType: mimeType filename: fileName
	self respond:
			[:url |
			| response |
			response := WAResponse new.
			response contentType: mimeType.
			response headerAt: 'Expires' put: 'Thu, 01 Jan 2095 12:00:00 GMT'.
			response headerAt: 'content-disposition'
				put: ('attachment ; filename=' , fileName).
			response headerAt: 'Content-length' put: contents size printString.
			response contents nextPutAll: contents.
			response]
! !

!WASession methodsFor: '*ShoreComponents' stamp: 'pk 4/29/2006 22:28'!
onLoadScripts
	^ scripts ifNil: [ OrderedCollection new]! !

!WAIframeTag methodsFor: '*ShoreComponents' stamp: 'pk 6/29/2006 09:25'!
frameBorder: integer

	self attributes at: 'frameBorder' put: integer displayString! !

!WAIframeTag methodsFor: '*ShoreComponents' stamp: 'pk 6/29/2006 09:24'!
scrolling: aBoolean

	self attributes at: 'scrolling' put: (
		aBoolean ifTrue: [ 'yes' ] ifFalse: [ 'no' ]).
! !

WAApplication subclass: #ShoreApplication
	instanceVariableNames: 'fileProvider'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Kernel'!

!ShoreApplication class methodsFor: 'as yet unclassified' stamp: 'pk 4/22/2006 11:18'!
appName

	^ self name! !

!ShoreApplication methodsFor: 'as yet unclassified' stamp: 'pk 5/17/2006 20:47'!
basePath: newPath
	
	| oldPath |

	oldPath := self basePath.

	super basePath: newPath.
	
	self basePath = oldPath
		ifFalse: [ self fileProvider basePathChanged ].! !

!ShoreApplication methodsFor: 'accessing' stamp: 'pk 4/11/2006 13:15'!
fileProvider
	"Answer the value of fileProvider"

	^ fileProvider ifNil: [
		self fileProvider: self standardFileProviderClass new. fileProvider].! !

!ShoreApplication methodsFor: 'accessing' stamp: 'pk 12/14/2005 14:23'!
fileProvider: anObject
	"Set the value of fileProvider"

	fileProvider := anObject.
	anObject application: self.! !

!ShoreApplication methodsFor: 'accessing' stamp: 'pk 12/14/2005 14:15'!
register: aDocument
	
	^ (self urlForRequestHandler:
		(WADocumentHandler
			document: aDocument
			mimeType: aDocument mimeType
			fileName: nil)) displayString.

	! !

!ShoreApplication methodsFor: 'accessing' stamp: 'pk 6/14/2006 10:23'!
standardFileProviderClass

	^ ShoreFileProvider! !

ShoreApplication subclass: #ShoreDemo1Application
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo1'!

!ShoreDemo1Application class methodsFor: 'as yet unclassified' stamp: 'pk 4/22/2006 11:19'!
appName

	^ 'ShoreDemo1'! !

ShoreApplication subclass: #ShoreDemo2Application
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo2'!

!ShoreDemo2Application class methodsFor: 'as yet unclassified' stamp: 'pk 4/23/2006 18:36'!
appName

	^ 'ShoreDemo2'! !

ShoreApplication subclass: #ShoreDemo3Application
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo3'!

!ShoreDemo3Application class methodsFor: 'as yet unclassified' stamp: 'pk 4/30/2006 08:03'!
appName

	^ 'ShoreDemo3'! !

!ShoreDemo3Application methodsFor: 'as yet unclassified' stamp: 'pk 5/17/2006 17:00'!
initialize

	super initialize.

	self preferenceAt: #deploymentMode put: true.! !

ShoreApplication subclass: #ShoreDemo4Application
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo4'!

!ShoreDemo4Application class methodsFor: 'as yet unclassified' stamp: 'pk 5/16/2006 16:25'!
appName

	^ 'ShoreDemo4'! !

!ShoreDemo4Application methodsFor: 'as yet unclassified' stamp: 'pk 5/17/2006 17:00'!
initialize

	super initialize.

	self preferenceAt: #deploymentMode put: true.! !

WAScriptLibrary subclass: #ShoreStandardScripts
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Libraries'!

!ShoreStandardScripts class methodsFor: 'as yet unclassified' stamp: 'pk 4/22/2006 10:33'!
updateRoot: anHtmlRoot

	| script |
	
	script := String streamContents: [ :stream |
		self new do: [:ea |  stream nextPutAll: ea ] ].

	anHtmlRoot addScript: script.! !

!ShoreStandardScripts methodsFor: 'accessing' stamp: 'pk 6/29/2006 10:36'!
contextMenu

^ '

var ShoreContextMenu = Class.create();

ShoreContextMenu.prototype = {

	initialize: function() {	
		isMenu 	= false;
		overpopupmenu = false;
	},

	mouseSelect: function(e)
	{
		if( isMenu )
		{
			if( overpopupmenu == false )
			{
				isMenu = false ;
				overpopupmenu = false;
				document.getElementById(''shoreContextMenu'').className = "hidden" ;
				document.getElementById(''shoreContextMenuContent'').innerHTML = "" ;
				return false ;
			}
			return false ;
		}
		return true;
	},

	shoreContextMenuStart: function(event)
	{
		var scipt;

		if ( document.all) { script = event.srcElement.getAttribute(''rel'')}
		else { script = event.target.getAttribute(''rel'')}

		if (!!script) { return true } 

		var arrayPageScroll = getPageScroll();

		document.getElementById(''shoreContextMenu'').style.left = arrayPageScroll[0]+event.clientX+"px";
		document.getElementById(''shoreContextMenu'').style.top = arrayPageScroll[1]+event.clientY+"px";

		document.getElementById(''shoreContextMenu'').className = "shoreControl shoreContextMenu";

		eval(script);

		isMenu = true;
		return false ;
	}
}

function shoreContextMenuStartIE()
{
	return ShoreContextMenu.current.shoreContextMenuStart(event);
}

ShoreContextMenu.current = new ShoreContextMenu();

document.onmousedown 	= ShoreContextMenu.current.mouseSelect;

if ( document.all) 
	{ document.oncontextmenu 	= shoreContextMenuStartIE; }
else 
	{ document.oncontextmenu 	= ShoreContextMenu.current.shoreContextMenuStart; };

'! !

!ShoreStandardScripts methodsFor: 'accessing' stamp: 'pk 4/29/2006 19:53'!
modalDialog

^ '

var ShoreModalDialog = Class.create();

ShoreModalDialog.prototype = {


	initialize: function(cap, w, h) {	
		caption = cap;
		width = w;
		height = h;
	},

	open: function() {		
		var overlay = document.getElementById(''shoreModalDialogOverlay'');
		var dialog = document.getElementById(''shoreModalDialogBox'');	
		var header = document.getElementById(''shoreModalDialogBoxHeader'');
		var content = document.getElementById(''shoreModalDialog'');

		header.innerHTML = caption;
		content.innerHTML = "";

		this.fixSize();

		document.onmousedown 	= null;


		overlay.className = ''shoreModalDialogOverlay'';
		dialog.className = ''shoreModalDialogBox'';
	},

	close: function() {		
		var dialog = document.getElementById(''shoreModalDialogBox'');	
		var overlay = document.getElementById(''shoreModalDialogOverlay'');

		overlay.className = ''hidden'';
		dialog.className = ''hidden'';	

		document.onmousedown 	= ShoreContextMenu.current.mouseSelect;
	},

	fixSize: function() {		
		var overlay = document.getElementById(''shoreModalDialogOverlay'');
		var content = document.getElementById(''shoreModalDialog'');
		var dialog = document.getElementById(''shoreModalDialogBox'');	

		var h = Math.max(content.offsetHeight + 20, height)
		var w = Math.max(content.offsetWidth + 20, width)
	
		var arrayPageSize = getPageSize();
		overlay.style.height = arrayPageSize[1] +"px";

		var arrayPageSize = getPageSize();
		var arrayPageScroll = getPageScroll();
		var lightboxTop = arrayPageScroll[1] + (arrayPageSize[3] / 2) - (h/2);

		dialog.style.top = Math.max(lightboxTop, 0) +"px";
		dialog.style.width = w +"px";
		dialog.style.height = h +"px";
		dialog.style.left = Math.max(arrayPageSize[0]/2-(w/2),0) +"px";

		overlay.style.height = (Math.max(arrayPageSize[1], h+30)) + "px";
	}

}




'! !

!ShoreStandardScripts methodsFor: 'accessing' stamp: 'pk 5/1/2006 12:40'!
onResize

	^ '
var shoreOnResizeElements = [];

shoreAddOnResizeElement = function(element) {
	shoreOnResizeElements[shoreOnResizeElements.length] = element; 
};


function shoreResizeHandler(event) {
	for ( var x = 0 ; x < shoreOnResizeElements.length ; x++ ) {
		resizedElement = shoreOnResizeElements[x];
		var script = shoreOnResizeElements[x].getAttribute(''onresize'');
		if (document.all) { 
			script(); }
		else {
			eval(script); }
		resizedElement = null;
	}
	for ( var x = 0 ; x < shoreOnResizeElements.length ; x++ ) {
		resizedElement = shoreOnResizeElements[x];
		var script = shoreOnResizeElements[x].getAttribute(''onresize'');
		if (document.all) { 
			script(); }
		else {
			eval(script); }
		resizedElement = null;
	}
	
}

var lastWidth;
var lastHeight;
var resizedElement;

function shoreResizeHandlerIE() {
	
	if ((document.documentElement.clientWidth == lastWidth) && (document.documentElement.clientHeight == lastHeight)) {
		return }

	lastWidth = document.documentElement.clientWidth;
	lastHeight = document.documentElement.clientHeight;
	shoreResizeHandler(event);
}

if ( document.all) { 
	window.onresize = shoreResizeHandlerIE
} else {
	window.onresize = shoreResizeHandler
}

'! !

!ShoreStandardScripts methodsFor: 'accessing' stamp: 'pk 6/25/2006 09:41'!
tables

^ '

function shoreTableSwapPreview(previewId, switchId, styleClass, updateScript, plus, minus)
{
	var elm = document.getElementById(previewId);
	var switchElm = document.getElementById(switchId);

	if (elm.className=="hidden")  
	{ 
		elm.className=styleClass; 
		switchElm.innerHTML = ("<img src=''"+minus+"''/>"); 
		eval(updateScript) 
	} else { 
		elm.className="hidden"; 
		switchElm.innerHTML =  ("<img src=''"+plus+"''/>"); 
	} 
}

'! !

!ShoreStandardScripts methodsFor: 'accessing' stamp: 'pk 5/16/2006 15:10'!
utils

^ '

getAbsolutePos = function(el) {
	var SL = 0, ST = 0;
	var isDiv = /^div$/i.test(el.tagName);
	if (isDiv && el.scrollLeft)
		SL = el.scrollLeft;
	if (isDiv && el.scrollTop)
		ST = el.scrollTop;
		var r = { x: el.offsetLeft - SL, y: el.offsetTop - ST };
	if (el.offsetParent) {
		var tmp = this.getAbsolutePos(el.offsetParent);
		r.x += tmp.x;
		r.y += tmp.y;
	}
	return r;
};


function getPageScroll(){

	var yScroll;

	if (self.pageYOffset) {
		yScroll = self.pageYOffset;
	} else if (document.documentElement && document.documentElement.scrollTop){	 // Explorer 6 Strict
		yScroll = document.documentElement.scrollTop;
	} else if (document.body) {// all other Explorers
		yScroll = document.body.scrollTop;
	}

	arrayPageScroll = new Array('''',yScroll) 
	return arrayPageScroll;
}


function getPageSize(){
	
	var xScroll, yScroll;
	
	if (window.innerHeight && window.scrollMaxY) {	
		xScroll = document.body.scrollWidth;
		yScroll = window.innerHeight + window.scrollMaxY;
	} else if (document.body.scrollHeight > document.body.offsetHeight){ // all but Explorer Mac
		xScroll = document.body.scrollWidth;
		yScroll = document.body.scrollHeight;
	} else { // Explorer Mac...would also work in Explorer 6 Strict, Mozilla and Safari
		xScroll = document.body.offsetWidth;
		yScroll = document.body.offsetHeight;
	}
	
	var windowWidth, windowHeight;
	if (self.innerHeight) {	// all except Explorer
		windowWidth = self.innerWidth;
		windowHeight = self.innerHeight;
	} else if (document.documentElement && document.documentElement.clientHeight) { // Explorer 6 Strict Mode
		windowWidth = document.documentElement.clientWidth;
		windowHeight = document.documentElement.clientHeight;
	} else if (document.body) { // other Explorers
		windowWidth = document.body.clientWidth;
		windowHeight = document.body.clientHeight;
	}	
	
	// for small pages with total height less then height of the viewport
	if(yScroll < windowHeight){
		pageHeight = windowHeight;
	} else { 
		pageHeight = yScroll;
	}

	// for small pages with total width less then width of the viewport
	if(xScroll < windowWidth){	
		pageWidth = windowWidth;
	} else {
		pageWidth = xScroll;
	}


	arrayPageSize = new Array(pageWidth,pageHeight,windowWidth,windowHeight) 
	return arrayPageSize;
}

'! !

!String methodsFor: '*ShoreComponents' stamp: 'pk 5/6/2006 13:43'!
asXHtml

	^ ((Smalltalk includesKey: #Core) "isVisualWorks"
		ifTrue: [ Smalltalk at: #'Seaside.ShoreCanvas' ]
		ifFalse: [ Smalltalk at: #'ShoreCanvas' ])
		encode: self! !

WAStyleLibrary subclass: #ShoreStandardScheme
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Libraries'!

!ShoreStandardScheme methodsFor: 'as yet unclassified' stamp: 'pk 6/29/2006 11:42'!
component

^ '

.shoreComponent {
	background-color: #ecf1fd;
	border: 1px solid #8e98b5;
}

.shoreComponentImportantPart {
	background-color: #c6d3f7;
	font-weight: bold;
}

.shoreComponentImportantPart a {
	text-decoration: none;
}

.shoreComponentList {
	background-color: #c6d3f7;
	font-weight: bold;
}

.shoreComponentListItem {
	background-color: #c6d3f7;
	font-weight: bold;
}

.shoreComponentListItem:hover {
	background-color: #c6d3f7;
}

.shoreComponenNote {
	color: gray;
}

.shoreComponentButton {
	border: 1px solid #8e98b5;
	background: #8e98b5;
}

.shoreComponentButtonDisabled {
	border: 1px solid gray;
	color: gray;
}

.shoreComponentInput {
	border: 1px solid #8e98b5;
}


'! !

!ShoreStandardScheme methodsFor: 'as yet unclassified' stamp: 'pk 6/29/2006 10:49'!
control

^ '

.shoreControl {
	background-color: #ecf1fd;
	border: 1px solid #3d64bc;
}

.shoreControlItem {
	background-color: white;
}

.shoreControlItem:hover {
	background-color: #3d64bc;	
	color: white;
}

'! !

!ShoreStandardScheme methodsFor: 'as yet unclassified' stamp: 'pk 6/29/2006 10:48'!
form

^ '

.shoreForm {
	border: 2px solid #3d64bc;;
	background-color: #ecf1fd;
}

.shoreForm {
	border: 2px solid #3d64bc;;
	background-color: #ecf1fd;
}

.shoreForm h1 {
	font-size: 120%;
	font-weight: bold;
}

.shoreForm p {
	border: 1px solid #e0e0e7;
	background-color: rgb(247, 249, 254);
}

.shoreFormInput {
	border: 1px solid #e0e0e7;
	background-color: white;
}

.shoreFormButton {
	font-size: 9pt;
	font-weight: bold;
	text-decoration: none;
}

'! !

!ShoreStandardScheme methodsFor: 'as yet unclassified' stamp: 'pk 6/29/2006 11:46'!
general

^ '

h1 {
	font-size: 200%;	
}

'! !

!ShoreStandardScheme methodsFor: 'as yet unclassified' stamp: 'pk 6/29/2006 11:11'!
layout

^ '
.shorePageHeader {
	color: white;
	border: 0px;
	font: 16pt sans-serif;
	font-weight: bold;
	background-color: #3d64bc;
}

.shorePageHeaderSubtitle {
	font: 9pt sans-serif;
	font-weight: bold;;
}

.shorePageFooter {
	border: 1px solid black;
	background-color: #ccccee;
}
'! !

!ShoreStandardScheme methodsFor: 'as yet unclassified' stamp: 'pk 6/29/2006 11:00'!
panel

^ '
.shorePanel {

}

.shorePanelSection {
	background-color: rgb(214, 223, 247);
}

.shorePanelSectionHeader {
	background-color: #555577;
	color: white;
	font-weight: bold;
}

.shorePanelSectionContent {
	background-color: rgb(214, 223, 247);
	color: black;
	font-weight: normal;
}

.shorePanelSectionContent a {
	text-decoration: none;
}

'! !

!ShoreStandardScheme methodsFor: 'as yet unclassified' stamp: 'pk 6/29/2006 10:46'!
scheme

^ '

.shoreForm {
	border: 2px solid #3d64bc;;
	background-color: #ecf1fd;
}

.shoreForm {
	border: 2px solid #3d64bc;;
	background-color: #ecf1fd;
}

.shoreForm h1 {
	font-size: 120%;
	font-weight: bold;
}

.shoreForm p {
	border: 1px solid #e0e0e7;
	background-color: rgb(247, 249, 254);
}

.shoreFormInput {
	border: 1px solid #e0e0e7;
	background-color: white;
}

.shoreFormButton {
	font-size: 9pt;
	font-weight: bold;
	text-decoration: none;
}


.shoreControl {
	background-color: #ecf1fd;
	border: 1px solid #3d64bc;
}

.shoreControlItem {
	background-color: white;
}

.shoreControlItem:hover {
	background-color: #3d64bc;	
	color: white;
}

'! !

WAStyleLibrary subclass: #ShoreStandardStyles
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Libraries'!

!ShoreStandardStyles class methodsFor: 'as yet unclassified' stamp: 'pk 7/15/2005 00:07'!
updateRoot: anHtmlRoot

	| style |
	
	style := String streamContents: [ :stream |
		self new do: [:ea |  stream nextPutAll: ea ] ].

	anHtmlRoot addStyle: style.! !

!ShoreStandardStyles methodsFor: 'accessing' stamp: 'pk 6/29/2006 11:46'!
body

^ '
body {
	margin: 0px; 
	font-family: sans-serif; 
	font-size: 9pt;
}

img{
	border-style: none ;
}


ul { 
	margin-left: 10px;
	padding-left: 10px;
}



'! !

!ShoreStandardStyles methodsFor: 'accessing' stamp: 'pk 6/29/2006 10:39'!
contextMenu

^ '
.shoreContextMenu {
	position: absolute;
	z-index: 80;
}

.shoreContextMenuItem {
	padding: 3px;	
	cursor: pointer;
}


'! !

!ShoreStandardStyles methodsFor: 'accessing' stamp: 'pk 7/15/2005 00:29'!
datePicker

^ '.shoreDatePicker {
		z-index:999; 
		position:absolute; 
		background-color: #e0e0e7; 
		border: 1px solid black;
		width: 220px;	
}

.shoreDatePickerHidden {
		z-index:999; 
		position:absolute; 
		background-color: #e0e0e7; 
		border: 1px solid black;
		width: 220px;
		display: none;
}

.shoreDatePickerCalendarTable {
	width: 100%;	
	height: 150px;	
	background-color: white;
}

.shoreDatePickerCalendarHeader {
	width: 100%;
	font-size: 80%;
	height: 12px;	
}

.shoreDatePickerCalendarTable {
	width: 100%;	
	background-color: white;
}

.shoreDatePickerAnotherMonth {
	background-color: #dedede;
	border: 1px solid #dedede;
	text-align: center;
	cursor: pointer;
}

.shoreDatePickerDayName {
	background-color: black;
	padding: 2px;
	color: white;
	border: 1px solid #dedede;
	text-align: center;
	font-size: 7pt;
}


.shoreDatePickerThisMonth {
	background-color: white;
	border: 1px solid #dedede;
	text-align: center;
	cursor: pointer;
}

.shoreDatePickerToday {
	background-color: yellow;
	text-align: center;
	cursor: pointer;
}

.shoreDatePickerNavigationTable {
	width: 100%;
	background-color: black;
	color: white;
	font-weight: bold;
}

.shoreDatePickerNavigationTable a {
	color: white;
	text-decoration: none;
}

.shoreDatePickerNavigationTableCell {
	width: 25%;
	text-align: center;
}
'! !

!ShoreStandardStyles methodsFor: 'accessing' stamp: 'pk 6/29/2006 10:32'!
dialogs

^ '

.shoreFormDialog {
	margin-left: 10%;
	margin-right: 10%; 
	margin-top: 5px; 
	padding: 5px;
}

.shoreFormDialog h1 {
	margin: 0px;
}

.shoreFormDialog p {
	text-align: center;
	padding: 1px;
	margin: 1px;
	margin-left: 5%;
	margin-right: 5%;
}

.shoreFormDialogTextInput {
	padding: 1px;
	margin: 5px;
	margin-left: 5%;
	margin-right: 5%;
	width: 80%;
}



.shoreButtons {
	text-align: center;
	margin: 3px;
}

.shoreBackButton {
	margin-right: 10px; 
}

.shoreBackButton a {
	text-decoration: none;
}


'! !

!ShoreStandardStyles methodsFor: 'accessing' stamp: 'pk 7/15/2005 00:01'!
documentation

^ '
.shoreDocumentationTable {
	border: 1px solid #8e98b5;
	width: 100%;
}

.shoreDocumentationTableRow {
}

.shoreDocumentationTableLabel {
	background-color: #e0e0e7;
	width: 15em;
	vertical-align: top;
}

.shoreDocumentationTableContent {
	background-color: white;
}
'! !

!ShoreStandardStyles methodsFor: 'accessing' stamp: 'pk 6/29/2006 10:58'!
dynamicPanel

^ '
.shoreDynamicPanel {
	padding: 2px;
	margin: 0px;
}

.shorePanelSectionContainer {
	margin-bottom: 3px;
}

.shoreDynamicPanelSectionHeader {
	padding: 2px;
	padding-left: 5px;
	padding-right: 5px;
	cursor: move;
}

.shorePanelSectionHeader {
	padding: 2px;
	padding-left: 5px;
	padding-right: 5px;
	cursor: pointer;
}

.shorePanelSectionHeader img {
	margin-right: 5px;
	border-width: 0px;	
}

.shoreDynamicPanel li {
	padding: 2px;
	margin: 0px;
	list-style-type: none;
}

.shoreDynamicPanelSectionContent {
	margin-left: 3px;
	margin-right: 3px;
	padding: 2px;
}

.shoreDynamicPanelSectionContent li {
	margin-left: 0px;
	padding-left: 0px;
}


'! !

!ShoreStandardStyles methodsFor: 'accessing' stamp: 'pk 7/3/2005 20:14'!
editors

^ '
.shoreRichEdit {
	border: 1px solid #8e98b5;
}

.shoreRichEditField {
	border: 1px solid #8e98b5;
	margin: 3px;
}

.shoreRichEditEditor {
	width: 100%;
}

.shoreRichEditButtons {

}
'! !

!ShoreStandardStyles methodsFor: 'accessing' stamp: 'pk 6/29/2006 11:09'!
hierarchy

^ '
.shorePageHeader {
	margin: 0px; 
	padding: 0px;
	padding-left: 40px;
	height: 45px;
	background-repeat: no-repeat;
	background-position: 4px;
}

.shorePageHeader img {
	float: left;
	border: 0px;
	padding-right: 50px;
}


'! !

!ShoreStandardStyles methodsFor: 'accessing' stamp: 'pk 6/29/2006 11:07'!
layout 
^ '

ul, ol, dl {
     position: relative;  }

.shoreLayoutHolder {
	position: relative;
	height: 100%;
}

html>body .shoreLayoutHolder {
			height: auto;
			min-height: 100%;
		}

.shoreLayoutLeftColumn {
			float: left;
			width: 150px;

}

.shoreLayoutRightColumn {
			float: right;
			width: 150px;
}


.shoreLayoutMiddleColumn {
			height: expression("0px"); /* workaround pro 3px bug v IE */
			margin: 0 160px; /* do stran je treba margin */
			padding: 10px 0; /* do vysky je treba padding */
}

.shoreLayoutColumn {
	margin: 5px;
}

.shoreLayoutCleaner {
		height: 10px;
		clear: both;

}
		
.shoreLayoutFooter {
		margin: 2px;
		margin-left: 7px;
		margin-right: 7px;
		padding: 2px;
}


	
'

! !

!ShoreStandardStyles methodsFor: 'accessing' stamp: 'pk 6/29/2006 11:57'!
lists

^ '
.shoreBatchedList {
}


.shoreBatchedListTable {
	width: 100%;
}

.shoreBatchedListNavigation {
	padding: 2px;
	text-align: right;
	margin: 0px;
	padding-top: 0px;
}

.shoreBatchedListPages {
	padding: 1px;
	padding-bottom: 0px;
	padding-left: 10px;
	margin: 0px;
}
	
.shoreLiveBatchdeListButton {
	padding: 1px;
	padding-left: 7px;
	padding-right: 7px;
	margin-left: 3px;
	cursor: pointer;
	padding-right: 10px;
}

.shoreLiveBatchdeListButtonDisabled {
	padding: 1px;
	padding-left: 7px;
	padding-right: 7px;
	margin-left: 3px;
}

.shoreBatchedListFilter {
	text-align: right;
	padding: 3px;
	margin: 0px;
}

.shoreBatchedListFilterInput {
	width: 120px;
}

.shoreBatchedListFilterButton {
	width: 60px;
}

.shoreBatchedListNavigation a {
}

.shoreBatchedListSorters {
	font-weight: normal;
	padding-left: 10px;
	float: right;
}

.shoreBatchedListItem{
	padding-left: 5px;
}

.shoreBatchedListItem:hover{
	padding-left: 5px;
}

.shoreBatchedListItemNote {
	padding-right: 5px;
	padding-right: 5px;
	text-align: right;
}

.shoreLisData{
	overflow: scroll;
	height: 140px;
	padding-left: 5px;
}
'! !

!ShoreStandardStyles methodsFor: 'accessing' stamp: 'pk 5/17/2006 12:53'!
modalDialog

^ '
.shoreModalDialogBox{
	position: absolute;
	top: 40px;
	left: 0;
	width: 100%;
	height: 100px;
	z-index: 100;
	background-color: #ecf1fd;
	border: 2px solid #3d64bc;
	}

#shoreModalDialog{
	padding: 10px;
	}

		
.shoreModalDialogOverlay{
	position: absolute;
	top: 0;
	left: 0;
	z-index: 90;
	width: 100%;
	height: 500px;
	background-color: #DDD;
	filter:alpha(opacity=60);
	-moz-opacity: 0.6;
	opacity: 0.6;
	}

#shoreModalDialogBoxHeader{
	background-color: #3d64bc;
	color: white;
	padding: 5px;
	font-weight: bold;
	}

'
! !

!ShoreStandardStyles methodsFor: 'accessing' stamp: 'pk 5/7/2006 19:49'!
roundCorners

^  '
.shoreR1 { 
	padding: 0px;
	border: 0px solid white; 
	border-top: 1px solid black; 
	margin: 0 4px;
}

.shoreR2 { 
	padding: 0px;
	border: 0px solid white; 
	border-top: 1px solid black; 
	margin: 0 2px;
	overflow: hidden; 
}

.shoreR3 { 
	padding: 0px;
	border: 0px solid white; 
	border-top: 1px solid black; 
	margin: 0 1px;
	overflow: hidden; 
}

.shoreRoundCorners { 
	margin: 0px;
	padding: 0px;
}

'.
! !

!ShoreStandardStyles methodsFor: 'accessing' stamp: 'pk 4/29/2006 13:59'!
tabControl

^ '
.shoreTabControl .navigationOptions {
	border-bottom : 1px solid #ccc;
	margin : 0;
	padding-bottom : 19px;
	padding-left : 10px;
}

.shoreTabControl .navigationOptions ul, .shoreTabControl .navigationOptions li	{
	display : inline;
	list-style-type : none;
	margin : 0;
	padding : 0;
}

	
.shoreTabControl .navigationOptions a:link, .shoreTabControl .navigationOptions a:visited	{
	background : #E8EBF0;
	border : 1px solid #ccc;
	color : #666;
	float : left;
	font-size : small;
	font-weight : normal;
	line-height : 14px;
	margin-right : 8px;
	padding : 2px 10px 2px 10px;
	text-decoration : none;
}

.shoreTabControl .navigationOptions a:link.active, .shoreTabControl .navigationOptions a:visited.active	{
	background : #fff;
	border-bottom : 1px solid #fff;
	color : #000;
}

.shoreTabControl .navigationOptions ul a:hover	{
	color : #f00;
}

.shoreTabControl .navigationOptions .option-selected a {
	background : #fff;
	border-bottom : 1px solid #fff;
	color : #000;
}

.shoreTabControl .navigationContent {
	background : #fff;
	border : 1px solid #ccc;
	border-top : none;
	margin : 0px;
	padding : 15px;
	line-height: 1.1;  /* IE6 CSS workaround - http://www.dracos.co.uk/web/css/ie6floatbug/ */
}
'! !

!ShoreStandardStyles methodsFor: 'accessing' stamp: 'pk 6/18/2006 17:51'!
tables

^ '
.shoreTable {
	padding: 0px;
	margin: 5px;
}

.shoreTablePreviewButton {
	cursor: pointer;
	text-align: center;
}


'! !

!ShoreStandardStyles methodsFor: 'accessing' stamp: 'pk 7/6/2005 19:30'!
timetables

^ '
.shoreDayTimetable {
	border: 2px solid black;
	position: relative;

}

.shoreDayTimetableItem {
	position: absolute;
	border-width: 0px;
	font-size: 8pt;
}
'! !

!ShoreStandardStyles methodsFor: 'accessing' stamp: 'pk 4/23/2006 09:09'!
useful

^ '

.renderingTime {
	text-align: right;
	color: #dedede;
}

.bordered {
	padding: 2px;
	border: 1px solid #3d64bc;
}

.hidden{
	display: none;
}

'! !

!ShoreStandardStyles methodsFor: 'accessing' stamp: 'pk 4/23/2006 20:28'!
xpPanel

^ '
.shoreXPPanel {

	padding:10px;

	height: 100%;	
	background-color: rgb(116, 150, 226);

}

.shoreXPPanelSectionsTable {
	padding: 0px;
	margin-top: 8px;
	margin-bottom: 8px;
	width: 100%;
}

.shoreXPPanelTopLeft {
	background-color: rgb(247, 249, 254);
	height: 25px;
	width: 2px;
	cursor: pointer;
	background-position: left top;
	background-repeat: no-repeat;
}

.shoreXPPanelTopRightOpen {
	background-color: rgb(247, 249, 254);
	color: rgb(33, 93, 198);
	cursor: pointer;
	height: 20px;
	font-weight: bold;
	font-size: 11px;
	font-family: verdana,tahoma,arial,sans-serif;
	padding-left: 10px;
	padding-right: 35px;
	background-position: right top;
	background-repeat: no-repeat;
}
.shoreXPPanelTopRightClosed {
	background-color: rgb(247, 249, 254);
	color: rgb(33, 93, 198);
	cursor: pointer;
	height: 20px;
	font-weight: bold;
	font-size: 11px;
	font-family: verdana,tahoma,arial,sans-serif;
	padding-left: 10px;
	padding-right: 35px;
	background-position: right top;
	background-repeat: no-repeat;
}
.shoreXPPanelSection {
	border-left: 1px solid rgb(247, 249, 254);
	border-right: 1px solid rgb(247, 249, 254);
	border-bottom: 1px solid rgb(247, 249, 254);
	background-color: rgb(214, 223, 247);
	font-family: verdana,tahoma,arial,sans-serif;
	color: black;
	cursor: default;
	font-size: 10px;
	padding: 5px;
}

'! !

WADecoration subclass: #ShoreDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Kernel'!

!ShoreDecoration methodsFor: 'renderer' stamp: 'pk 12/14/2005 15:13'!
fileProvider

	^ self session application fileProvider! !

!ShoreDecoration methodsFor: 'renderer' stamp: 'pk 12/11/2005 11:36'!
rendererClass 
	"Returns the receivers default renderer class"

	^ ShoreCanvas! !

ShoreDecoration subclass: #ShoreDynamicPanelDecoration
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Panels'!

!ShoreDynamicPanelDecoration methodsFor: 'accessing' stamp: 'pk 5/16/2006 15:32'!
id
	"Answer the value of id"

	^ id! !

!ShoreDynamicPanelDecoration methodsFor: 'accessing' stamp: 'pk 5/17/2006 12:40'!
id: anObject
	"Set the value of id"

	id := anObject! !

!ShoreDynamicPanelDecoration methodsFor: 'initialization' stamp: 'pk 5/16/2006 15:32'!
initialize

	super initialize.

	id := ShoreComponent newId.
	! !

!ShoreDynamicPanelDecoration methodsFor: 'rendering' stamp: 'pk 6/29/2006 10:59'!
renderContentOn: html

	html roundedDivColor: 'rgb(214, 223, 247)' top: false bottom: true with: [
		html div class: #shorePanelSection; 
			passenger: self;
			class: 'inventory-item';
			script: (html draggable revert: true);
			with: [
				html div class: #shorePanelSectionContent;  
					class: #shoreDynamicPanelSectionContent; 
					with: [ self renderOwnerOn: html  ]]]
		

! !

ShoreDecoration subclass: #ShorePanelDecoration
	instanceVariableNames: 'id open enabled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Panels'!

!ShorePanelDecoration class methodsFor: 'images' stamp: 'pk 5/8/2006 18:37'!
disabled

^ ShoreMIMEDocument type: 'image/png' content:      'R0lGODlhCgALAKEBAAAAAP///////////yH5BAEKAAIALAAAAAAKAAsAAAIUlI8Sy2sAI0xU
NfZkrOlioW3ceBQAOw=='! !

!ShorePanelDecoration class methodsFor: 'images' stamp: 'pk 5/8/2006 18:37'!
enabled

^ ShoreMIMEDocument type: 'image/png' content:     'R0lGODlhCgALAMIFAAAAAAEBAQkJCfT09P39/f///////////yH5BAEKAAcALAAAAAAKAAsA
AAMdeLp81U6BtwpYgtomyLiVEoDUxGySBi4T2gAr1CQAOw=='! !

!ShorePanelDecoration methodsFor: 'accessing' stamp: 'pk 5/8/2006 17:54'!
enabled
	"Answer the value of enabled"

	^ enabled! !

!ShorePanelDecoration methodsFor: 'accessing' stamp: 'pk 5/17/2006 12:42'!
enabled: anObject
	"Set the value of enabled"

	enabled := anObject! !

!ShorePanelDecoration methodsFor: 'accessing' stamp: 'pk 5/7/2006 21:30'!
id
	"Answer the value of id"

	^ id! !

!ShorePanelDecoration methodsFor: 'accessing' stamp: 'pk 5/17/2006 12:40'!
id: anObject
	"Set the value of id"

	id := anObject! !

!ShorePanelDecoration methodsFor: 'initialization' stamp: 'pk 5/8/2006 17:55'!
initialize

	super initialize.
	
	open := true.
	enabled := true.
	id := ShoreComponent newId.
! !

!ShorePanelDecoration methodsFor: 'accessing' stamp: 'pk 5/7/2006 21:22'!
open

	^open! !

!ShorePanelDecoration methodsFor: 'accessing' stamp: 'pk 5/7/2006 21:22'!
open: anObject

	open := anObject! !

!ShorePanelDecoration methodsFor: 'rendering' stamp: 'pk 6/29/2006 10:59'!
renderContentOn: html

	| |

	html roundedDivColor: '#555577' top: true bottom: false with: [
		self renderHeaderOn: html. ].
	
	html div class: #shorePanelSectionContainer; with: [
	html roundedDivColor: 'rgb(214, 223, 247)' top: false bottom: true with: [
		html div class: #shorePanelSection;
			with: [
				html div id: id; class: #shoreDynamicPanelSectionContent; 
					class: #shoreDynamicPanelSectionContent; 
					with: [ self renderOwnerOn: html  ]]]].
			
	open ifFalse: [	
		html script: ('document.getElementById("{1}").style.display = ''none'';' format: (Array with: id)).].! !

!ShorePanelDecoration methodsFor: 'rendering' stamp: 'pk 6/14/2006 09:18'!
renderHeaderOn: html

	| imageUrl headerDiv |

	imageUrl := self enabled
		ifTrue: [ self fileProvider urlFor: 'ShorePanelDecoration/enabled' ]
		ifFalse: [ self fileProvider urlFor: 'ShorePanelDecoration/disabled' ].		

	headerDiv := html div class: #shorePanelSectionHeader.
	enabled ifTrue: [
		headerDiv onClick: (html effect id: id; perform: #toggleBlind);
			onClick: (html updater
				asynchronous: true;
				id: id, 'none';
				callback: [:h | open := open not.]) ].
	headerDiv with: [
			html image url: imageUrl.
			html text: self owner name].! !

ShoreDecoration subclass: #ShoreXPPanelDecoration
	instanceVariableNames: 'sections width open'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Panels'!

!ShoreXPPanelDecoration class methodsFor: 'images' stamp: 'pk 5/6/2006 16:10'!
topLeftImage

^ ShoreMIMEDocument type: 'image/png' content: 'iVBORw0KGgoAAAANSUhEUgAAAAIAAAACCAYAAABytg0kAAAAFUlEQVR4XmMomvTwfxEQAxkP
/oMAAGfnDKifxHoEAAAAAElFTkSuQmCC'! !

!ShoreXPPanelDecoration class methodsFor: 'images' stamp: 'pk 5/6/2006 16:11'!
topRightClosedImage

^ ShoreMIMEDocument type: 'image/png' content:

 'iVBORw0KGgoAAAANSUhEUgAAAFgAAAAZCAYAAAC1ken9AAAEWElEQVR4XuWZ21LiWBSG+8Hm
seZV5hGmarobtRtRUEQQ5CBEUE4BOYOcwzkkHP1nrURKWqHVi6m52LvqMwnlhXz1u7L22l+m
+hNUfQ1VW2NCjKcmI/WF4WSNATNeo0/0RswKytCkywxW6BDtvkmrt0KTUVZoKEuDeneJR6az
RK29RJVpLVEhys0XSo0Fikx9gQKRf1wgx9RMHohs1SRTWUCuzCGX50gzpTlSzySLJonCHHEm
P8c9k5vhbsPDDDEimjW5ZTIzSFtEZJNweoOOm5RJaJukjuAzf/5VNRBf8H8kOJjQxRe8T3DE
kKghnJoilFBJnEkwPiWp2ocFBwjxBW8JljilJPUqrMDhreLkoojj8zxdC0QeP89zsLlKuAi0
EIizdE18wZ8RHE5McOat4edZBt5gCdl8F4/NEZT+FO2uikK5h0CkgsPjJH6c5eEO03NiKr7g
jwi+SU7guKrA6pAhP3Sg6QvsWuv1E+ok3enJwWKTcRHqUpqnJFUTX/A+wdGshstgE1ZKLqeW
Jb63hiMdF948Dk4z8EhDU3JCE1/wLsGh+AhWZw7SfR3L1RofXR1FxY/TFGzuKnyx8XOSxRf8
RrBXUugl9mDU2c368sffBttr+7MnCvmafkh3j5TiLFzhPvz3KknVxBe8LTiW1eEOteDxFzBf
rPYKfS2cBXPaK/UhCU7DEWjDFx3Dv0mx+IJfBLuCLQQj1Z1lYCP2dZo5vfPlGi0qE9x12LxN
qsUj8QXvFBxoGu3XvvVaLq8VvQhnlPh2T6VeOYvjqwbckQGuqUyIL/hNgpu4vC788oL7XQ3e
lIfpjL5Le2wk2Oqp45LqsPiCdwi+krrUosno0YbiIzWYywOnd6zR31BUcHgqw3bVNAT7xBf8
VrD/jl5UJzKi8Qb1wOYL7Olpdw3e1N4Jye0ONfhuyvhGGw6uweIneI/gcEqF3VOlnjaJcm1g
/PtvYKEsl6/8rM/N5PbGMySzbRxRH2xxFGDztcWvwfv6YEmewns7wKH9AcdUKgqVPrT50qix
fN3cc2oHkxl9Zx1J2k7bnBn8Y5Vx5KpRm6aI30XsE3yboTlCfAxXqA2LPUNJTiOWbKJBG48+
JbVPUjmx3YGGSmOECO34js/S+EZyLc6yUX+dNz3x++D9swidZsBToxY7SfKBI4ev1gTt7mjO
ECjBTy0cw/c2ZxbfrSl8PcnCcl6GldozTq9bGoi/k/vdNE2SNZqoqfAZkruweWo4chZxQGPJ
7/ZfOTgv4fCiRr9Dcv0dXEaoe7ibiD+LeH/grhknF9exIXUECs6DHZz6mjihDsHmbRibCe4W
Tuhqv27DGTSTa8jlubD448r3j4winOQUl4sRvNEBdQY9uCihrhuFZr+KMdRx0aDdTZ95b4e4
jquGXPHnwZ84k5Nkbt34OIhnvCrV1gkJH1OyCUqr8Rw3z+iC28dG4gv+3KlyhEQz5iGnZpzB
mYedL/fin8n9j8f2LPhfa1rXqY1u5XUAAAAASUVORK5CYII='! !

!ShoreXPPanelDecoration class methodsFor: 'images' stamp: 'pk 5/6/2006 16:11'!
topRightOpenImage

^ ShoreMIMEDocument type: 'image/png' content:
 'iVBORw0KGgoAAAANSUhEUgAAAFgAAAAZCAYAAAC1ken9AAAEUElEQVR4XuWZ6VLiaBSG+8Lm
quZS5h6marobtRtQUEQQZI+oLIYIyCZ72JOw+845iZTMCK3+mJofX6oeCZQ/5KnXk/Od80Wf
PkObrqEZa0yIsW4x0l4ZTtYYMOM1+kRvxKygDi26zGCFDtHuW7R6KzQZdYWGujSpd5d4YjpL
1NpLVJnWEhWi3Hyl1FjgkakvUCQKTwvkmZrFA6FULXKVBeTKHHJ5jnumNEf2hcyjRbo4R4op
zHHH5Ge43fAwww2RVCyumdwM0hYJ2SJ+v2GKWNYiuk1misgLv/9RMRFf8H8kOJJmyWXxBe8S
nDAlGohndUTTGomziKR0kmp8WHCYEF/wlmCJU0pSL+Mq3IEqjs8f4Tgr0GuRKODnWR5Obwnn
4RbCKZZuiC/4M4Lj6QlOAzX8PM0hEClBKXTx1BxB7etodzUUyz2EExUcOjL4cVqAL07v07r4
gj8iOJaZwH1Zgd0tQ37owJgusOtar59RJ+kefx42p4zzaJfSrJNUQ3zB+wQnFQMXkSbslFxO
LUt87xqOpjgPFHBwkoNfGlqS04b4gncJjqZGsHvykO7qWK7Wb2R++e3PnZI7qoYfJ1k4fVUE
b8YvSRZf8BvBAUmlh9iDWWd3yd2wfT1TyNf0Q7p9ohQr8Mb7CN1pJNUQX/C24BtlCl+0BX+o
iPlitVPuv+83gjntlfqQBN/DHW4jmBwjtEmx+IJfBXsjLUQS1b1yd33G6Z0v12hRmeCuwxlo
Ui0eiS94p+Bw02y/9l27avCKHoQzSny7p1GvrMBx2YAvMcAVlQnxBb9JcBMXV8W9D7h95UGf
0Xdpj80E2/11XFAdFl/wDsGXUpdaNBk9OlB8pAZzeeD0jg36Gx5VHJ7IcF42TcFB8QW/FRy6
pQfVsYxkqkE9sJXQX9Vgrr0TktsdGgjGyvhGBw6uweIneI/geFaDy1+lnjaDcm1g/vtv4LRu
4PfTuZXc3niGjNLGEfXBNncRzmBb/Bq8rw+WZB2B6wEOXQ9wUKkoVvow5kuzxvLr5p5TO5jM
6DtPkaHjtNOTw192GUfeGrVpqvhdxD7B1zmaI6TG8EbbsLlylOR73GSaaNDBo09J7ZNUTmx3
YKDSGCFBJz7H6T2+kVybp2zWX0+sJ34fvH8WMaUZsG7WYg9JPnDn8dWeptMdzRnCJYSohWP4
3ulR8N2exddjBbazMuzUnnF6fdJA/JPcr6ZpkmzQRE1D0JTchdNfw5HnEQc0lvzu+icHZyUc
ntfod0huqIOLBHUPtxPxZxHvD9wNc3NxdTOkjkDFWaSDk2ATx9QhOAMN8zDB3cIxvbqu2vBE
rOSacnkuLP648v2VUYKTnOVyMUIgOaDOoAcvJdQbU2n2q5pDHS8N2n30WeB6iKuUZsoVfx78
iZ2cJHPrxusgnvFqVFsnJHxMySYoreb7lLWji2yvjcQX/LmtcoJEM9aS0zB3cNay8/Ve/J3c
/7i2Z8F/A34b15jGQIh/AAAAAElFTkSuQmCC'! !

!ShoreXPPanelDecoration methodsFor: 'initialization' stamp: 'pk 6/30/2005 13:51'!
initialize

	super initialize.
	
	open := true.! !

!ShoreXPPanelDecoration methodsFor: 'accessing' stamp: 'pk 6/30/2005 13:01'!
open
	^open! !

!ShoreXPPanelDecoration methodsFor: 'accessing' stamp: 'pk 6/30/2005 13:01'!
open: anObject
	open := anObject! !

!ShoreXPPanelDecoration methodsFor: 'rendering' stamp: 'pk 4/23/2006 20:27'!
renderContentOn: html
 
	| topLeftImage topRightOpenImage topRightClosedImage |
	
	topLeftImage := self fileProvider urlFor: 'ShoreXPPanelDecoration/topLeftImage'.
	topRightOpenImage := self fileProvider urlFor: 'ShoreXPPanelDecoration/topRightOpenImage'.
	topRightClosedImage := self fileProvider urlFor: 'ShoreXPPanelDecoration/topRightClosedImage'.

	html table
		layout
		class: #shoreXPPanelSectionsTable;
		with: [
			| id |
			id := html advanceKey.
			html tableRow onClick: '
			if (cells[1].className == ''shoreXPPanelTopRightClosed'') {
				parentNode.rows[1].cells[0].className = ''shoreXPPanelSection'';
				cells[1].style.backgroundImage="url(', topRightOpenImage, ')";
				cells[1].className = ''shoreXPPanelTopRightOpen'';
			} else {
				parentNode.rows[1].cells[0].className = ''hidden'';
				cells[1].style.backgroundImage="url(', topRightClosedImage, ')";
				cells[1].className = ''shoreXPPanelTopRightClosed'';
		}';
			with: [
				html tableData
					style: (html backgroundImage: topLeftImage);
					class: #shoreXPPanelTopLeft;
					with: [html space].
				html tableData
					class: (self open
						ifTrue: [ #shoreXPPanelTopRightOpen ]
						ifFalse: [ #shoreXPPanelTopRightClosed ]);
					style: (self open
						ifTrue: [ html backgroundImage: topRightOpenImage ]
						ifFalse: [ html backgroundImage: topRightClosedImage ]);
					with: self owner name
			].
			html tableRow
				id: id;
				with: [
					html tableData
						colSpan: 2;
						class: (self open
							ifTrue: [ #shoreXPPanelSection ]
							ifFalse: [ #hidden ]);
						with: [
							self renderOwnerOn: html ]]] 

! !

WADecoration subclass: #ShoreRenderingTimeDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Useful'!

WAFormTag subclass: #ShoreFormTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Kernel'!

!ShoreFormTag methodsFor: 'as yet unclassified' stamp: 'pk 1/3/2006 19:27'!
after

	canvas context actionUrl parameters keysAndValuesDo:
		[:k :v |
		canvas hiddenInput name: k; value: v.
		canvas text: ' ']! !

!ShoreFormTag methodsFor: 'as yet unclassified' stamp: 'pk 5/17/2006 12:41'!
with: aBlock

	| oldStream newStream |
	
	(self document isKindOf: WAPrettyPrintedDocument)
		ifTrue: [ ^ super with: aBlock].
	
	oldStream := self document stream.
	newStream := oldStream class with: String new.
	self document stream: newStream. 

	canvas nest:  [
		self before.
		aBlock renderOn: canvas.].

	self document stream: oldStream.
	self document openTag: self tag attributes: attributes.
	oldStream nextPutAll: newStream reset contents.
	isClosed := true.

	self after.
	self document closeTag: self tag.

! !

!WATagBrush methodsFor: '*ShoreComponents' stamp: 'pk 4/23/2006 15:30'!
closeDialog

	self onClick: 'ShoreModalDialog.current.close()'.! !

!WATagBrush methodsFor: '*ShoreComponents' stamp: 'pk 4/22/2006 19:47'!
confirm: aString andDo: aBlock

	self
		showDialog: [:h | 

			h fixDialogSize.
			h paragraph: aString.
			h buttons: [ 
				| url |
				url := h urlForAction: aBlock.
				h button text: 'Yes' translated; onClick: 				('window.location.href = "{1}"'  format: (Array with: url)).
				h space.
				h button closeDialog; text: 'No' translated] ]
		caption: 'Confirmation' translated
		width: 320
		height: 100! !

!WATagBrush methodsFor: '*ShoreComponents' stamp: 'pk 6/14/2006 09:26'!
contextMenu: aMenuSpec

	self attributeAt: #rel put: (canvas updater id: #shoreContextMenuContent; 
		callback: [:h | 
			aMenuSpec do: [:item |
				self renderContextMenuItem: item key action: item value on: h ] ])! !

!WATagBrush methodsFor: '*ShoreComponents' stamp: 'pk 4/22/2006 21:02'!
getString: initialValue message: aMessage andDo: aBlock

	| valueHolder |

	valueHolder := ValueHolder new contents: initialValue.

	self	showDialog: [:h | 
		h form: [
			h fixDialogSize.
			h paragraph: [
				h text: aMessage. 
				h break.
				h textInput 
					class: #shoreFormDialogTextInput;
					on: #contents of: valueHolder.
				h buttons: [
					h submitButton callback: [ aBlock value: valueHolder  contents]; text: 'OK' translated.	
					h space.
					h button closeDialog; text: 'Cancel' translated] ] ] ] 
	caption: 'Input' translated
	width: 350
	height: 0! !

!WATagBrush methodsFor: '*ShoreComponents' stamp: 'pk 4/22/2006 19:47'!
inform: aString

	self
		showDialog: [:h | 
			h fixDialogSize.
			h paragraph: aString.
			h buttons: [ h button closeDialog; text: 'OK' translated] ]
		caption: 'Information' translated
		width: 320
		height: 100! !

!WATagBrush methodsFor: '*ShoreComponents' stamp: 'pk 4/29/2006 19:34'!
onClickAction: aBlock

	self onClick: ('window.location.href = "{1}"' format: (Array with: (canvas urlForAction: aBlock)))! !

!WATagBrush methodsFor: '*ShoreComponents' stamp: 'pk 6/29/2006 10:38'!
renderContextMenuItem: aName action: aBlock on: html

	html div class: #shoreControlItem; class: #shoreContextMenuItem;
		onClickAction: aBlock;
		onMouseOver: 'overpopupmenu=true';
		onMouseOut: 'overpopupmenu=false';
		with: aName.
							! !

!WATagBrush methodsFor: '*ShoreComponents' stamp: 'pk 4/22/2006 18:04'!
showDialog: renderBlock caption: caption 

	self showDialog: renderBlock caption: caption width: 320 height: 150

! !

!WATagBrush methodsFor: '*ShoreComponents' stamp: 'pk 6/14/2006 09:26'!
showDialog: renderBlock caption: caption width: width height: height

	self onClick: ('ShoreModalDialog.current =  new ShoreModalDialog("{1}", {2}, {3}); ShoreModalDialog.current.open();' format: (Array with: (caption value copyReplaceAll: '"' with: '/"') asXHtml with: width with: height)).

	self onClick: (canvas updater
		id: #shoreModalDialog;
		evalScripts: true;
		callback: renderBlock).
		
! !
ShoreDemo1ContextMenu initialize!
ShoreDemo1DynamicFileDownload initialize!
ShoreDemo1Introduction initialize!
ShoreDemo1ListsDemo initialize!
ShoreDemo1NestedFormsDemo initialize!
ShoreDemo1RichEditDemo initialize!
ShoreDemo1StandardDialogsDemo initialize!
ShoreDemo1TabControlDemo initialize!
ShoreDemo1TableDemo initialize!
ShoreDemo1TableDemo2 initialize!
ShoreDemo1TableDemo3 initialize!
ShoreDemo1TableDemo4 initialize!
ShoreDemo1TableDemo5 initialize!
ShoreDemo1WebTree initialize!
ShoreDemo1 initialize!
ShoreDemo2 initialize!
ShoreDemo4 initialize!
ShoreDemo3 initialize!
ShoreFileLibrary initialize!
ShoreCanvas initialize!
